package de.bsvrz.buv.plugin.anlagendarstellung.dobj.editparts;

import java.util.List;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.gef.GraphicalEditPart;

import de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeQuerschnittModelTypAbstract;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.AnzeigeQuerschnittFigure;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.AnzeigeQuerschnittLinksFigure;
import de.bsvrz.buv.plugin.anlagendarstellung.figures.AnzeigeQuerschnittRechtsFigure;
import de.bsvrz.buv.plugin.anlagendarstellung.model.AnzeigeQuerschnittTyp;
import de.bsvrz.buv.plugin.darstellung.model.Darstellung;
import de.bsvrz.buv.plugin.dobj.internal.DarstellungExtensionPoint;
import de.bsvrz.buv.plugin.dobj.model.ConfiguratedDoTyp;
import de.bsvrz.buv.plugin.dobj.model.DoTyp;
import de.bsvrz.dav.daf.main.ResultData;

/**
 * EditPart fr AQ A81, Typ 2.
 * 
 * @author HofmannJ
 * 
 */
public class AnzeigeQuerschnittA81Typ2EditPart extends DoMitVerbLinieEditPart
{

  protected AnzeigeQuerschnittLinksFigure _contentPane = null;

  /**
   * Breite des ContentPane.
   */
  private static final int WIDTH_CONTENT_PANE = 225 + ADefs.FRAME_WIDTH_ADD;

  /**
   * Bereite der Darstellung gesamt.
   */
  private static final int WIDTH = WIDTH_CONTENT_PANE + 30;

  private static final int HEIGHT_CONTENT_PANE = 86 + ADefs.FRAME_HEIGHT_ADD;

  private static final int ANZAHL = 2;

  private static final String IMG_PATH_NORMAL = "icons/aq/a81/typ2/a81_aq_typ2_bg_225x86.png";

  private static final String IMG_PATH_GEDREHT = "icons/aq/a81/typ2/a81_aq_typ2_bg_225x86_G180.png";
  
  /**
   * Legt fest ob der Programmzustand dargestellt werden soll.
   */
  private static final boolean SHOW_PROGRAMMZUSTAND = false;

  /**
   * Legt fest ob die Helligkeit des AQs dargestellt werden soll.
   */
  private static final boolean SHOW_HELLIGKEIT = false;


  @Override
  public IFigure getContentPane()
  {
    return _contentPane;
  }

  @Override
  protected List getModelChildren()
  {
    if (getCastedModel().getKomponenten() != null && getCastedModel().getKomponenten().size() > 0)
    {
      return getCastedModel().getKomponenten();
    }
    else
    {
      ConfiguratedDoTyp doTyp1 = DarstellungExtensionPoint.getDoTyp("AnzeigeTypAEditPart");
      ConfiguratedDoTyp doTyp2 = DarstellungExtensionPoint.getDoTyp("AnzeigeTypBEditPart");
      ConfiguratedDoTyp doTyp3 = DarstellungExtensionPoint.getDoTyp("AnzeigeTypCEditPart");
      ConfiguratedDoTyp doTyp4 = DarstellungExtensionPoint.getDoTyp("AnzeigeTypBlinkerEditPart");

      Darstellung darstellung = (Darstellung)getViewer().getProperty(Darstellung.class.toString());
      EList<DoTyp> doTypen = darstellung.getDoTypen();

      boolean vorhanden1 = false;
      boolean vorhanden2 = false;
      boolean vorhanden3 = false;
      boolean vorhanden4 = false;

      for (DoTyp typ : doTypen)
      {
        if (typ instanceof ConfiguratedDoTyp)
        {
          ConfiguratedDoTyp co = (ConfiguratedDoTyp)typ;
          if (co.getId().equals(doTyp1.getId()))
          {
            vorhanden1 = true;
            doTyp1 = co;
          }
          if (co.getId().equals(doTyp2.getId()))
          {
            vorhanden2 = true;
            doTyp2 = co;
          }
          if (co.getId().equals(doTyp3.getId()))
          {
            vorhanden3 = true;
            doTyp3 = co;
          }
          if (co.getId().equals(doTyp4.getId()))
          {
            vorhanden4 = true;
            doTyp4 = co;
          }
        }
      }

      int x = 1;
      int yA = 37 + ADefs.TEXT_Y_ZEILEN_OFFSET;
      int yB = 19 + ADefs.TEXT_Y_ZEILEN_OFFSET;
      int yC = 53 + ADefs.TEXT_Y_ZEILEN_OFFSET;
      int yBlinker = 0 + ADefs.TEXT_Y_ZEILEN_OFFSET;

      for (int i = 0; i < ANZAHL; i++)
      {
        // A
        AnzeigeModelTypAbstract a1 = (AnzeigeModelTypAbstract)doTyp1.createModel();
        a1.setLocation(new Point(x, yA));
        getCastedModel().getKomponenten().add(a1);
        x = x + ADefs.WIDTH_A + 1;

        // Blinker
        AnzeigeModelTypAbstract bl1 = (AnzeigeModelTypAbstract)doTyp4.createModel();
        bl1.setLocation(new Point(x + 12, yBlinker));
        getCastedModel().getKomponenten().add(bl1);

        // B
        AnzeigeModelTypAbstract b1 = (AnzeigeModelTypAbstract)doTyp2.createModel();
        b1.setLocation(new Point(x, yB));
        getCastedModel().getKomponenten().add(b1);

        // C
        AnzeigeModelTypAbstract c1 = (AnzeigeModelTypAbstract)doTyp3.createModel();
        c1.setLocation(new Point(x, yC));
        getCastedModel().getKomponenten().add(c1);
        x = x + ADefs.WIDTH_B_C + 1;
      }

      // Letztes A
      AnzeigeModelTypAbstract a2 = (AnzeigeModelTypAbstract)doTyp1.createModel();
      a2.setLocation(new Point(x, yA));
      getCastedModel().getKomponenten().add(a2);

      // Blinker Rechts ber statischem Schild
      AnzeigeModelTypAbstract blRechts = (AnzeigeModelTypAbstract)doTyp4.createModel();
      blRechts.setLocation(new Point(WIDTH_CONTENT_PANE - 1 - 17 - 8 - ADefs.FRAME_WIDTH_ADD, yA - 17 - 1));
      getCastedModel().getKomponenten().add(blRechts);

      if (!vorhanden1)
      {
        doTypen.add(doTyp1);
      }
      if (!vorhanden2)
      {
        doTypen.add(doTyp2);
      }
      if (!vorhanden3)
      {
        doTypen.add(doTyp3);
      }
      if (!vorhanden4)
      {
        doTypen.add(doTyp4);
      }

      return getCastedModel().getKomponenten();
    }
  }

  @Override
  protected AnzeigeQuerschnittFigure createFigure()
  {
    AnzeigeQuerschnittRechtsFigure rechts = null;
    AnzeigeQuerschnittFigure result = null;

    // _contentPane = new AnzeigeQuerschnittLinksFigure(
    // AnzeigeQuerschnittTyp.WVZ_LEH_A1_TYP_1, 0);
    _contentPane = new AnzeigeQuerschnittLinksFigure(AnzeigeQuerschnittTyp.WVZ_A8_Typ1, 0);
    _contentPane.setSize(WIDTH_CONTENT_PANE, HEIGHT_CONTENT_PANE);
    rechts = new AnzeigeQuerschnittRechtsFigure(getCastedModel().getKontext());
    rechts.setSize(35, 73);
    
    /*
     * Programmzustand bei Bedarf ausblenden.
     */
    if (rechts.getLabelProgramm() != null)
    {
      rechts.getLabelProgramm().setVisible(SHOW_PROGRAMMZUSTAND);
    }

    /*
     * Helligkeit bei Bedarf ausblenden.
     */
    if (rechts.getLabelHelligkeit() != null)
    {
      rechts.getLabelHelligkeit().setVisible(SHOW_HELLIGKEIT);
    }

    // /*
    // * Listener zur CheckBox Handschaltung hinzufgen.
    // */
    // addListenerToCheckBoxHandschaltungen(rechts.getCheckBoxHandschaltung());

    result = new AnzeigeQuerschnittFigure(_contentPane, rechts);
    result.setSize(WIDTH, HEIGHT_CONTENT_PANE);
    result.switchLinksRechts(getCastedModel().getFahrtrichtung());

    String text = getCastedModel().getBezeichnung();
    if (text != null)
    {
      result.setExtraText(text);
    }

    addToolTipListener(result);

    int fahrtrichtung = getCastedModel().getFahrtrichtung();
    if (fahrtrichtung == 0)
    {
      positioniereText(true);
    }
    else
    {
      positioniereText(false);
    }

    /*
     * Uhrzeit im Kontext Handschaltung ausblenden.
     */
    if (getCastedModel().getKontext() == ADefs.KONTEXT_HANDSCHALTUNG)
    {
      if ((_contentPane != null) && (_contentPane.getLabelZeit() != null))
      {
        _contentPane.getLabelZeit().setVisible(false);
      }
    }
    
    if (true)
    {
      /*
       * Border Festlegen
       */
      LineBorder lineBorder = new LineBorder(ColorConstants.orange, 2);
      _contentPane.setBorderChangeable(false);
      _contentPane.setBorder(lineBorder);
    }

    return result;
  }

  @Override
  public void notifyChanged(Notification notification)
  {
    super.notifyChanged(notification);
    if (AnlagendarstellungPackage.Literals.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__BEZEICHNUNG.equals(notification
        .getFeature()))
    {

      ((AnzeigeQuerschnittFigure)getFigure()).setExtraText(notification.getNewStringValue());
      getFigure().repaint();

    }
    else if (AnlagendarstellungPackage.Literals.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KONTEXT.equals(notification
        .getFeature()))
    {
    }
    else if (AnlagendarstellungPackage.Literals.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__FAHRTRICHTUNG
        .equals(notification.getFeature()))
    {

      int fr = notification.getNewIntValue();

      AnzeigeQuerschnittFigure figure = (AnzeigeQuerschnittFigure)getFigure();
      figure.switchLinksRechts(fr);

      EList<AnzeigeModelTypAbstract> anzeigen = getCastedModel().getKomponenten();

      if (getCastedModel().getFahrtrichtung() != 1)
      {
        /*
         * NORD
         */
        int x = 1;
        int yA = 37 + ADefs.TEXT_Y_ZEILEN_OFFSET;
        int yB = 19 + ADefs.TEXT_Y_ZEILEN_OFFSET;
        int yC = 53 + ADefs.TEXT_Y_ZEILEN_OFFSET;
        int yBlinker = 0 + ADefs.TEXT_Y_ZEILEN_OFFSET;

        int idx = 0;
        for (int i = 0; i < ANZAHL; i++)
        {

          // A
          anzeigen.get(idx).setLocation(new Point(x, yA));
          x = x + ADefs.WIDTH_A + 1;
          idx++;

          // Blinker
          anzeigen.get(idx).setLocation(new Point(x + 12, yBlinker));
          idx++;

          // B
          anzeigen.get(idx).setLocation(new Point(x, yB));
          idx++;

          // C
          anzeigen.get(idx).setLocation(new Point(x, yC));
          x = x + ADefs.WIDTH_B_C + 1;
          idx++;
        }

        // Letztes A
        anzeigen.get(idx).setLocation(new Point(x, yA));
        idx++;

        // Blinker rechts bner statischem Zeichen
        // blRechts.setLocation(new Point(WIDTH_CONTENT_PANE - 1 - 17, 52));
        anzeigen.get(idx).setLocation(new Point(WIDTH_CONTENT_PANE - 1 - 17 - 8 - ADefs.FRAME_WIDTH_ADD, yA - 17 - 1));

        positioniereText(true);
      }
      else
      {
        /*
         * SD
         */
        int x = WIDTH_CONTENT_PANE - 5 - ADefs.WIDTH_A;

        // Statisches Zeichen beachten:

        int yA = 1;
        int yB = 1 + 17 + 1;
        int yC = 1;
        int yBlinker = 1 + 17 + 1 + 33 + 1;

        int idx = 0;
        for (int i = 0; i < ANZAHL; i++)
        {

          // A
          anzeigen.get(idx).setLocation(new Point(x, yA));
          x = x - ADefs.WIDTH_B_C - 1;
          idx++;

          // Blinker
          anzeigen.get(idx).setLocation(new Point(x + 12, yBlinker));
          idx++;

          // B
          anzeigen.get(idx).setLocation(new Point(x, yB));
          idx++;

          // C
          anzeigen.get(idx).setLocation(new Point(x, yC));
          x = x - ADefs.WIDTH_A - 1;
          idx++;
        }

        // Letztes A
        anzeigen.get(idx).setLocation(new Point(x, yA));
        idx++;

        // Blinker ber statischem Zeichen
        anzeigen.get(idx).setLocation(new Point(0 + 1 + 8, yA + 33 + 1));

        positioniereText(false);
      }
    }
    else if (AnlagendarstellungPackage.Literals.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DATA_UPDATE.equals(notification
        .getFeature()))
    {
      ResultData result = (ResultData)notification.getNewValue();
      dataUpdateAnzeigeQuerschnittModelTypAbstract(result, getCastedModel());
    }
    else if (AnlagendarstellungPackage.Literals.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DARSTELLUNG_UPDATE
        .equals(notification.getFeature()))
    {
      String s = (String)notification.getNewValue();
      getFigure().setToolTip(new Label(s));
    }
  }

  private void positioniereText(boolean inRichtung)
  {
    EditPartHelper.positioniereText(inRichtung, true, _contentPane, WIDTH_CONTENT_PANE, HEIGHT_CONTENT_PANE,
        IMG_PATH_NORMAL, IMG_PATH_GEDREHT);
  }

  /**
   * We don't need to explicitly handle refresh visuals because the times when this needs to be done it is handled by
   * the table e.g. handleNameChange()
   */
  protected void refreshVisuals()
  {
    Point pos = getModel().getLocation();
    Dimension dim = getFigure().getSize();

    Rectangle constraint = new Rectangle(pos, dim);

    if (constraint != null)
      ((GraphicalEditPart)getParent()).setLayoutConstraint(this, getFigure(), constraint);
    else
    {
      ((GraphicalEditPart)getParent()).setLayoutConstraint(this, getFigure(), new Rectangle(pos.x, pos.y, -1, -1));
    }
  }

  /**
   * @return
   */
  private AnzeigeQuerschnittModelTypAbstract getCastedModel()
  {
    AnzeigeQuerschnittModelTypAbstract model = null;
    if (getModel() instanceof AnzeigeQuerschnittModelTypAbstract)
    {
      model = (AnzeigeQuerschnittModelTypAbstract)getModel();
    }
    return model;
  }

}
