package de.bsvrz.buv.plugin.anlagendarstellung.figures;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.AbstractConnectionAnchor;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.draw2d.geometry.PrecisionPoint;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gef.commands.CommandStack;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;

import com.bitctrl.lib.eclipse.emf.gef.commands.SetCommand;

import de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage;
import de.bsvrz.buv.plugin.anlagendarstellung.PickerVertical;

/**
 * Diese Klasse liefert die Figure fr den Picker. Fr das Draggen der
 * Pfeilspitzen wird der {@link DndHelper} verwendet.
 * 
 * @author Swarco Traffic Systems GmbH
 * 
 */
public class FigurePickerParent extends Figure
		implements
			PropertyChangeListener
{
	public static final int TRIANGLE_HEIGHT = 4;
	public static final int TRIANGLE_WIDTH = 5;
	public static final int BORDER_WIDTH = 0;

	/**
	 * Breite der Verbindungslinie zwischen den Pfeilen.
	 */
	public static final int LINE_WIDTH = 1;
	private Color _color = ColorConstants.black;
//	private TriangleFigureTop _triTop;
//	private TriangleFigureBot _triBot;
//	private PathFigureBlanko _pathFigure;
//	private PolylineConnection _linie;

	/**
	 * Hier steht ausnahmsweie in der grafischen Figure das Modell zur Verfgung.
	 * Es wird Die Y-Position der oberen Pfeilspitze sowie die Distanz zur unteren
	 * Pfeilspitze gesichert, wenn diese ber den {@link DndHelper} gendert
	 * werden.
	 */
	private PickerVertical _model;

	private CommandStack _commandStack;

	/**
	 * Liste mit den Positionen der darzustellenden Ticks.
	 */
	public List<Integer> _listOfTicks = null;

	/**
	 * Flag legt fest ob die Ticks gezeichnet werden sollen oder nicht.
	 */
	private boolean _paintTicks = true;
  private RGB _farbeHintergrund = ColorConstants.lightGray.getRGB();
  private int _transparenz = 255;

	public FigurePickerParent()
	{
		super();

		if (BORDER_WIDTH > 0)
		{
			this.setBorder(new LineBorder(ColorConstants.red, BORDER_WIDTH));
		}

		init();
	}

	private void init()
	{
		this.setLayoutManager(new FreeformLayout());
		// this.setBackgroundColor(ColorConstants.lightBlue);
		this.setOpaque(true);

//		_triTop = new TriangleFigureTop();
//		_triTop.setBounds(new Rectangle(0, 0, TRIANGLE_WIDTH, TRIANGLE_HEIGHT));
//		_triTop.setVisible(false);
//		
//		this.add(_triTop);
//
//		_triBot = new TriangleFigureBot();
//		_triBot.setBounds(new Rectangle(0, 50, TRIANGLE_WIDTH, TRIANGLE_HEIGHT));
//		_triBot.setVisible(false);
//		this.add(_triBot);

//		reInitPathFigure();

//		/*
//		 * Drag'n'Drop aktivieren.
//		 */
//		DndHelper dndHelperTop = new DndHelper(_triTop);
//		dndHelperTop.setMoveOnlyAlongYAxis(true);
//		dndHelperTop.setOtherFigure(_triBot, ECollisionLocation.bottom);
//		dndHelperTop._pcs.addPropertyChangeListener(this);
//
//		DndHelper dndHelperBottom = new DndHelper(_triBot);
//		dndHelperBottom.setMoveOnlyAlongYAxis(true);
//		dndHelperBottom.setOtherFigure(_triTop, ECollisionLocation.top);
//		dndHelperBottom.addListener(this);
	}

	private void reInitPathFigure()
	{
//		_linie = new PolylineConnection();
//		_linie.setForegroundColor(getColor());
//		// _linie.setSourceAnchor(new ChopboxAnchor(_triTop));
//		// _linie.setTargetAnchor(new ChopboxAnchor(_triBot));
//		_linie.setSourceAnchor(new TopAnchor(_triTop));
//		_linie.setTargetAnchor(new BottomAnchor(_triBot));		 
//		_linie.setLineWidth(LINE_WIDTH);
//		
//		add(_linie);

		// getLayer(CONNECTION_LAYER).add(linie);
		// this.add(_pathFigure);
	}

//	public PolylineConnection getLinie()
//	{
//		return _linie;
//	}

//	class DecisionFigure extends ActivityFigure
//	{
//		FixedAnchor inAnchor, yesAnchor, noAnchor;
//
//		public DecisionFigure()
//		{
//			inAnchor = new FixedAnchor(this);
//			inAnchor.place = new Point(1, 0);
//			targetAnchors.put("in_dec", inAnchor);
//			noAnchor = new FixedAnchor(this);
//			noAnchor.place = new Point(2, 1);
//			sourceAnchors.put("no", noAnchor);
//			yesAnchor = new FixedAnchor(this);
//			yesAnchor.place = new Point(1, 2);
//			sourceAnchors.put("yes", yesAnchor);
//		}
//
//		public void paintFigure(Graphics g)
//		{
//			// Rectangle r = bounds;
//			// PointList pl = new PointList(4);
//			// pl.addPoint(r.x + r.width / 2, r.y);
//			// pl.addPoint(r.x, r.y + r.height / 2);
//			// pl.addPoint(r.x + r.width / 2, r.y + r.height - 1);
//			// pl.addPoint(r.x + r.width, r.y + r.height / 2);
//			// g.drawPolygon(pl);
//			// g.drawText(message, r.x + r.width / 4 + 5, r.y + 3 * r.height / 8);
//			// g.drawText("N", r.x + 7 * r.width / 8, r.y + 3 * r.height / 8);
//			// g.drawText("Y", r.x + r.width / 2 - 2, r.y + 3 * r.height / 4);
//
//			int heightTriangle = 15;
//
//			Rectangle r = bounds;
//			PointList pl = new PointList(4);
//
//			pl.addPoint(r.x + r.width / 2, r.y + 0);
//			pl.addPoint(r.x + r.width, r.y + heightTriangle);
//			pl.addPoint(r.x + r.width / 2, r.y + heightTriangle);
//			pl.addPoint(r.x + 0, r.y + heightTriangle);
//			g.setForegroundColor(getColor());
//			g.fillPolygon(pl);
//
//			// PointList pl2 = new PointList(4);
//			// pl2.addPoint(r.x + 0, r.y + 0);
//			// pl2.addPoint(r.x + 10, r.y + 0);
//			// pl2.addPoint(r.x + 10, r.y + 10);
//			// pl2.addPoint(r.x + 0, r.y + 10);
//			// g.drawPolygon(pl2);
//
//		}
//	}

//	class TriangleFigureTop extends ActivityFigure
//	{
//		FixedAnchor inAnchor, outAnchor;
//
//		public TriangleFigureTop()
//		{
//			inAnchor = new FixedAnchor(this);
//			inAnchor.place = new Point(1, 0);
//			targetAnchors.put("in_tri_top", inAnchor);
//
//			outAnchor = new FixedAnchor(this);
//			outAnchor.place = new Point(1, 2);
//			sourceAnchors.put("out_tri_top", outAnchor);
//		}
//
//		public void paintFigure(Graphics g)
//		{
//			Rectangle r = bounds;
//
//			PointList pl = new PointList(4);
//			pl.addPoint(r.x + r.width / 2, r.y + 0);
//			pl.addPoint(r.x + r.width, r.y + TRIANGLE_HEIGHT);
//			pl.addPoint(r.x + r.width / 2, r.y + TRIANGLE_HEIGHT);
//			// inAnchor.place = new Point(r.x + r.width / 2, r.y + triangleHeight);
//			// outAnchor.place = new Point(r.x + r.width / 2, r.y + triangleHeight);
//			inAnchor.place = new Point(r.x + r.width / 2, r.height);
//			outAnchor.place = new Point(r.x + r.width / 2, r.height);
//			pl.addPoint(r.x + 0, r.y + TRIANGLE_HEIGHT);
//			g.setBackgroundColor(getColor());
//			g.fillPolygon(pl);
//
//			if (false)
//			{
//				g.setForegroundColor(ColorConstants.red);
//				g.drawPolygon(pl);
//			}
//
//		}
//	}
//
//	class TriangleFigureBot extends ActivityFigure
//	{
//		FixedAnchor inAnchor, outAnchor;
//
//		public TriangleFigureBot()
//		{
//			inAnchor = new FixedAnchor(this);
//			inAnchor.place = new Point(1, 0);
//			targetAnchors.put("in_tri_bot", inAnchor);
//
//			outAnchor = new FixedAnchor(this);
//			outAnchor.place = new Point(1, 2);
//			sourceAnchors.put("out_tri_bot", outAnchor);
//		}
//
//		public void paintFigure(Graphics g)
//		{
//			Rectangle r = bounds;
//
//			PointList pl = new PointList(4);
//
//			pl.addPoint(r.x + 0, r.y + 0);
//			pl.addPoint(r.x + r.width / 2, r.y + 0);
//			pl.addPoint(r.x + r.width, r.y + 0);
//			pl.addPoint(r.x + r.width / 2, r.y + TRIANGLE_HEIGHT);
//
//			inAnchor.place = new Point(r.x + r.width / 2, r.height);
//			outAnchor.place = new Point(r.x + r.width / 2, r.height);
//
//			g.setBackgroundColor(getColor());
//			g.fillPolygon(pl);
//
//			if (false)
//			{
//				g.setForegroundColor(ColorConstants.red);
//				g.drawPolygon(pl);
//			}
//
//		}
//	}

	/**
	 * Figure zum Darstellen der Ticks auf dem Picker.<br>
	 * 
	 * @author Swarco Traffic Systems GmbH
	 * 
	 */
	public class FigureTicks extends Figure
	{
		@Override
		protected void paintFigure(Graphics g)
		{
			super.paintFigure(g);

			PointList pl = new PointList();

			Rectangle r = FigureTicks.this.getBounds();
			pl.addPoint(r.x, r.y);
			pl.addPoint(r.x + r.width, r.y);
			pl.addPoint(r.x + r.width, r.y + r.height);
			pl.addPoint(r.x, r.y + r.height);

			g.setBackgroundColor(ColorConstants.darkGray);
			g.fillPolygon(pl);
		}
	}

	abstract class ActivityFigure extends Figure
	{
		Rectangle r = new Rectangle();

		Hashtable targetAnchors = new Hashtable();

		Hashtable sourceAnchors = new Hashtable();

		String message = new String();

		public void setName(String msg)
		{
			message = msg;
			repaint();
		}

		public ConnectionAnchor ConnectionAnchorAt(Point p)
		{
			ConnectionAnchor closest = null;
			long min = Long.MAX_VALUE;
			Hashtable conn = getSourceConnectionAnchors();
			conn.putAll(getTargetConnectionAnchors());
			Enumeration e = conn.elements();
			while (e.hasMoreElements())
			{
				ConnectionAnchor c = (ConnectionAnchor) e.nextElement();
				Point p2 = c.getLocation(null);
				long d = p.getDistance2(p2);
				if (d < min)
				{
					min = d;
					closest = c;
				}
			}
			return closest;
		}

		public ConnectionAnchor getSourceConnectionAnchor(String name)
		{
			return (ConnectionAnchor) sourceAnchors.get(name);
		}

		public ConnectionAnchor getTargetConnectionAnchor(String name)
		{
			return (ConnectionAnchor) targetAnchors.get(name);
		}

		public String getSourceAnchorName(ConnectionAnchor c)
		{
			Enumeration e = sourceAnchors.keys();
			String name;
			while (e.hasMoreElements())
			{
				name = (String) e.nextElement();
				if (sourceAnchors.get(name).equals(c))
					return name;
			}
			return null;
		}

		public String getTargetAnchorName(ConnectionAnchor c)
		{
			Enumeration e = targetAnchors.keys();
			String name;
			while (e.hasMoreElements())
			{
				name = (String) e.nextElement();
				if (targetAnchors.get(name).equals(c))
					return name;
			}
			return null;
		}

		public ConnectionAnchor getSourceConnectionAnchorAt(Point p)
		{
			ConnectionAnchor closest = null;
			long min = Long.MAX_VALUE;
			Enumeration e = getSourceConnectionAnchors().elements();
			while (e.hasMoreElements())
			{
				ConnectionAnchor c = (ConnectionAnchor) e.nextElement();
				Point p2 = c.getLocation(null);
				long d = p.getDistance2(p2);
				if (d < min)
				{
					min = d;
					closest = c;
				}
			}
			return closest;
		}

		public Hashtable getSourceConnectionAnchors()
		{
			return sourceAnchors;
		}

		public ConnectionAnchor getTargetConnectionAnchorAt(Point p)
		{
			ConnectionAnchor closest = null;
			long min = Long.MAX_VALUE;
			Enumeration e = getTargetConnectionAnchors().elements();
			while (e.hasMoreElements())
			{
				ConnectionAnchor c = (ConnectionAnchor) e.nextElement();
				Point p2 = c.getLocation(null);
				long d = p.getDistance2(p2);
				if (d < min)
				{
					min = d;
					closest = c;
				}
			}
			return closest;
		}

		public Hashtable getTargetConnectionAnchors()
		{
			return targetAnchors;
		}
	}

	class FixedAnchor extends AbstractConnectionAnchor
	{
		Point place;

		public FixedAnchor(IFigure owner)
		{
			super(owner);
		}

		public Point getLocation(Point loc)
		{
			Rectangle r = getOwner().getBounds();
			int x = r.x + place.x * r.width / 2;
			int y = r.y + place.y * r.height / 2;
			Point p = new PrecisionPoint(x, y);
			getOwner().translateToAbsolute(p);

			return p;
		}
	}

//	class PathFigureBlanko extends PolylineConnection
//	{
//		public PathFigureBlanko()
//		{
//			PolylineDecoration polylineDecoration = new PolylineDecoration();
//			polylineDecoration.setTemplate(new PointList(0));
//			setTargetDecoration(polylineDecoration);
//			// setConnectionRouter(new ManhattanConnectionRouter());
//			setLineWidth(5);
//		}
//	}
//
//	private void setYTriTop(int y)
//	{
//		if (_triTop != null)
//		{
//			Rectangle bounds = _triTop.getBounds();
//			bounds.y = y;
//			_triTop.setBounds(bounds);
//			rep();
//		}
//	}
//
//	private void setYTriBot(int y)
//	{
//		if (_triBot != null)
//		{
//			Rectangle bounds = _triBot.getBounds();
//			bounds.y = y;
//			_triBot.setBounds(bounds);
//			rep();
//		}
//	}

//	/**
//	 * Setzt den Picker.
//	 * 
//	 * @param yPosPfeilTop
//	 *          Y-Position des oberen Pfeils relativ zu dieser Figure (beginnend
//	 *          bei 0).
//	 * @param distanceToPfeilBottom
//	 *          Distanz zwischen der Spitze des oberen zur Spitze des unteren
//	 *          Pfeils dieser Figure.
//	 */
//	public void setPickerData(int yPosPfeilTop, int distanceToPfeilBottom)
//	{
//		Rectangle figureBounds = this.getBounds();
//
//		if (_triTop != null)
//		{
//			Rectangle boundsTriTopNeu = new Rectangle(_triTop.getBounds());
//			boundsTriTopNeu.y = figureBounds.y + yPosPfeilTop;
//			_triTop.setBounds(boundsTriTopNeu);
//
//		}
//
//		if (_triBot != null)
//		{
//			Rectangle boundsTriBotNeu = new Rectangle(_triBot.getBounds());
//			boundsTriBotNeu.y = _triTop.getBounds().y + distanceToPfeilBottom
//					- boundsTriBotNeu.height;
//			_triBot.setBounds(boundsTriBotNeu);
//		}
//	}

//	/**
//	 * Liefert die Definition des Pickers.
//	 * 
//	 * @return int[]-Array der Gre 2. Der erste Wert liefert Y-Position des
//	 *         oberen Pfeils relativ zu dieser Figure (beginnend bei 0). Der
//	 *         zweite Wert liefert die Distanz zwischen der Spitze des oberen zur
//	 *         Spitze des unteren Pfeils dieser Figure. Ist einer der Werte
//	 *         <code>-1</code> war eine korrekte Ermittlung nicht mglich.
//	 */
//	public int[] getPickerData()
//	{
//		int yPosPfeilTop = -1;
//		int distanceToPfeilBottom = -1;
//
//		Rectangle figureBounds = this.getBounds();
//
//		if (_triTop != null)
//		{
//			Rectangle boundsTriTop = _triTop.getBounds();
//			yPosPfeilTop = boundsTriTop.y - figureBounds.y;
//
//			if (_triBot != null)
//			{
//				Rectangle boundsTriBot = _triBot.getBounds();
//				distanceToPfeilBottom = boundsTriBot.getBottom().y - boundsTriTop.y;
//			}
//		}
//
//		return new int[]{yPosPfeilTop, distanceToPfeilBottom};
//	}
//
//	public void rep()
//	{
//		if (false)
//		{
//			if (_triBot != null)
//			{
//				/*
//				 * Unteres Dreieck neu Positionieren
//				 */
//				Dimension size = this.getSize();
//
//				System.out.println("Size: " + size.width + "x" + size.height);
//
//				System.out.println("Location before: " + _triBot.getLocation().x + ","
//						+ _triBot.getLocation().y);
//
//				System.out.println("Figure: " + this.getBounds());
//				System.out.println("TRI   : " + _triBot.getBounds());
//
//				Rectangle bounds = this.getBounds();
//
//				Rectangle b = new Rectangle(bounds.x - BORDER_WIDTH, bounds.y
//						+ bounds.height - TRIANGLE_HEIGHT, TRIANGLE_WIDTH, bounds.height);
//				_triBot.setBounds(b);
//
//				System.out.println("Location after:  " + _triBot.getLocation().x + ","
//						+ _triBot.getLocation().y);
//			}
//		}
//
//		// this.repaint();
//		//
//		// _triTop.repaint();
//		// _triBot.repaint();
//		// _pathFigure.repaint();
//		// // reInitPathFigure();
//	}
//	public PathFigureBlanko getPathFigureBlanko()
//	{
//		return _pathFigure;
//	}

	@Override
	public void setSize(int w, int h)
	{
		super.setSize(w, h);
//		rep();
	}

	/**
	 * Liefert die Farbe, in welcher die Pfeilspitzen mit Verbindungslinie
	 * gezeichnet werden sollen.
	 * 
	 * @return Farbe.
	 */
	private Color getColor()
	{
		return _color;
	}
	
	/**
	 * Liefert die Farbe, in welcher die Pfeilspitzen mit Verbindungslinie
	 * gezeichnet werden sollen.
	 * 
	 * @return Farbe.
	 */
	public void setColor(Color color)
	{
	  _color = color;
	  
//	  _linie.setForegroundColor(_color);
	  
	}

//	/**
//	 * Liefert die Distanz zwischen der oberen und der unteren Pfeilspitze.
//	 * 
//	 * @return Distanz oder <code>-1</code> wenn nicht bestimmbar.
//	 */
//	public int getDistanceBereich()
//	{
//		int re = -1;
//
//		if ((_triTop != null) && (_triBot != null))
//		{
//			int yTop = _triTop.getBounds().getTop().y;
//			int yBottom = _triBot.getBounds().getBottom().y;
//
//			if (yTop == yBottom)
//			{
//				re = yTop;
//			} else if (yBottom > yTop)
//			{
//				re = yBottom - yTop;
//			} else if (yTop > yBottom)
//			{
//				re = yTop - yBottom;
//			}
//		}
//
//		return re;
//	}

	/**
	 * Liefert die obere Y-Position dieser Figure zurck.
	 * 
	 * @return
	 */
	public int getStartY()
	{
		return this.getBounds().getTop().y;
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt)
	{
//		if (evt != null)
//		{
//			String propertyName = evt.getPropertyName();
//			if (propertyName.equals(DndHelper.PROP_VERSCHOBEN))
//			{
//				int[] pickerData = getPickerData();
//
//				// TODO Modell aktualisieren, Endlos-Loop prfen & absichern
//				if ((_model != null) && (_commandStack != null))
//				{
//					if ((pickerData != null) && (pickerData.length > 1)
//							&& (pickerData[0] >= 0) && (pickerData[1] >= 0))
//					{
//						/*
//						 * Ohne das SetCommand wird der Editor nicht als Dirty markiert und
//						 * das Speichern ist unmglich!
//						 */
//						// _model.setYPosPickerTop(pickerData[0]);
//						// _model.setDistanz(pickerData[1]);
//
//						/*
//						 * YPosPickerTop via setCommand
//						 */
//						if (_model.getYPosPickerTop() != pickerData[0])
//						{
//							EStructuralFeature feature = AnlagendarstellungPackage.Literals.PICKER_VERTICAL__YPOS_PICKER_TOP;
//							final SetCommand cmd = new SetCommand(_model, feature,
//									pickerData[0]);
//							_commandStack.execute(cmd);
//						}
//
//						/*
//						 * Distanz via setCommand
//						 */
//						if (_model.getDistanz() != pickerData[1])
//						{
//							EStructuralFeature feature = AnlagendarstellungPackage.Literals.PICKER_VERTICAL__DISTANZ;
//							final SetCommand cmd = new SetCommand(_model, feature,
//									pickerData[1]);
//							_commandStack.execute(cmd);
//						}
//
//					}
//				}
//			}
//		}

	}

	/**
	 * Diese Figure muss Position des dargestellten Pickers im Modell sichern
	 * knnen. Dieses {@link PickerVertical}-Modell kann mit dieser Methode
	 * bergeben werden.<br>
	 * Mit Hilfe des CommandStacks wird das setzen der Werte ber SetCommand
	 * durchgefhrt.
	 * 
	 * @param model
	 *          {@link PickerVertical}-Modell fr die Erfassung der Pickerauswahl.
	 * @param commandStack
	 *          CommandStack zum Ausfhren de SetCommand.
	 */
	public void setModelAndStack(PickerVertical model, CommandStack commandStack)
	{
		this._model = model;
		this._commandStack = commandStack;
	}

	@Override
	protected void paintFigure(Graphics g)
	{
		super.paintFigure(g);

		// TICK-Test
		// g.setForegroundColor(ColorConstants.cyan);
		// for (int i = 0; i < 100; i = i + 10)
		// {
		// g.drawLine(bounds.x, bounds.y + i, bounds.x + bounds.width, bounds.y +
		// i);
		// }

		g.setAlpha(_transparenz);
		//if (getBackgroundColor().getRGB().equals(_farbeHintergrund))
		g.setBackgroundColor(new Color(null, _farbeHintergrund));
		g.fillRectangle(bounds);
		
		g.setForegroundColor(ColorConstants.gray);
		if ((_listOfTicks != null) && isPaintTicks())
		{			
		  g.setAlpha(255);
			for (Integer yPosTick : _listOfTicks)
			{
				g.drawLine(bounds.x, bounds.y + yPosTick, bounds.x + bounds.width,
						bounds.y + yPosTick);
				
				
				
			}
		}

	}

	/**
	 * Setzt die Positionen der Ticks und lst die Aktualisierung der Darstellung
	 * aus.
	 * 
	 * @param listOfTicks
	 *          Collection der Ticks.
	 */
	public void setTicks(Collection<Integer> listOfTicks)
	{
		LinkedList<Integer> lTicks = new LinkedList<Integer>();
		if (listOfTicks != null)
		{
			lTicks.addAll(listOfTicks);
		}
		_listOfTicks = lTicks;
		repaint();
	}

	/**
	 * Prft ob die Ticks gezeichnet werden sollen.
	 * 
	 * @return Liefert <code>true</code> wenn die Ticks gezeichnet werden sollen,
	 *         sonst <code>false</code>.
	 */
	public boolean isPaintTicks()
	{
		return _paintTicks;
	}

	/**
	 * Legt fest ob die Ticks gezeichnet werden sollen.
	 * 
	 * @param paintTicks
	 *          Wenn <code>true</code> werden die Ticks gezeichnet, bei
	 *          <code>false</code> nicht.
	 */
	public void setPaintTicks(boolean paintTicks)
	{
		_paintTicks = paintTicks;
		repaint();
	}

  public void setFarbeHintergrund(RGB farbeHintergrund)
  {
    // TODO Auto-generated method stub
//    System.out.println("FigurePickerParent.setFarbeHintergrund(!!!): " + farbeHintergrund);
    
    _farbeHintergrund  = farbeHintergrund;
  }

  public void setTranparenz(int alpha)
  {
    // TODO Auto-generated method stub
    _transparenz  = alpha;
  }
  
  public int getTranparenz()
  {
    // TODO Auto-generated method stub
    return _transparenz;
  }

}
