/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Typklasse fr AQ
 * 
 * @author Pittner
 * 
 */
public class AnzeigeQuerschnittTyp
{

  private static List typen = new ArrayList();

  public static AnzeigeQuerschnittTyp WVZ_A_B_C = new AnzeigeQuerschnittTyp("WVZ-A-B-C");

  public static AnzeigeQuerschnittTyp WVZ_A_B_C_SIMULATION = new AnzeigeQuerschnittTyp("WVZ-A-B-C-SIMULATION");

  public static AnzeigeQuerschnittTyp WVZ_A_B_C_TRICHTER = new AnzeigeQuerschnittTyp("WVZ-A-B-C-TRICHTER");

  public static AnzeigeQuerschnittTyp WVZ_B_C = new AnzeigeQuerschnittTyp("WVZ-B-C");

  public static AnzeigeQuerschnittTyp WVZ_B_C_SIMULATION = new AnzeigeQuerschnittTyp("WVZ-B-C-SIMULATION");

  public static AnzeigeQuerschnittTyp WVZ_B_C_TRICHTER = new AnzeigeQuerschnittTyp("WVZ-B-C-TRICHTER");

  public static AnzeigeQuerschnittTyp WVZ_A_B_C_AUTOMATIK = new AnzeigeQuerschnittTyp("WVZ-B-C-AUTOMATIK");

  public static AnzeigeQuerschnittTyp WVZ_B_C_AUTOMATIK = new AnzeigeQuerschnittTyp("WVZ-B-C-AUTOMATIK");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ1 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-1");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ2 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-2");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ3 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-3");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ4 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-4");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ5 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-5");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ6 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-6");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ7 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-7");

  public static AnzeigeQuerschnittTyp WVZ_B27_Typ8 = new AnzeigeQuerschnittTyp("WVZ-B27-Typ-8");

  public static AnzeigeQuerschnittTyp WVZ_A14_Typ1 = new AnzeigeQuerschnittTyp("WVZ-A14-Typ-1");
  
  public static AnzeigeQuerschnittTyp WVZ_A2_Typ1 = new AnzeigeQuerschnittTyp("WVZ-A2-Typ-1");
  
  public static AnzeigeQuerschnittTyp WVZ_A2_Typ2 = new AnzeigeQuerschnittTyp("WVZ-A2-Typ-2");
  
  public static AnzeigeQuerschnittTyp WVZ_A2_Typ3 = new AnzeigeQuerschnittTyp("WVZ-A2-Typ-3");
  
  public static AnzeigeQuerschnittTyp WVZ_A2_Typ4 = new AnzeigeQuerschnittTyp("WVZ-A2-Typ-4");
  
  public static AnzeigeQuerschnittTyp WVZ_A2_Typ5 = new AnzeigeQuerschnittTyp("WVZ-A2-Typ-5");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ1 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-1");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ2 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-2");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ3 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-3");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ4 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-4");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ5 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-5");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ6 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-6");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ6D = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-6D");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ7 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-7");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ9 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-9");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ13 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-13");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ7D = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-7D");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ10 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-10");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ10D = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-10D");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ11 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-11");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ11D = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-11D");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ12 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-12");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ14 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-14");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ14D = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-14D");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ15 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-15");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ16 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-16");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ16B = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-16B");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ16C = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-16C");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ17 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-17");
  
  public static AnzeigeQuerschnittTyp WVZ_A8_Typ17B = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-17B");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ18 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-18");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ19 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-19");

  public static AnzeigeQuerschnittTyp WVZ_A8_Typ21 = new AnzeigeQuerschnittTyp("WVZ-A8-Typ-21");

  private String type;

  private AnzeigeQuerschnittTyp(String type)
  {
    this.type = type;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return type;
  }

  public static boolean hasType(String type)
  {
    return typen.contains(type.toUpperCase());
  }

  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.bsvrz.buv.plugin.anlagendarstellung.status.Status#setStatus(java.lang.String)
   */
  public AnzeigeQuerschnittTyp setTyp(String s)
  {
    // TODO Auto-generated method stub
    AnzeigeQuerschnittTyp ait = null;

    if (s.equals(WVZ_A_B_C.getType()))
      ait = WVZ_A_B_C;
    else if (s.equals(WVZ_B_C.getType()))
      ait = WVZ_B_C;
    else if (s.equals(WVZ_A_B_C_TRICHTER.getType()))
      ait = WVZ_A_B_C_TRICHTER;
    else if (s.equals(WVZ_A_B_C_SIMULATION.getType()))
      ait = WVZ_A_B_C_SIMULATION;
    else if (s.equals(WVZ_B_C_TRICHTER.getType()))
      ait = WVZ_B_C_TRICHTER;
    else if (s.equals(WVZ_B_C_SIMULATION.getType()))
      ait = WVZ_B_C_SIMULATION;
    else if (s.equals(WVZ_A_B_C_AUTOMATIK.getType()))
      ait = WVZ_A_B_C_AUTOMATIK;
    else if (s.equals(WVZ_B27_Typ1.getType()))
      ait = WVZ_B27_Typ1;
    else if (s.equals(WVZ_B27_Typ2.getType()))
      ait = WVZ_B27_Typ2;
    else if (s.equals(WVZ_B27_Typ3.getType()))
      ait = WVZ_B27_Typ3;
    else if (s.equals(WVZ_B27_Typ4.getType()))
      ait = WVZ_B27_Typ4;
    else if (s.equals(WVZ_B27_Typ5.getType()))
      ait = WVZ_B27_Typ5;
    else if (s.equals(WVZ_B27_Typ6.getType()))
      ait = WVZ_B27_Typ6;
    else if (s.equals(WVZ_B27_Typ7.getType()))
      ait = WVZ_B27_Typ7;
    else if (s.equals(WVZ_B27_Typ7.getType()))
      ait = WVZ_B27_Typ7;
    else if (s.equals(WVZ_A14_Typ1.getType()))
      ait = WVZ_A14_Typ1;
    else if (s.equals(WVZ_A2_Typ1.getType()))
      ait = WVZ_A2_Typ1;
    else if (s.equals(WVZ_A2_Typ2.getType()))
      ait = WVZ_A2_Typ2;
    else if (s.equals(WVZ_A2_Typ3.getType()))
      ait = WVZ_A2_Typ3;
    else if (s.equals(WVZ_A2_Typ4.getType()))
      ait = WVZ_A2_Typ4;
    else if (s.equals(WVZ_A2_Typ5.getType()))
      ait = WVZ_A2_Typ5;
   
   
    else
    {

    }

    return ait;
  }

}
