/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.model;

import java.util.List;

/**
 * Model Object of a Connection, wird aus Kompatibilittsgrunden bentigt
 * 
 * @deprecated  
 * @author Pittner
 * 
 */
public class LinkElement extends PropertyAwareObject
{
  private AnzeigeQuerschnitt source;

  private Fahrstreifen target;

  /**
   * @param foreignTable
   * @param primaryKeyTable
   * @param foreignKeyColumn
   */
  public LinkElement(AnzeigeQuerschnitt source, Fahrstreifen target)
  {
    super();
    this.source = source;
    this.target = target;
    this.source.addSourceConnections(this);
    this.target.addTargetConnections(this);

  }

  public String getSourceAnchorOffset()
  {

    return (String)getProperty(SOURCE_ANCHOR_OFFSET);
  }

  public void setSourceAnchorOffset(String sourceAnchorOffset)
  {
    setProperty(SOURCE_ANCHOR_OFFSET, sourceAnchorOffset);
  }

  public String getTargetAnchorOffset()
  {
    return (String)getProperty(TARGET_ANCHOR_OFFSET);
  }

  public void setTargetAnchorOffset(String targetAnchorOffset)
  {
    setProperty(TARGET_ANCHOR_OFFSET, targetAnchorOffset);
  }

  public void setBendPoints(List bendpoints)
  {
    setProperty(BENDPOINTS, bendpoints);
  }

  public List getBendPoints()
  {
    return (List)getProperty(BENDPOINTS);
  }

  /**
   * @return Returns the foreignKeyTable.
   */
  public AnzeigeQuerschnitt getSource()
  {
    return source;
  }

  /**
   * @return Returns the primaryKeyTable.
   */
  public Fahrstreifen getTarget()
  {
    return target;
  }

  /**
   * @param sourceForeignKey
   *          the primary key table you are connecting to
   */
  public void setTarget(Fahrstreifen target)
  {
    this.target = target;
  }

  /**
   * @param sourceForeignKey
   *          the foreign key table you are connecting from
   */
  public void setSource(AnzeigeQuerschnitt source)
  {
    this.source = source;
  }

}
