/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * Rahmenwerk-Plug-in "Baustellen- und Unfalleingabe"
 * Copyright (C) 2009 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.baueditor.sts.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;

import de.bsvrz.buv.plugin.baueditor.sts.BauEditorPlugin;
import de.bsvrz.buv.plugin.baueditor.sts.views.EngstellenViewPart;

/**
 * Aktion zum Anzeigen von Enstellen in der Ansicht "Engstellen".
 * 
 * @author BitCtrl Systems GmbH, Andreas Meissner
 * @version $Id: ZeigeInEngstellenAnsichtAktion.java,v 1.2 2014/11/14 07:29:41 Pittner Exp $
 */
public class ZeigeInEngstellenAnsichtAktion implements IObjectActionDelegate {

	/**
	 * Aktuell selektierter WorkbenchPart.
	 */
	private IWorkbenchPart workbenchPart;

	/**
	 * Aktuell selektiertes Element.
	 */
	private ISelection selection;

	@Override
	public void setActivePart(final IAction action,
			final IWorkbenchPart targetPart) {
		workbenchPart = targetPart;
	}

	@Override
	public void run(final IAction action) {

		try {

			final IWorkbenchWindow window = workbenchPart.getSite()
					.getWorkbenchWindow();
			EngstellenViewPart view;
			view = (EngstellenViewPart) window.getActivePage().showView(
					EngstellenViewPart.ID);
			view.setInput(selection);

		} catch (final PartInitException e) {
			BauEditorPlugin.getDefault().getLogger().warning(
					"Ansicht Engstellen konnte nicht geffnet werden.", e);
		}
	}

	@Override
	public void selectionChanged(final IAction action, final ISelection sel) {
		selection = sel;
	}
}
