/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * Rahmenwerk-Plug-in "Baustellen- und Unfalleingabe"
 * Copyright (C) 2009 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.baueditor.sts.editors;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.databinding.Binding;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.core.databinding.conversion.NumberToStringConverter;
import org.eclipse.core.databinding.conversion.StringToNumberConverter;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.core.databinding.observable.list.ComputedList;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.observable.set.ListToSetAdapter;
import org.eclipse.core.databinding.observable.value.ComputedValue;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.core.databinding.validation.IValidator;
import org.eclipse.core.databinding.validation.ValidationStatus;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.ConnectionLayer;
import org.eclipse.draw2d.ConnectionRouter;
import org.eclipse.draw2d.FanRouter;
import org.eclipse.draw2d.FigureCanvas;
import org.eclipse.draw2d.Layer;
import org.eclipse.draw2d.LayeredPane;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MouseEvent;
import org.eclipse.draw2d.MouseListener;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.draw2d.graph.DirectedGraph;
import org.eclipse.draw2d.graph.DirectedGraphLayout;
import org.eclipse.draw2d.graph.Edge;
import org.eclipse.draw2d.graph.Node;
import org.eclipse.jface.action.ControlContribution;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.databinding.viewers.IViewerObservableSet;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.jface.databinding.viewers.ObservableSetContentProvider;
import org.eclipse.jface.databinding.viewers.ViewersObservables;
import org.eclipse.jface.dialogs.IMessageProvider;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.fieldassist.ControlDecoration;
import org.eclipse.jface.fieldassist.FieldDecorationRegistry;
import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.jface.layout.GridLayoutFactory;
import org.eclipse.jface.layout.TableColumnLayout;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.ISelectionListener;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.forms.IMessageManager;
import org.eclipse.ui.forms.ManagedForm;
import org.eclipse.ui.forms.events.HyperlinkAdapter;
import org.eclipse.ui.forms.events.HyperlinkEvent;
import org.eclipse.ui.forms.widgets.ExpandableComposite;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.Hyperlink;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;
import org.eclipse.ui.forms.widgets.TableWrapData;
import org.eclipse.ui.forms.widgets.TableWrapLayout;
import org.eclipse.ui.part.EditorPart;
import org.eclipse.ui.progress.UIJob;

import com.bitctrl.lib.eclipse.databinding.validator.IntegerValidator;
import com.bitctrl.lib.eclipse.databinding.validator.MessageValidator;
import com.bitctrl.lib.eclipse.databinding.validator.RangeValidator.IntervallType;
import com.bitctrl.lib.eclipse.databinding.validator.StringValidator;
import com.bitctrl.lib.eclipse.databinding.widgets.DecorationHelper;
import com.bitctrl.lib.eclipse.help.DefaultHelpContext;
import com.bitctrl.lib.eclipse.job.BackgroundUIJob;
import com.bitctrl.lib.eclipse.selectionProvider.SelectionProvider;
import com.bitctrl.lib.eclipse.selectionProvider.SelectionProviderWrapper;
import com.ibm.icu.text.NumberFormat;

import de.bsvrz.buv.plugin.baueditor.sts.BauEditorPlugin;
import de.bsvrz.buv.plugin.baueditor.sts.BildDateiPfade;
import de.bsvrz.buv.plugin.baueditor.sts.EngstellenVerwaltung;
import de.bsvrz.buv.plugin.baueditor.sts.Konstanten;
import de.bsvrz.buv.plugin.baueditor.sts.graph.figures.StrassenKnotenFigureMitLabel;
import de.bsvrz.buv.plugin.baueditor.sts.graph.figures.TooltipUtil;
import de.bsvrz.buv.plugin.baueditor.sts.util.EngstellenCache;
import de.bsvrz.buv.plugin.baueditor.sts.util.converter.DoubleToOffsetInfoStringConverter;
import de.bsvrz.buv.plugin.baueditor.sts.util.converter.IntervallToInfoStringConverter;
import de.bsvrz.buv.plugin.baueditor.sts.util.listener.EngstellenChangedAdapter;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.BaustellenWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.EngstellenWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.StauWrapper;
import de.bsvrz.buv.plugin.baueditor.sts.util.wrapper.UnfallWrapper;
import de.bsvrz.buv.plugin.ereigniskal.EreignisKalenderListener;
import de.bsvrz.buv.plugin.ereigniskal.EreignisKalenderVerwaltung;
import de.bsvrz.buv.plugin.ereigniskal.actions.EreignisBearbeitenAktion;
import de.bsvrz.buv.plugin.ereigniskal.actions.EreignisTypAnlegenAktion;
import de.bsvrz.buv.plugin.selektion.SelektionsTransfer;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit.Eingabetyp;
import de.bsvrz.buv.rw.basislib.login.UrlasserDialog;
import de.bsvrz.buv.rw.basislib.login.UrlasserDialog.UrlasserDialogInfo;
import de.bsvrz.buv.rw.bitctrl.eclipse.SystemObjectTypeLabelProvider;
import de.bsvrz.buv.rw.bitctrl.eclipse.actions.UebernehmeSystemKalenderZeitbereichAction;
import de.bsvrz.buv.rw.bitctrl.eclipse.databinding.CompositeZeitDauerExtendedObservableValue;
import de.bsvrz.buv.rw.bitctrl.eclipse.databinding.DatumZeitObservableZeitPunkt;
import de.bsvrz.buv.rw.bitctrl.eclipse.databinding.RichtungTextComputedValue;
import de.bsvrz.buv.rw.bitctrl.eclipse.databinding.converter.BooleanToTmcRichtungConverter;
import de.bsvrz.buv.rw.bitctrl.eclipse.databinding.converter.TmcRichtungToBooleanConverter;
import de.bsvrz.buv.rw.bitctrl.eclipse.widgets.CompositeZeitDauerExtended;
import de.bsvrz.buv.rw.bitctrl.startup.StartupPlugin;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.sys.funclib.bitctrl.modell.AenderbareMenge;
import de.bsvrz.sys.funclib.bitctrl.modell.DynamischesObjekt;
import de.bsvrz.sys.funclib.bitctrl.modell.att.Feld;
import de.bsvrz.sys.funclib.bitctrl.modell.att.WerteBereich;
import de.bsvrz.sys.funclib.bitctrl.modell.fachmodellglobal.attribute.AttStreckeMeter;
import de.bsvrz.sys.funclib.bitctrl.modell.systemmodellglobal.objekte.Benutzer;
import de.bsvrz.sys.funclib.bitctrl.modell.tmereigniskalenderglobal.attribute.AtlZusaetzlicheAttribute;
import de.bsvrz.sys.funclib.bitctrl.modell.tmereigniskalenderglobal.objekte.Ereignis;
import de.bsvrz.sys.funclib.bitctrl.modell.tmereigniskalenderglobal.objekte.EreignisTyp;
import de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.attribute.AttTmcRichtung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AttFahrStreifenLage;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.attribute.AttVerkehrsStaerkeStunde;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.konfigurationsdaten.KdStrasseFernZiele;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.AeusseresStrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Baustelle;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.InneresStrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Situation;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Strasse;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenKnoten;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Unfall;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.NetzCache;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.NetzCacheExtended;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.StrassenTeilSegmenteCache;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.StreckenAbschnitt;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.StreckenAbschnitt.Intervall;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.StreckenAbschnittCache;

/**
 * Die abstrakte Superklasse fr die Editoren.
 * 
 * @author BitCtrl Systems GmbH, Andreas Meissner
 * @version $Id: EngstellenEditor.java,v 1.2 2014/11/14 07:29:40 Pittner Exp $
 */
public abstract class EngstellenEditor extends EditorPart {

	/**
	 * Lock-Object.
	 */
	private static Object lock = new Object();

	/**
	 * Allgemeine Style-Angaben fr die Sections (gesetzte Werte: TITLE_BAR und
	 * EXPANDED).
	 */
	protected static final int SECTION_STYLE = ExpandableComposite.TITLE_BAR
			| ExpandableComposite.EXPANDED;

	/**
	 * Erweiterte Style-Angaben fr Sections (gesetzte Werte: TITLE_BAR,
	 * EXPANDED und TWISTIE).
	 * 
	 * @see EngstellenEditor#SECTION_STYLE
	 */
	protected static final int SECTION_STYLE_MIT_TWISTIE = SECTION_STYLE
			| ExpandableComposite.TWISTIE;

	/**
	 * TimeOut, nach welchem das Warten auf ein eintreffendes Datensatz
	 * abgebrochen und eine entsprechende Fehlermeldung ausgegeben werden soll.
	 */
	private static final long TIMEOUT = 60000;

	/** Der Kontext fr das DataBinding. */
	private DataBindingContext bindingContext;

	/** Der Netz-Cache. */
	private NetzCache netzCache;

	/** Der erweiterte Netz-Cache. */
	private NetzCacheExtended netzCacheExtended;

	/** Der Streckenabschnitts-Cache. */
	private StreckenAbschnittCache streckenCache;

	/** Der Straenteilsegmente-Cache. */
	private StrassenTeilSegmenteCache strassenTeilSegmenteCache;

	/** Die evtl. neu angelegte Situation. */
	private Situation neuAngelegteSituation;

	/** Flag, welches angibt, ob der Editor gerade beschftigt ist. */
	private boolean isBusy;

	/** Das evtl. neu angelegte Ereignis. */
	private Ereignis neuesEreignis;

	/** Der EngstellenWrapper, welcher in diesem Editor bearbeitet werden kann. */
	private EngstellenWrapper wrapper;

	/**
	 * Der Font, welcher bei den Labels im Editorbereich "Segmente" verwendet
	 * wird.
	 */
	private Font segmenteLabelFont;

	/** Das NumberFormat zum Formatieren von Integer-Werten. */
	private NumberFormat intNumberFormat;

	/** Das NumberFormat zum Formatieren von Double-Werten. */
	private NumberFormat doubleNumberFormat;

	/** Das Scrolled-Form dieses Editors. */
	private ScrolledForm form;

	/** Das Managed-Form dieses Editors. */
	private ManagedForm managedForm;

	/** Der MessageManager zur Verwaltung der Fehler und Warnungen. */
	private IMessageManager messageManager;

	/** Der Button zum Aktualisieren des Editors. */
	private Button refreshButton;

	/** Der Button zum Speichern des Editors. */
	private Button saveButton;

	/**
	 * Die Checkbox zur Anzeige, ob ein dazugehriges Ereignis angelegt werden
	 * soll bzw. bereits existiert.
	 */
	private Button ereignisCheckbox;

	/** Das Composite, welches die Widgets der Ereignisbehandlung enthlt. */
	private Composite ereignisVerknuepfenComposite;

	/**
	 * Das StackLayout des Ereignis-Composite (
	 * {@link #ereignisVerknuepfenComposite}).
	 */
	private StackLayout ereignisVerknuepfenStackLayout;

	/** Das Label, welches der Ereignis-Checkbox nachgestellt ist. */
	private Label ereignisVerknuepfenLabel;

	/** Der Hyperlink, welcher ein bereits verknpftes Ereignis verlinkt. */
	private Hyperlink ereignisVerknuepfenHyperlink;

	/** Der ComboViewer zur Auswahl des Ereignistyps. */
	private ComboViewer ereignisTypComboViewer;

	/** Der Button zum ffnen des Wizards zum Anlegen eines neuen Ereignistyps. */
	private Button neuerEreignisTypButton;

	/** Toolbar-Aktion zur bernahme von Kalendereintrgen. */
	private IAction systemKalenderAction;

	/** Das Zeit-Widget zur Angabe der Startzeit. */
	private DatumZeit vonDatumZeit;

	/** Der Button zum Aktualisieren der Startzeit. */
	private Button aktualisiereStartZeitButton;

	/** Das Zeit-Widgetzur Angabe der Endzeit. */
	private DatumZeit bisDatumZeit;

	/** Der Button zum Aktualisieren der Endzeit. */
	private Button aktualisiereEndZeitButton;

	/** Das Dauer-Widget zur Angabe der Dauer. */
	private CompositeZeitDauerExtended zeitDauer;

	/** Der Button zur Deklaration einer unbekannten Dauer. */
	private Button dauerUnbekanntButton;

	/** Das Textfeld zur Angabe des Namens einer Engstelle. */
	private Text nameText;

	/** Der ComboViewer zur Auswahl der Strae. */
	private ComboViewer strasseComboViewer;

	/** Composite welches die Radio-Boxen zur Auswahl der Richtung enthlt. */
	private Composite richtungComposite;

	/** Der Radio-Button fr die positive Richtung. */
	private Button positiveRichtungButton;

	/** Der Radio-Button fr die negative Richtung. */
	private Button negativeRichtungButton;

	/** Der ComboViewer zur Auswahl des Startstraenknotens. */
	private ComboViewer startKnotenComboViewer;

	/** Der ComboViewer zur Auswahl des Endstraenknotens. */
	private ComboViewer endKnotenComboViewer;

	/** Das Textfeld zur Angabe des StartOffsets. */
	private Text startOffsetText;

	/** Das Info-Label zur Anzeige des StartOffsets-Bereichs. */
	private Label startOffsetInfoLabel;

	/** Das Textfeld zur Angabe des EndOffsets. */
	private Text endOffsetText;

	/** Das Info-Label zur Anzeige des EndOffsets-Bereichs. */
	private Label endOffsetInfoLabel;

	/** Das Text-Feld zur Angabe des Start-Betriebskilometers. */
	private Text startBetriebsKilometerText;

	/**
	 * Der ComboViewer zur Auswahl der Blocknummer fr den
	 * Startbetriebskilometer.
	 */
	private ComboViewer startBlockNummerComboViewer;

	/** Das Info-Label zur Anzeige des Start-Betriebskilometer-Bereichs. */
	private Label startBetriebsKilometerInfoLabel;

	/** Das Text-Feld zur Angabe des End-Betriebskilometers. */
	private Text endBetriebsKilometerText;

	/**
	 * Der ComboViewer zur Auswahl der Blocknummer fr den Endbetriebskilometer.
	 */
	private ComboViewer endBlockNummerComboViewer;

	/** Das Info-Label zur Anzeige des End-Betriebskilometer-Bereichs. */
	private Label endBetriebsKilometerInfoLabel;

	/** Der TableViewer zur Definiton der gesperrten Fahrstreifen. */
	private CheckboxTableViewer fahrstreifenTableViewer;

	/**
	 * Das Info-Label zur Anzeige der Anzahl der Fahrstreifen auf dem
	 * Startstraensegment.
	 */
	private Label anzahlFahrstreifenInfoLabel;

	/** Das Info-Label zur Anzeige der Anzahl der freien Fahrstreifen. */
	private Label freieFahrstreifenInfoLabel;

	/** Das Textfeld zur Angabe der Restkapazitt. */
	private Text restKapazitaetText;

	/** Das Textfeld zur Angabe der Engpasskapazitt. */
	private Text engpassKapazitaetText;

	/** Das Textfeld zur Angabe einer Kurzinfo. */
	private Text kurzinfoText;

	/** Das Textfeld zur Angabe der Beschreibung. */
	private Text beschreibungText;

	/** Das Composite, welches die Widget des Bereichs "Segmente" enthlt. */
	private Section segmenteSection;

	/** Die Zeichenebene zur Darstellung der Sraensegmente. */
	private LayeredPane segmenteLayeredPane;

	/** Das Bild, welches im Titel des Editors angezeigt wird. */
	private Image titleImage;

	/** Ein Dummy-Composite: wird bentigt zum Layout. */
	// private Composite dummyComposite;

	/**
	 * Control-Decoration des Text-Widgets fr die
	 * End-Betriebskilometer-Eingabe.
	 */
	private ControlDecoration startBetriebsKilometerTextDecoration;

	/** Control-Decoration des Text-Widgets fr die StartOffset-Eingabe. */
	private ControlDecoration startOffsetTextDecoration;

	/**
	 * Control-Decoration des Text-Widgets fr die
	 * Start-Betriebskilometer-Eingabe.
	 */
	private ControlDecoration endBetriebsKilometerTextDecoration;

	/** Control-Decoration des Text-Widgets fr die EndOffset-Eingabe. */
	private ControlDecoration endOffsetTextDecoration;

	/** Binding des Text-Widgets fr die StartOffset-Eingabe. */
	private Binding startOffsetBinding;

	/** Binding des Text-Widgets fr die Start-Betriebskilometer-Eingabe. */
	private Binding startBetriebsKilometerBinding;

	/** Binding des Text-Widgets fr die EndOffset-Eingabe. */
	private Binding endOffsetBinding;

	/** Binding des Text-Widgets fr die End-Betriebskilometer-Eingabe. */
	private Binding endBetriebsKilometerBinding;

	/**
	 * Flag, welches angibt, ob gerade die Aktion "Ereignistyp anlegen"
	 * ausgefhrt wurde.
	 */
	private boolean neuenEreignisTypAngelegt;

	/** UIJob, welcher zum Aktualisieren des Editors zustndig ist. */
	private UpdateEditorJob updateEditorJob;

	/**
	 * Listener, welcher nderungen der Menge der Engstellen behandelt.
	 */
	private final EngstellenChangedAdapter engstellenListener = new EngstellenChangedAdapter() {

		@Override
		public void engstellenRemoved(final Object quelle,
				final List<EngstellenWrapper> engstellen) {

			if (wrapper.isNeuesElement()) {
				return;
			}
			final Situation situation = wrapper.getSituation();
			if (situation == null) {
				return;
			}
			boolean engstelleWurdeGeloescht = false;
			for (final EngstellenWrapper engstelle : engstellen) {
				if (situation.getPid()
						.equals(engstelle.getSituation().getPid())) {
					engstelleWurdeGeloescht = true;
					break;
				}
			}
			if (!engstelleWurdeGeloescht) {
				return;

			}

			// Wenn das Entfernen der Engstelle nicht in diesem Plug-in
			// ausgelst wurde, informiert eine Info-Dialog ber die
			// Lschung.
			final Display display = Display.getDefault();
			if (display != null && !display.isDisposed()) {
				display.asyncExec(new Runnable() {
					public void run() {
						if (quelle != BauEditorPlugin.getDefault()
								.getEngstellenCache()) {
							MessageDialog.openInformation(getSite().getShell(),
									"Info",
									getLoeschInfoText(situation.getName()));
						}
						getSite().getPage().closeEditor(EngstellenEditor.this,
								false);
					}
				});
			}
		}

		@Override
		public void engstellenAdded(final Object quelle,
				final List<EngstellenWrapper> engstellen) {

			if (neuAngelegteSituation == null) {
				return;
			}

			EngstellenWrapper neuerWert = null;
			for (final EngstellenWrapper neueEngstelle : engstellen) {
				if (neueEngstelle.getSituation() != null
						&& neuAngelegteSituation.getPid().equals(
								neueEngstelle.getSituation().getPid())) {
					neuerWert = neueEngstelle;
					break;
				}
			}

			if (neuerWert != null) {
				engstelleChanged(quelle, neuerWert, null);
			}
		}

		@Override
		public void engstelleChanged(final Object quelle,
				final EngstellenWrapper neuerWert,
				final EngstellenWrapper alterWert) {

			synchronized (lock) {

				Situation aktuelleSituation = wrapper.getSituation();
				if (aktuelleSituation == null) {
					aktuelleSituation = neuAngelegteSituation;
				}

				if (aktuelleSituation != null
						&& neuerWert.getSituation() != null
						&& aktuelleSituation.getPid().equals(
								neuerWert.getSituation().getPid())) {

					if (checkSaveJob != null) {
						checkSaveJob.cancel();
					}

					final Display display = getSite().getShell().getDisplay();
					if (display != null && !display.isDisposed()) {

						// Der Editor wird nicht sofort aktualisiert. Es wird
						// zunchst eine bestimmte Zeit gewartet, um fr
						// mglicherweise nacheinander eintreffende
						// Datensatz-Updates nur eine Aktualisierung
						// durchzufhren.

						// Es wird hier noch ein kleiner zustzlichen
						// TimeOut (50ms) hinzugefgt, damit sichergestellt
						// ist, dass der Navigator in dieser Zeit schon
						// aktualisiert wurde und die von diesem Job
						// initialisierte Selektion erfolgreich ausgefhrt
						// werden kann.
						if (updateEditorJob == null || updateEditorJob.isDone()) {
							updateEditorJob = new UpdateEditorJob(display,
									neuerWert);
							updateEditorJob
									.schedule(Konstanten.UPDATE_TIMEOUT + 50);
						} else {
							updateEditorJob.setNeuerWrapper(neuerWert);
						}
					}
				}
			}
		}
	};

	/**
	 * UIJob, welcher den Editor aktualisiert.
	 */
	private final class UpdateEditorJob extends UIJob {

		/** Die Engstelle, welcher dieser Editor anzeigen soll. */
		private EngstellenWrapper neuerWert;

		/** Flag, welches angibt, ob der Job bereits ausgefhrt wurde. */
		private boolean done;

		/**
		 * Der Konstruktor.
		 * 
		 * @param jobDisplay
		 *            das Display
		 * @param neuerWert
		 *            die Engstelle, welche dieser Editor anzeigen soll
		 */
		public UpdateEditorJob(final Display jobDisplay,
				final EngstellenWrapper neuerWert) {
			super(jobDisplay, "Aktualisiere Editor");
			this.neuerWert = neuerWert;
			done = false;
		}

		/**
		 * Liefert <code>true</code> zurck, wenn der Job bereits ausgefhrt
		 * wurde, ansonsten <code>false</code>.
		 * 
		 * @return <code>true</code>, wenn der Job bereits ausgefhrt wurde,
		 *         ansonsten <code>false</code>
		 */
		public boolean isDone() {
			return done;
		}

		/**
		 * Setzt die neue Engstelle, welche dieser Editor anzeigen soll.
		 * 
		 * @param neuerWrapper
		 *            die Engstelle
		 */
		public void setNeuerWrapper(final EngstellenWrapper neuerWrapper) {
			neuerWert = neuerWrapper;
		}

		@Override
		public IStatus runInUIThread(final IProgressMonitor monitor) {
			boolean provideSelection = false;

			if (monitor.isCanceled()) {
				return Status.CANCEL_STATUS;
			}

			if (isBusy) {
				isBusy = false;
				if (form != null && !form.isDisposed()) {
					form.setBusy(isBusy);
				}
				provideSelection = neuAngelegteSituation != null;
			} else if (wrapper.isDirty()) {
				MessageDialog
						.openInformation(
								getSite().getShell(),
								"Info",
								"Die Engstelle '"
										+ wrapper.getName()
										+ "' wurde im Datenverteiler aktualisiert. "
										+ "\n\nDer dazugehrige Editor muss somit ebenfalls aktualisiert werden. "
										+ "Smtliche nderungen gehen dabei verloren.");
			}

			if (monitor.isCanceled()) {
				return Status.CANCEL_STATUS;
			}

			neuAngelegteSituation = null;
			if (neuerWert instanceof BaustellenWrapper) {
				wrapper = new BaustellenWrapper((BaustellenWrapper) neuerWert);
				setInput(new BaustellenEditorInput((BaustellenWrapper) wrapper));
			} else if (neuerWert instanceof UnfallWrapper) {
				wrapper = new UnfallWrapper((UnfallWrapper) neuerWert);
				setInput(new UnfallEditorInput((UnfallWrapper) wrapper));
			}
			setPartName(getEditorInput().getName());
			wrapper.setEreignis(neuesEreignis);
			setDirty(false);
			setEnablement(true);
			bindValues();
			if (provideSelection) {
				SelektionsTransfer.getInstanz()
						.selectionChanged(EngstellenEditor.this,
								new StructuredSelection(wrapper));
				setFocus();
			}
			done = true;
			return Status.OK_STATUS;
		}
	};

	/**
	 * Listener, welcher auf nderungen des Ereigniskalenders lauscht.
	 */
	private final EreignisKalenderListener ereignisKalenderListener = new EreignisKalenderListener() {

		@Override
		public void ereignisseEntfernt(final Collection<Ereignis> liste) {

			if (wrapper.getEreignis() == null) {
				return;
			}

			for (final Ereignis ereignis : liste) {
				if (wrapper.getEreignis().getPid().equals(ereignis.getPid())) {
					final Display display = Display.getDefault();
					if (display != null && !display.isDisposed()) {
						display.syncExec(new Runnable() {
							@Override
							public void run() {
								final boolean tempDirty = wrapper.isDirty();
								wrapper.setEreignis(null);
								if (!tempDirty && wrapper.isDirty()) {
									wrapper.setDirty(tempDirty);
								}
							}
						});
					}
				}
			}
		}

		@Override
		public void ereignisseAngelegt(final Collection<Ereignis> liste) {

			if (wrapper.getSituation() == null) {
				return;
			}

			for (final Ereignis ereignis : liste) {
				final Feld<AtlZusaetzlicheAttribute> zusaetzlicheAttribute = ereignis
						.getKdEreignisEigenschaften().getDatum()
						.getZusaetzlicheAttribute();
				if (zusaetzlicheAttribute == null
						|| !zusaetzlicheAttribute.isEmpty()) {
					continue;
				}

				for (final AtlZusaetzlicheAttribute attribut : zusaetzlicheAttribute) {
					if (!attribut
							.getAttributname()
							.equals(Konstanten.EREIGNIS_EIGENSCHAFTEN_REFERENZ_AUSLOESENDE_SITUATION)) {
						continue;
					}
					if (attribut.getAttributwert().equals(
							wrapper.getSituation().getPid())) {
						final Display display = Display.getDefault();
						if (display != null && !display.isDisposed()) {
							display.syncExec(new Runnable() {
								@Override
								public void run() {
									wrapper.setEreignis(ereignis);
								}
							});
						}
						return;
					}
				}
			}
		}

		@Override
		public void ereignisTypenEntfernt(final Collection<EreignisTyp> liste) {
			aktualisiereEreignisTypenCombo(null);
		}

		@Override
		public void ereignisTypenAngelegt(final Collection<EreignisTyp> liste) {
			EreignisTyp ereignisTyp = null;
			if (neuenEreignisTypAngelegt && liste != null && !liste.isEmpty()) {
				final List<EreignisTyp> ereignisTypen = new ArrayList<EreignisTyp>(
						liste);
				ereignisTyp = ereignisTypen.get(0);
			}
			aktualisiereEreignisTypenCombo(ereignisTyp);
		}

		@Override
		public void ereignisTypAktualisiert(final EreignisTyp typ) {
			aktualisiereEreignisTypenCombo(neuenEreignisTypAngelegt ? typ
					: null);
		}
	};

	/**
	 * Ein Wrapper-Objekt, welches mehrere {@link ISelectionProvider} verwaltet.
	 */
	private SelectionProviderWrapper selectionProviderWrapper;

	/**
	 * Der SelectionProvider dieses Editors.
	 */
	private final ISelectionProvider selectionProvider = new SelectionProvider() {
		@Override
		public ISelection getSelection() {
			if (wrapper != null) {
				return new StructuredSelection(wrapper);
			}
			return super.getSelection();
		}
	};

	/**
	 * Der SelectionProvider der Segmente-Ansicht.
	 */
	private final ISelectionProvider segmenteSelectionProvider = new SelectionProvider();

	/**
	 * Default-FocusListener fr alle Standard-Widgets.
	 * 
	 * @author BitCtrl Systems GmbH, Andreas Meissner
	 * @version $Id: EngstellenEditor.java,v 1.2 2014/11/14 07:29:40 Pittner Exp $
	 */
	private class DefaultFocusListener extends FocusAdapter {
		@Override
		public void focusGained(final FocusEvent e) {
			if (selectionProviderWrapper != null && selectionProvider != null) {
				selectionProviderWrapper
						.setSelectionProvider(selectionProvider);
			}
		};
	}

	/**
	 * Der Default-FocusListener fr alle Standard-Widget (also alle auer die
	 * Viewer).
	 */
	private final FocusListener defaultFocusListener = new DefaultFocusListener();

	/**
	 * Hilfsklasse zur Selektion des ersten Elements eines ComboViewers nachdem
	 * dessen Inhalt durch DataBinding aktualisiert wurde.
	 * 
	 * @author BitCtrl Systems GmbH, Andreas Meissner
	 * @version $Id: EngstellenEditor.java,v 1.2 2014/11/14 07:29:40 Pittner Exp $
	 */
	private class SelectFirstElementOfComboViewerJob extends UIJob {

		/** Der ComboViewer dessen Selektion behandelt werden soll. */
		private final ComboViewer viewer;

		/**
		 * Der Konstruktor.
		 * 
		 * @param viewer
		 *            der ComboViewer dessen Selektion behandelt werden soll
		 */
		public SelectFirstElementOfComboViewerJob(final ComboViewer viewer) {
			super("Selektiere erstes Element");
			this.viewer = viewer;
		}

		// TODO Prfung auf Leerstring wieder eingebaut, weil ansonsten die
		// Initialisierung mit einem neuen Datensatz schief geht. Die
		// Implementierung der Datensatzlogik innerhalb des Editors sollte
		// unbedingt berdacht werden!

		@Override
		public IStatus runInUIThread(final IProgressMonitor monitor) {
			if (viewer != null && viewer.getCombo() != null
					&& !viewer.getCombo().isDisposed()
					&& "".equals(viewer.getCombo().getText())
					&& viewer.getElementAt(0) != null) {
				viewer.setSelection(new StructuredSelection(viewer
						.getElementAt(0)));
			}
			return Status.OK_STATUS;
		}
	};

	/**
	 * UIJob, welcher ggf. nach Ablauf eines TimeOuts ber das Fehlschlagen des
	 * Abspeichervorgangs informiert.
	 */
	private UIJob checkSaveJob = new UIJob("berprfe Abspeichervorgang") {

		@Override
		public IStatus runInUIThread(final IProgressMonitor monitor) {
			if (monitor.isCanceled()) {
				return Status.CANCEL_STATUS;
			}

			if (isBusy) {
				MessageDialog
						.openError(
								getSite().getShell(),
								"Fehler",
								"Es gab ein Problem beim Abspeichern der Engstelle.\n\n"
										+ "Es ist jedoch mglich, dass die Engstelle korrekt angelegt wurde und "
										+ "lediglich ein Problem im Benachrichtigungsmechanismus aufgetreten ist.\n\n"
										+ "Aktualisieren Sie bitte die Ansicht 'Engstellen-Navigator' und vergewissern Sie sich, ob die Engstelle angelegt wurde. "
										+ "Ist dies der Fall, knnen Sie diesen Editor ohne zu Speichern schlieen. "
										+ "Ansonsten versuchen Sie bitte nochmals, diese Engstelle zu speichern.");

				if (monitor.isCanceled()) {
					return Status.CANCEL_STATUS;
				}

				isBusy = false;
				if (form != null && !form.isDisposed()) {
					form.setBusy(isBusy);
				}
				setEnablement(true);
			}
			return Status.OK_STATUS;
		}
	};

	@Override
	public void init(final IEditorSite site, final IEditorInput editorInput)
			throws PartInitException {

		if (!(editorInput instanceof EngstellenEditorInput)) {
			throw new PartInitException(
					"EngstellenEditor muss ein EngstellenEditorInput bergeben werden.");
		}

		setSite(site);
		setInput(editorInput);

		netzCache = StartupPlugin.getDefault().getDefaultNetzCache();
		netzCacheExtended = StartupPlugin.getDefault()
				.getDefaultNetzCacheExtended();
		streckenCache = StartupPlugin.getDefault()
				.getDefaultStreckenAbschnittCache();
		strassenTeilSegmenteCache = StartupPlugin.getDefault()
				.getDefaultStrassenTeilSegmenteCache();
		neuenEreignisTypAngelegt = false;

		wrapper = ((EngstellenEditorInput) editorInput).getWrapper();
		titleImage = getEditorInput().getImageDescriptor().createImage();

		intNumberFormat = NumberFormat.getIntegerInstance(Locale.GERMANY);
		intNumberFormat.setGroupingUsed(false);
		doubleNumberFormat = NumberFormat.getNumberInstance(Locale.GERMANY);
		doubleNumberFormat.setGroupingUsed(false);

		setTitleImage(titleImage);
		if (!wrapper.isNeuesElement()) {
			setPartName(getEditorInput().getName());
		}

		BauEditorPlugin.getDefault().getEngstellenCache()
				.addEngstellenListener(engstellenListener);
		EreignisKalenderVerwaltung.getInstanz().addEreignisKalenderListener(
				ereignisKalenderListener);
	}

	/**
	 * Liefert den Info-Text zurck, welcher angezeigt werden soll, wenn nach
	 * Lschung einer Engstelle der dazugehrige Editor geschlossen werden muss.
	 * 
	 * @param nameEngstelle
	 *            der Name der Engstelle
	 * 
	 * @return der Info-Text bei Lschung der im Editor bearbeiteten Engstelle
	 */
	protected abstract String getLoeschInfoText(String nameEngstelle);

	/**
	 * Konfiguriere das DataBinding.
	 */
	private void bindValues() {

		if (bindingContext != null) {
			bindingContext.dispose();
		}

		bindingContext = new DataBindingContext();
		final Realm realm = SWTObservables.getRealm(Display.getDefault());
		getMessageManager().removeAllMessages();

		bindValues(bindingContext, realm);
	}

	/**
	 * Methode, welche sich um das gesamte DataBindung der in diesem Editor
	 * enthaltenen Widgets kmmert.
	 * 
	 * @param bc
	 *            der aktuelle DataBindingContext
	 * @param realm
	 *            der gltige Bereich
	 */
	protected void bindValues(final DataBindingContext bc, final Realm realm) {

		// Sicher Werte, welche sich bei der Initialisierung der Bindings
		// verndern, sodass diese nochmals aktualisiert werden knnen.
		final boolean alterDirtyState = wrapper.isDirty();
		final StrassenKnoten startKnoten = wrapper.getStartKnoten();
		final StrassenKnoten endKnoten = wrapper.getEndKnoten();
		final double startOffset = wrapper.getStreckenAbschnitt()
				.getStartOffset();
		final double endOffset = wrapper.getStreckenAbschnitt().getEndOffset();
		final List<StrassenSegment> strassenSegmente = wrapper
				.getStreckenAbschnitt().getStrassenSegmente();
		final int engpassKapazitaet = wrapper.getEngpassKapazitaet();

		// Dirty-State Listener
		wrapper.addPropertyChangeListener("dirty",
				new PropertyChangeListener() {
					public void propertyChange(final PropertyChangeEvent evt) {
						final Display display = getSite().getShell()
								.getDisplay();
						if (display != null && !display.isDisposed()) {
							display.syncExec(new Runnable() {
								@Override
								public void run() {
									setDirty(wrapper.isDirty());
								}
							});
						}
					}
				});

		// Bind Values
		final IObservableValue streckenAbschnittObservableValue = BeansObservables
				.observeValue(realm, wrapper,
						EngstellenWrapper.STRECKEN_ABSCHNITT);

		bindKopfbereichValues(bc, realm);
		bindDauerBereichValues(bc, realm);
		bindInfoBereichValues(bc, realm);
		bindLageBereichValues(bc, realm, startKnoten, endKnoten);
		bindOffsetValues(bc, streckenAbschnittObservableValue);
		bindBetriebsKilometerValues(bc, streckenAbschnittObservableValue);
		bindBereichFahrstreifenValues(bc, realm,
				streckenAbschnittObservableValue);
		bindKapazitaetenBereichValues(bc, realm);

		// Setze Startknoten
		if (!wrapper.getStartKnoten().getPid().equals(startKnoten.getPid())) {
			wrapper.setStartKnoten(startKnoten);
		}
		if (!wrapper.getEndKnoten().getPid().equals(endKnoten.getPid())) {
			wrapper.setEndKnoten(endKnoten);
		}

		// Setze ggf. beim ndern des Startstraenknotens vernderte
		// Straensegmente neu
		final List<StrassenSegment> aktuelleStrassenSegmente = new ArrayList<StrassenSegment>(
				wrapper.getStreckenAbschnitt().getStrassenSegmente());
		for (final StrassenSegment segment : strassenSegmente) {
			if (!aktuelleStrassenSegmente.contains(segment)) {
				if (segment instanceof AeusseresStrassenSegment) {
					wrapper.setAlternativesAeuesseresStrassenSegment((AeusseresStrassenSegment) segment);
				} else if (segment instanceof InneresStrassenSegment) {
					wrapper.getStreckenAbschnitt().setInneresStrassenSegment(
							(InneresStrassenSegment) segment);
				}
			}
		}

		// Setze Offsets
		if (wrapper.getStreckenAbschnitt().getStartOffset() != startOffset) {
			wrapper.getStreckenAbschnitt().setStartOffset(startOffset);
		}
		if (wrapper.getStreckenAbschnitt().getEndOffset() != endOffset) {
			wrapper.getStreckenAbschnitt().setEndOffset(endOffset);
		}

		// Setze Engpasskapazitt
		if (wrapper.getEngpassKapazitaet() != engpassKapazitaet) {
			wrapper.setEngpassKapazitaet(engpassKapazitaet);
		}

		// Streckenabschnitt Listener
		final PropertyChangeListener propertyChangeListener = new PropertyChangeListener() {
			public void propertyChange(final PropertyChangeEvent evt) {
				setDirty(true);
				aktualisiereSegmenteGraph();
			}
		};
		wrapper.getStreckenAbschnitt().addPropertyChangeListener(
				EngstellenWrapper.STRASSEN_SEGMENTE, propertyChangeListener);
		wrapper.addPropertyChangeListener(EngstellenWrapper.STRECKEN_ABSCHNITT,
				new PropertyChangeListener() {
					public void propertyChange(final PropertyChangeEvent evt) {
						wrapper.getStreckenAbschnitt()
								.addPropertyChangeListener(
										EngstellenWrapper.STRASSEN_SEGMENTE,
										propertyChangeListener);
						aktualisiereSegmenteGraph();
					}
				});
		aktualisiereSegmenteGraph();

		// Warnung bei Ereignissen
		final PropertyChangeListener propertyChangeListener2 = new PropertyChangeListener() {
			public void propertyChange(final PropertyChangeEvent evt) {
				final String key = EngstellenWrapper.EREIGNIS_WARNUNG;
				if (wrapper.getEreignis() != null
						&& !wrapper.isVerknuepfeEreignis()
						&& wrapper.getStartZeit().getTime() < System
								.currentTimeMillis()) {
					messageManager
							.addMessage(
									key,
									"Das Lschen eines dazugehrigen Ereignisses in der Vergangenheit kann zu Inkonsistenzen fhren.",
									null, IMessageProvider.WARNING);
				} else {
					messageManager.removeMessage(key);
				}
			}
		};
		wrapper.addPropertyChangeListener(EngstellenWrapper.EREIGNIS,
				propertyChangeListener2);
		wrapper.addPropertyChangeListener(EngstellenWrapper.START_ZEIT,
				propertyChangeListener2);
		wrapper.addPropertyChangeListener(
				EngstellenWrapper.VERKNUEPFE_EREIGNIS, propertyChangeListener2);

		wrapper.addPropertyChangeListener(EngstellenWrapper.EREIGNIS,
				new PropertyChangeListener() {
					@Override
					public void propertyChange(final PropertyChangeEvent evt) {
						aktualisiereEreignisVerknuepfenComposite();
					}
				});

		// Setze Dirty-State
		final UIJob resetDirtyStateJob = new UIJob("") {
			@Override
			public IStatus runInUIThread(final IProgressMonitor monitor) {
				setDirty(alterDirtyState);
				return Status.OK_STATUS;
			}
		};
		resetDirtyStateJob.schedule(10);
	}

	/**
	 * Konfiguriere das DataBinding fr die Widget im Editorkopfbereich.
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param realm
	 *            das Realm
	 */
	private void bindKopfbereichValues(final DataBindingContext bc,
			final Realm realm) {

		// Name
		final String errorText = "Bitte geben Sie einen Namen ein!";
		bc.bindValue(SWTObservables.observeText(nameText, SWT.Modify),
				BeansObservables.observeValue(realm, wrapper,
						EngstellenWrapper.NAME), new UpdateValueStrategy()
						.setAfterConvertValidator(new MessageValidator(
								EngstellenWrapper.NAME, getMessageManager(),
								nameText, new StringValidator(errorText)
										.setSeverity(IStatus.ERROR))), null);

		// Ereignis
		final IObservableValue verknuepfeEreignisObservableValue = BeansObservables
				.observeValue(realm, wrapper,
						EngstellenWrapper.VERKNUEPFE_EREIGNIS);
		final IObservableValue ereignisObservableValue = BeansObservables
				.observeValue(realm, wrapper, EngstellenWrapper.EREIGNIS);
		final ComputedValue computedVisibleValue = new ComputedValue() {
			@Override
			protected Object calculate() {
				return ereignisObservableValue.getValue() == null;
			}
		};

		// Ereignis-Typ
		final IObservableValue ereignisTypObservable = ViewersObservables
				.observeSingleSelection(ereignisTypComboViewer);
		bc.bindValue(ereignisTypObservable, BeansObservables.observeValue(
				realm, wrapper, EngstellenWrapper.EREIGNIS_TYP), null, null);

		// Selection
		bc.bindValue(SWTObservables.observeSelection(ereignisCheckbox),
				verknuepfeEreignisObservableValue);

		// Enablement
		bc.bindValue(SWTObservables.observeEnabled(ereignisTypComboViewer
				.getControl()), verknuepfeEreignisObservableValue);
		bc.bindValue(SWTObservables.observeEnabled(neuerEreignisTypButton),
				verknuepfeEreignisObservableValue);

		// Visibility
		bc.bindValue(SWTObservables.observeVisible(ereignisTypComboViewer
				.getControl()), computedVisibleValue);
		bc.bindValue(SWTObservables.observeVisible(neuerEreignisTypButton),
				computedVisibleValue);

		// Setze Hyperlink (in)visibile + lade Ereignistypen
		aktualisiereEreignisVerknuepfenComposite();
		aktualisiereEreignisTypenCombo(wrapper.getEreignisTyp());
	}

	/**
	 * Konfiguriere das DataBinding fr die Widget im Bereich "Dauer".
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param realm
	 *            das Realm
	 */
	private void bindDauerBereichValues(final DataBindingContext bc,
			final Realm realm) {

		// Startzeit
		bc.bindValue(new DatumZeitObservableZeitPunkt(realm, vonDatumZeit),
				BeansObservables.observeValue(realm, wrapper,
						EngstellenWrapper.START_ZEIT));

		// Endzeit
		bc.bindValue(new DatumZeitObservableZeitPunkt(realm, bisDatumZeit),
				BeansObservables.observeValue(realm, wrapper,
						EngstellenWrapper.END_ZEIT));

		// Dauer
		bc.bindValue(new CompositeZeitDauerExtendedObservableValue(zeitDauer),
				BeansObservables.observeValue(realm, wrapper,
						EngstellenWrapper.DAUER), null, null);
	}

	/**
	 * Konfiguriere das DataBinding fr die Widget im Bereich "Info".
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param realm
	 *            das Realm
	 */
	private void bindInfoBereichValues(final DataBindingContext bc,
			final Realm realm) {

		final IObservableValue neuesElementObservableValue = BeansObservables
				.observeValue(realm, wrapper, EngstellenWrapper.NEUES_ELEMENT);

		// Kurzinfo
		bc.bindValue(SWTObservables.observeText(kurzinfoText, SWT.Modify),
				BeansObservables.observeValue(realm, wrapper,
						EngstellenWrapper.KURZ_INFO));
		bc.bindValue(SWTObservables.observeEditable(kurzinfoText),
				neuesElementObservableValue);

		// Beschreibung
		bc.bindValue(SWTObservables.observeText(beschreibungText, SWT.Modify),
				BeansObservables.observeValue(realm, wrapper,
						EngstellenWrapper.BESCHREIBUNG), null, null);
		bc.bindValue(SWTObservables.observeEditable(beschreibungText),
				neuesElementObservableValue);
	}

	/**
	 * Konfiguriere das DataBinding fr die Widget im Bereich "Lage".
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param realm
	 *            das Realm
	 * @param defaultStartKnoten
	 *            der Wert fr den Startknoten, welcher nach Initialisierung des
	 *            DataBinding bei der entsprechenden ComboBox ausgewhlt werden
	 *            soll
	 * @param defaultEndKnoten
	 *            der Wert fr den Endknoten, welcher nach Initialisierung des
	 *            DataBinding bei der entsprechenden ComboBox ausgewhlt werden
	 *            soll
	 */
	private void bindLageBereichValues(final DataBindingContext bc,
			final Realm realm, final StrassenKnoten defaultStartKnoten,
			final StrassenKnoten defaultEndKnoten) {

		// Strasse
		if (strasseComboViewer != null && strasseComboViewer.getCombo() != null
				&& !strasseComboViewer.getCombo().isDisposed()) {
			strasseComboViewer.setInput(netzCacheExtended
					.getStrassenMitSegmenten().toArray());
		}
		final IObservableValue strasseObservable = ViewersObservables
				.observeSingleSelection(strasseComboViewer);
		bc.bindValue(strasseObservable, BeansObservables.observeValue(realm,
				wrapper, EngstellenWrapper.STRASSE), null, null);

		// Positive Richtung
		final IObservableValue positiveRichtungObservable = SWTObservables
				.observeSelection(positiveRichtungButton);
		bc.bindValue(positiveRichtungObservable, BeansObservables.observeValue(
				realm, wrapper, EngstellenWrapper.RICHTUNG),
				new UpdateValueStrategy()
						.setConverter(new BooleanToTmcRichtungConverter(
								AttTmcRichtung.ZUSTAND_1_POSITIV)),
				new UpdateValueStrategy()
						.setConverter(new TmcRichtungToBooleanConverter(
								AttTmcRichtung.ZUSTAND_1_POSITIV)));
		if (!(getWrapper() instanceof StauWrapper)) {
			bc.bindValue(SWTObservables.observeEnabled(positiveRichtungButton),
					BeansObservables.observeValue(realm, wrapper,
							EngstellenWrapper.RICHTUNGS_AUSWAHL_MOEGLICH),
					null, null);
		}
		bc.bindValue(SWTObservables.observeText(positiveRichtungButton),
				new RichtungTextComputedValue(netzCache, strasseObservable,
						AttTmcRichtung.ZUSTAND_1_POSITIV, richtungComposite,
						getSite().getShell().getDisplay()));

		// Negative Richtung
		final IObservableValue negativeRichtungObservable = SWTObservables
				.observeSelection(negativeRichtungButton);
		bc.bindValue(negativeRichtungObservable, BeansObservables.observeValue(
				realm, wrapper, EngstellenWrapper.RICHTUNG),
				new UpdateValueStrategy(UpdateValueStrategy.POLICY_NEVER),
				new UpdateValueStrategy()
						.setConverter(new TmcRichtungToBooleanConverter(
								AttTmcRichtung.ZUSTAND_1N_NEGATIV)));
		if (!(getWrapper() instanceof StauWrapper)) {
			bc.bindValue(SWTObservables.observeEnabled(negativeRichtungButton),
					BeansObservables.observeValue(realm, wrapper,
							EngstellenWrapper.RICHTUNGS_AUSWAHL_MOEGLICH),
					null, null);
		}
		bc.bindValue(SWTObservables.observeText(negativeRichtungButton),
				new RichtungTextComputedValue(netzCache, strasseObservable,
						AttTmcRichtung.ZUSTAND_1N_NEGATIV, richtungComposite,
						getSite().getShell().getDisplay()));

		// Startknoten
		final IObservableValue startKnotenObservable = ViewersObservables
				.observeSingleSelection(startKnotenComboViewer);
		bc.bindValue(startKnotenObservable, BeansObservables.observeValue(
				realm, wrapper, EngstellenWrapper.START_KNOTEN), null, null);

		final IObservableList berechneteStartKnotenListe = new ComputedList(
				StrassenKnoten.class) {
			@Override
			protected List<StrassenKnoten> calculate() {
				AttTmcRichtung richtung = AttTmcRichtung.ZUSTAND_1N_NEGATIV;
				if ((Boolean) positiveRichtungObservable.getValue()) {
					richtung = AttTmcRichtung.ZUSTAND_1_POSITIV;
				}

				final Strasse strasse = (Strasse) strasseObservable.getValue();
				if (BauEditorPlugin.getDefault().isStrasseEindeutig()) {
					final KdStrasseFernZiele.Daten fernZiel = strasse
							.getKdStrasseFernZiele().getDatum();
					if (fernZiel != null && fernZiel.getTmcRichtung() != null) {
						richtung = fernZiel.getTmcRichtung();
					}
				}
				List<StrassenKnoten> ergebnis = new ArrayList<StrassenKnoten>();
				if (richtung != null && strasse != null) {
					ergebnis = streckenCache.getStartStrassenKnoten(strasse,
							richtung);
				}

				final UIJob job = new SelectFirstElementOfComboViewerJob(
						startKnotenComboViewer);
				job.schedule(1);

				return ergebnis;
			}
		};
		if (startKnotenComboViewer != null
				&& startKnotenComboViewer.getCombo() != null
				&& !startKnotenComboViewer.getCombo().isDisposed()) {
			startKnotenComboViewer.setInput(berechneteStartKnotenListe);
		}

		// Endknoten
		final IObservableValue endKnotenObservable = ViewersObservables
				.observeSingleSelection(endKnotenComboViewer);
		bc.bindValue(endKnotenObservable, BeansObservables.observeValue(realm,
				wrapper, EngstellenWrapper.END_KNOTEN), null, null);

		final IObservableList berechneteEndKnotenListe = new ComputedList(
				StrassenKnoten.class) {
			@Override
			protected List<StrassenKnoten> calculate() {
				AttTmcRichtung richtung = AttTmcRichtung.ZUSTAND_1N_NEGATIV;
				if ((Boolean) positiveRichtungObservable.getValue()) {
					richtung = AttTmcRichtung.ZUSTAND_1_POSITIV;
				}
				final Strasse strasse = (Strasse) strasseObservable.getValue();
				if (BauEditorPlugin.getDefault().isStrasseEindeutig()) {
					final KdStrasseFernZiele.Daten fernZiel = strasse
							.getKdStrasseFernZiele().getDatum();
					if (fernZiel != null && fernZiel.getTmcRichtung() != null) {
						richtung = fernZiel.getTmcRichtung();
					}
				}
				final StrassenKnoten startKnoten = (StrassenKnoten) startKnotenObservable
						.getValue();

				List<StrassenKnoten> ergebnis = new ArrayList<StrassenKnoten>();
				if (richtung != null && strasse != null && startKnoten != null) {
					ergebnis = streckenCache.getNachfolgerStrassenKnoten(
							strasse, richtung, startKnoten);

					// Fge evtl. auch noch den Startstraenknoten hinzu
					boolean issVorhanden = false;
					if (startKnoten.getInnereStrassenSegmente() != null) {
						for (final InneresStrassenSegment iss : startKnoten
								.getInnereStrassenSegmente()) {
							if (wrapper.getRichtung().equals(
									netzCacheExtended.getRichtung(iss))
									&& wrapper.getStrasse().equals(
											netzCacheExtended.getStrasse(iss))) {
								issVorhanden = true;
								break;
							}

						}
						if (issVorhanden) {
							ergebnis.add(0, startKnoten);
						}
					}
				}

				final UIJob job = new SelectFirstElementOfComboViewerJob(
						endKnotenComboViewer);
				job.schedule(1);

				return ergebnis;
			}
		};
		if (endKnotenComboViewer != null
				&& endKnotenComboViewer.getCombo() != null
				&& !endKnotenComboViewer.getCombo().isDisposed()) {
			endKnotenComboViewer.setInput(berechneteEndKnotenListe);
		}

		// Setze initiale Startstraenknoten
		StrassenKnoten startKnoten = defaultStartKnoten;
		if (startKnotenComboViewer != null
				&& startKnotenComboViewer.getCombo() != null
				&& !startKnotenComboViewer.getCombo().isDisposed()) {
			if (startKnoten == null
					&& startKnotenComboViewer.getElementAt(0) != null) {
				startKnoten = (StrassenKnoten) startKnotenComboViewer
						.getElementAt(0);
			}
			if (startKnoten != null) {
				startKnotenComboViewer.setSelection(new StructuredSelection(
						startKnoten));
			}
		}

		// Setze initiale Endstraenknoten
		StrassenKnoten endKnoten = defaultEndKnoten;
		if (endKnotenComboViewer != null
				&& endKnotenComboViewer.getCombo() != null
				&& !endKnotenComboViewer.getCombo().isDisposed()) {
			if (endKnoten == null
					&& endKnotenComboViewer.getElementAt(0) != null) {
				endKnoten = (StrassenKnoten) endKnotenComboViewer
						.getElementAt(0);
			}
			if (endKnoten != null) {
				endKnotenComboViewer.setSelection(new StructuredSelection(
						endKnoten));
			}
		}
	}

	/**
	 * Konfiguriere das DataBinding fr die Fahrstreifen-Widgets im Bereich
	 * "Kapazitten und gesperrte Fahrstreifen".
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param realm
	 *            das Realm
	 * @param streckenAbschnittObservableValue
	 *            das Observable des aktuellen Streckenabschnitts
	 */
	private void bindBereichFahrstreifenValues(final DataBindingContext bc,
			final Realm realm,
			final IObservableValue streckenAbschnittObservableValue) {

		// Anzahl der Fahrstreifen
		final IObservableValue anzahlFahrstreifenObservable = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.ANZAHL_FAHRSTREIFEN, byte.class);
		bc.bindValue(SWTObservables.observeText(anzahlFahrstreifenInfoLabel),
				new ComputedValue() {
					@Override
					protected Object calculate() {
						final Byte wert = (Byte) anzahlFahrstreifenObservable
								.getValue();
						if (wert <= 0) {
							return "unbekannt";
						}
						return wert.toString();
					}
				}, null, null);

		// Gesperrte Fahrstreifen
		final IObservableList berechneteGesperrteFahrstreifen = new ComputedList(
				StrassenKnoten.class) {
			@Override
			protected List<AttFahrStreifenLage> calculate() {

				// Berechne neuen Input.
				final List<AttFahrStreifenLage> ergebnis = new ArrayList<AttFahrStreifenLage>();
				byte anzahlFahrstreifen = (Byte) anzahlFahrstreifenObservable
						.getValue();
				if (anzahlFahrstreifen <= 0) {
					anzahlFahrstreifen = (byte) AttFahrStreifenLage
							.getZustaende().size();
				}
				for (byte i = 0; i < anzahlFahrstreifen; i++) {
					ergebnis.add(AttFahrStreifenLage.getZustand(i));
				}

				// Hack: Da die nderung des Inputs den CheckedStateListener
				// fr gelschte TableItems NICHT feuert, muss hier nochmals
				// auf falsche gesetzte (nicht mehr enthaltene Lagen)
				// berprft und ggf. das Model hndisch aktualisiert werden
				final Set<AttFahrStreifenLage> dasErgebnis = new HashSet<AttFahrStreifenLage>(
						ergebnis);
				final Job job = new Job("Aktualisiere Check States") {
					@Override
					protected IStatus run(final IProgressMonitor monitor) {

						boolean updateNotwendig = false;
						final Set<AttFahrStreifenLage> fahrstreifen = new HashSet<AttFahrStreifenLage>(
								wrapper.getLageGesperrterFahrstreifen());
						for (final Iterator<AttFahrStreifenLage> iter = fahrstreifen
								.iterator(); iter.hasNext();) {
							final AttFahrStreifenLage lage = iter.next();
							if (!dasErgebnis.contains(lage)) {
								iter.remove();
								updateNotwendig = true;
							}
						}
						if (updateNotwendig) {
							wrapper.setLageGesperrterFahrstreifen(fahrstreifen);
						}
						return Status.OK_STATUS;
					}
				};
				job.schedule(1);

				return ergebnis;
			}
		};
		if (fahrstreifenTableViewer != null
				&& fahrstreifenTableViewer.getTable() != null
				&& !fahrstreifenTableViewer.getTable().isDisposed()) {
			fahrstreifenTableViewer.setItemCount(0);
			fahrstreifenTableViewer.getTable().setVisible(true);
			fahrstreifenTableViewer.setInput(new ListToSetAdapter(
					berechneteGesperrteFahrstreifen));
		}

		// Lage gesperrter Fahrstreifen
		final IViewerObservableSet lageGesperrteFahrstreifenObservable = ViewersObservables
				.observeCheckedElements(fahrstreifenTableViewer,
						AttFahrStreifenLage.class);
		bc.bindSet(lageGesperrteFahrstreifenObservable, BeansObservables
				.observeSet(realm, wrapper,
						EngstellenWrapper.LAGE_GESPERRTER_FAHRSTREIFEN), null,
				null);

		// Anzahl der freien Fahrstreifen
		bc.bindValue(
				SWTObservables.observeText(freieFahrstreifenInfoLabel),
				new ComputedValue() {
					@Override
					protected Object calculate() {
						final Byte anzahlFahrstreifen = (Byte) anzahlFahrstreifenObservable
								.getValue();
						if (anzahlFahrstreifen <= 0) {
							return "unbekannt";
						}
						final int anzahlGesperrterFahrstreifen = lageGesperrteFahrstreifenObservable
								.size();
						return new Integer(anzahlFahrstreifen
								- anzahlGesperrterFahrstreifen).toString();
					}
				}, new UpdateValueStrategy(UpdateValueStrategy.POLICY_NEVER),
				null);
	}

	/**
	 * Konfiguriere das DataBinding fr die Kapazitten-Widgets im Bereich
	 * "Kapazitten und gesperrte Fahrstreifen".
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param realm
	 *            das Realm
	 */
	private void bindKapazitaetenBereichValues(final DataBindingContext bc,
			final Realm realm) {
		String errorText;
		// Restkapazitt
		final WerteBereich kapazitaetWerteBereich = WerteBereich
				.getWerteBereich(AttVerkehrsStaerkeStunde.class);
		final int minKapazitaet = (int) kapazitaetWerteBereich.getMinimum();
		final int maxKapazitaet = (int) kapazitaetWerteBereich.getMaximum();
		final IObservableValue restKapazitaetObservableValue = BeansObservables
				.observeValue(realm, wrapper,
						EngstellenWrapper.REST_KAPAZITAET_PRO_FAHRSTREIFEN);
		errorText = "Bitte geben Sie fr die durchschnittliche Restkapazitt eine Wert zwischen "
				+ minKapazitaet + " und " + maxKapazitaet + " ein!";
		bc.bindValue(
				SWTObservables.observeText(restKapazitaetText, SWT.Modify),
				restKapazitaetObservableValue,
				new UpdateValueStrategy()
						.setConverter(
								StringToNumberConverter.toInteger(
										intNumberFormat, true))
						.setAfterConvertValidator(
								new MessageValidator(
										EngstellenWrapper.REST_KAPAZITAET_PRO_FAHRSTREIFEN,
										messageManager, restKapazitaetText,
										new IntegerValidator(
												IntervallType.Geschlossen,
												minKapazitaet, maxKapazitaet,
												false, errorText) {
										})), new UpdateValueStrategy()
						.setConverter(NumberToStringConverter.fromInteger(
								intNumberFormat, true)));

		// Engpasskapazitt
		final IObservableValue engpassKapazitaetObservableValue = BeansObservables
				.observeValue(realm, wrapper,
						EngstellenWrapper.ENGPASS_KAPAZITAET);
		errorText = "Bitte geben Sie fr die Engpasskapazitt eine Wert zwischen "
				+ minKapazitaet + " und " + maxKapazitaet + " ein!";
		bc.bindValue(
				SWTObservables.observeText(engpassKapazitaetText, SWT.Modify),
				engpassKapazitaetObservableValue,
				new UpdateValueStrategy().setConverter(
						StringToNumberConverter
								.toInteger(intNumberFormat, true))
						.setAfterConvertValidator(
								new MessageValidator(
										EngstellenWrapper.ENGPASS_KAPAZITAET,
										messageManager, engpassKapazitaetText,
										new IntegerValidator(
												IntervallType.Geschlossen,
												minKapazitaet, maxKapazitaet,
												false, errorText))),
				new UpdateValueStrategy().setConverter(NumberToStringConverter
						.fromInteger(intNumberFormat, true)));
	}

	/**
	 * Konfiguriere das DataBinding fr die Offset-Widgets im Bereich "Lage".
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param streckenAbschnittObservableValue
	 *            das Observable des aktuellen Streckenabschnitts
	 * 
	 * @return das Observable des aktuellen Streckenabschnitts
	 */
	private IObservableValue bindOffsetValues(final DataBindingContext bc,
			final IObservableValue streckenAbschnittObservableValue) {

		// Observable Values
		final IObservableValue startOffsetObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.START_OFFSET, double.class);
		final IObservableValue maxStartOffsetObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.MAX_START_OFFSET, double.class);
		final IObservableValue endOffsetObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.END_OFFSET, double.class);
		final IObservableValue maxEndOffsetObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.MAX_END_OFFSET, double.class);

		final double minStreckeMeter = WerteBereich.getWerteBereich(
				AttStreckeMeter.class).getMinimum();
		startOffsetBinding = bc.bindValue(
				SWTObservables.observeText(startOffsetText, SWT.Modify),
				startOffsetObservableValue,
				new UpdateValueStrategy().setConverter(
						StringToNumberConverter.toDouble(doubleNumberFormat,
								true)).setAfterConvertValidator(
						new IValidator() {
							public IStatus validate(final Object value) {

								final String key = EngstellenWrapper.START_OFFSET;
								final Double endOffset = (Double) endOffsetObservableValue
										.getValue();

								if (value instanceof Double) {
									final double wert = (Double) value;
									final double minValue = minStreckeMeter / 1000d;
									final double maxValue = (Double) maxStartOffsetObservableValue
											.getValue();
									if (wert < minValue || wert > maxValue) {
										final String errorText = "Bitte geben Sie den Start-Offset im gltigen Wertebereich ein!";
										startOffsetTextDecoration
												.setDescriptionText(errorText);
										startOffsetTextDecoration.show();
										messageManager.addMessage(key,
												errorText, null,
												IMessageProvider.ERROR);
										return ValidationStatus
												.error(errorText);
									} else {

										final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
												.getValue();
										if (wert > endOffset
												&& streckenAbschnitt != null
												&& streckenAbschnitt
														.getAeussereStrassenSegmente()
														.size() < 2) {

											final String errorText = "Der Start-Offset darf nicht grer als der End-Offset sein!";
											startOffsetTextDecoration
													.setDescriptionText(errorText);
											startOffsetTextDecoration.show();
											messageManager.addMessage(key,
													errorText, null,
													IMessageProvider.ERROR);
											return ValidationStatus
													.error(errorText);

										}
									}
								}
								messageManager.removeMessage(key);
								startOffsetTextDecoration
										.setDescriptionText("");
								startOffsetTextDecoration.hide();
								return Status.OK_STATUS;
							}
						}), new UpdateValueStrategy()
						.setConverter(NumberToStringConverter.fromDouble(
								doubleNumberFormat, true)));

		bc.bindValue(SWTObservables.observeText(startOffsetInfoLabel),
				maxStartOffsetObservableValue, new UpdateValueStrategy(
						UpdateValueStrategy.POLICY_NEVER),
				new UpdateValueStrategy()
						.setConverter(new DoubleToOffsetInfoStringConverter()));

		endOffsetBinding = bc.bindValue(
				SWTObservables.observeText(endOffsetText, SWT.Modify),
				endOffsetObservableValue,
				new UpdateValueStrategy().setConverter(
						StringToNumberConverter.toDouble(doubleNumberFormat,
								true)).setAfterConvertValidator(
						new IValidator() {
							public IStatus validate(final Object value) {

								final String key = EngstellenWrapper.END_OFFSET;
								final Double startOffset = (Double) startOffsetObservableValue
										.getValue();

								if (value instanceof Double) {
									final double wert = (Double) value;
									final double minValue = minStreckeMeter / 1000d;
									final double maxValue = (Double) maxEndOffsetObservableValue
											.getValue();
									if (wert < minValue || wert > maxValue) {
										final String errorText = "Bitte geben Sie den End-Offset im gltigen Wertebereich ein!";
										endOffsetTextDecoration
												.setDescriptionText(errorText);
										endOffsetTextDecoration.show();
										messageManager.addMessage(key,
												errorText, null,
												IMessageProvider.ERROR);
										return ValidationStatus
												.error(errorText);
									} else {
										final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
												.getValue();
										if (wert < startOffset
												&& streckenAbschnitt != null
												&& streckenAbschnitt
														.getAeussereStrassenSegmente()
														.size() < 2) {

											final String errorText = "Der End-Offset darf nicht kleiner als der Start-Offset sein!";
											endOffsetTextDecoration
													.setDescriptionText(errorText);
											endOffsetTextDecoration.show();
											messageManager.addMessage(key,
													errorText, null,
													IMessageProvider.ERROR);
											return ValidationStatus
													.error(errorText);
										}
									}
								}
								messageManager.removeMessage(key);
								endOffsetTextDecoration.setDescriptionText("");
								endOffsetTextDecoration.hide();
								return Status.OK_STATUS;
							}
						}), new UpdateValueStrategy()
						.setConverter(NumberToStringConverter.fromDouble(
								doubleNumberFormat, true)));

		bc.bindValue(SWTObservables.observeText(endOffsetInfoLabel),
				maxEndOffsetObservableValue, new UpdateValueStrategy(
						UpdateValueStrategy.POLICY_NEVER),
				new UpdateValueStrategy()
						.setConverter(new DoubleToOffsetInfoStringConverter()));
		return streckenAbschnittObservableValue;
	}

	/**
	 * Konfiguriere das DataBinding fr die Start-Betriebskilometer-Widgets im
	 * Bereich "Lage".
	 * 
	 * @param bc
	 *            der DataBindingContext
	 * @param streckenAbschnittObservableValue
	 *            das Observable des aktuellen Streckenabschnitts
	 */
	private void bindBetriebsKilometerValues(final DataBindingContext bc,
			final IObservableValue streckenAbschnittObservableValue) {

		final IObservableValue startBetriebsKilometerObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.START_BETRIEBS_KILOMETER,
						double.class);
		final IObservableValue startBetriebsKilometerBereichObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.START_BETRIEBS_KILOMETER_BEREICH,
						Intervall.class);
		final IObservableValue endBetriebsKilometerObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.END_BETRIEBS_KILOMETER, double.class);
		final IObservableValue endBetriebsKilometerBereichObservableValue = BeansObservables
				.observeDetailValue(streckenAbschnittObservableValue,
						EngstellenWrapper.END_BETRIEBS_KILOMETER_BEREICH,
						Intervall.class);

		// (1) Start-Betriebskilometer

		// (1.1) Blocknummer
		bc.bindValue(
				ViewersObservables
						.observeSingleSelection(startBlockNummerComboViewer),
				BeansObservables
						.observeDetailValue(
								streckenAbschnittObservableValue,
								EngstellenWrapper.START_BETRIEBS_KILOMETER_BLOCK_NUMMER,
								String.class), null, null);

		final IObservableList berechneteStartBlockNummern = new ComputedList(
				StrassenKnoten.class) {
			@Override
			protected List<String> calculate() {
				final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
						.getValue();
				List<String> ergebnis = new ArrayList<String>();
				if (streckenAbschnitt.getStartSegment() != null) {
					ergebnis = strassenTeilSegmenteCache
							.getBlockNummern(streckenAbschnitt
									.getStartSegment());
				}
				final UIJob job = new SelectFirstElementOfComboViewerJob(
						startBlockNummerComboViewer);
				job.schedule(1);

				return ergebnis;
			}
		};
		if (startBlockNummerComboViewer != null
				&& startBlockNummerComboViewer.getCombo() != null
				&& !startBlockNummerComboViewer.getCombo().isDisposed()) {
			startBlockNummerComboViewer.setInput(berechneteStartBlockNummern);
		}

		bc.bindValue(SWTObservables.observeEnabled(startBlockNummerComboViewer
				.getControl()), new ComputedValue() {
			@Override
			protected Object calculate() {
				final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
						.getValue();
				List<String> ergebnis = new ArrayList<String>();
				if (streckenAbschnitt.getStartSegment() != null) {
					ergebnis = strassenTeilSegmenteCache
							.getBlockNummern(streckenAbschnitt
									.getStartSegment());
				}
				return ergebnis.size() > 1;
			}
		});

		// (1.2) Betriebskilometer
		startBetriebsKilometerBinding = bc.bindValue(
				SWTObservables.observeText(startBetriebsKilometerText,
						SWT.Modify),
				startBetriebsKilometerObservableValue,
				new UpdateValueStrategy().setConverter(
						StringToNumberConverter.toDouble(doubleNumberFormat,
								true)).setAfterConvertValidator(
						new IValidator() {
							public IStatus validate(final Object value) {
								final String key = EngstellenWrapper.START_BETRIEBS_KILOMETER;
								if (value instanceof Double) {
									final double wert = (Double) value;
									final Intervall intervall = (Intervall) startBetriebsKilometerBereichObservableValue
											.getValue();
									if (intervall != null) {
										String errorText = "Bitte geben Sie den Start-Betriebskilometer im gltigen Wertebereich ein!";
										if (wert < intervall.getMin()
												|| wert > intervall.getMax()) {
											startBetriebsKilometerTextDecoration
													.setDescriptionText(errorText);
											startBetriebsKilometerTextDecoration
													.show();
											messageManager.addMessage(key,
													errorText, null,
													IMessageProvider.ERROR);
											return ValidationStatus
													.error(errorText);
										} else {

											final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
													.getValue();
											final Double endBetriebsKilometer = (Double) endBetriebsKilometerObservableValue
													.getValue();

											if (intervall.istAufsteigend()) {
												if (wert > endBetriebsKilometer
														&& streckenAbschnitt != null
														&& streckenAbschnitt
																.getAeussereStrassenSegmente()
																.size() < 2) {

													errorText = "Der Start-Betriebskilometer darf nicht grer als der End-Betriebskilometer sein!";
													startBetriebsKilometerTextDecoration
															.setDescriptionText(errorText);
													startBetriebsKilometerTextDecoration
															.show();
													messageManager
															.addMessage(
																	key,
																	errorText,
																	null,
																	IMessageProvider.ERROR);
													return ValidationStatus
															.error(errorText);
												}
											} else if (wert < endBetriebsKilometer
													&& streckenAbschnitt != null
													&& streckenAbschnitt
															.getAeussereStrassenSegmente()
															.size() < 2) {

												errorText = "Der Start-Betriebskilometer darf nicht kleiner als der End-Betriebskilometer sein!";
												startBetriebsKilometerTextDecoration
														.setDescriptionText(errorText);
												startBetriebsKilometerTextDecoration
														.show();
												messageManager.addMessage(key,
														errorText, null,
														IMessageProvider.ERROR);
												return ValidationStatus
														.error(errorText);
											}
										}
									}
								}
								messageManager.removeMessage(key);
								startBetriebsKilometerTextDecoration
										.setDescriptionText("");
								startBetriebsKilometerTextDecoration.hide();
								return Status.OK_STATUS;
							}
						}), new UpdateValueStrategy()
						.setConverter(NumberToStringConverter.fromDouble(
								doubleNumberFormat, true)));

		bc.bindValue(SWTObservables.observeEnabled(startBetriebsKilometerText),
				new ComputedValue() {
					@Override
					protected Object calculate() {
						final Intervall intervall = (Intervall) startBetriebsKilometerBereichObservableValue
								.getValue();
						return intervall != null;
					}
				}, null, null);

		// (1.3) Info-Label
		bc.bindValue(SWTObservables
				.observeText(startBetriebsKilometerInfoLabel),
				startBetriebsKilometerBereichObservableValue,
				new UpdateValueStrategy(UpdateValueStrategy.POLICY_NEVER),
				new UpdateValueStrategy()
						.setConverter(new IntervallToInfoStringConverter()));

		bc.bindValue(SWTObservables
				.observeForeground(startBetriebsKilometerInfoLabel),
				new ComputedValue() {
					@Override
					protected Object calculate() {
						final Intervall intervall = (Intervall) startBetriebsKilometerBereichObservableValue
								.getValue();
						if (intervall != null) {
							return BauEditorPlugin
									.getSystemColor(SWT.COLOR_BLACK);
						} else {
							return BauEditorPlugin
									.getSystemColor(SWT.COLOR_RED);
						}
					}
				}, null, null);

		// (2) End-Betriebskilometer

		// (2.1) Blocknummer
		bc.bindValue(ViewersObservables
				.observeSingleSelection(endBlockNummerComboViewer),
				BeansObservables.observeDetailValue(
						streckenAbschnittObservableValue,
						EngstellenWrapper.END_BETRIEBS_KILOMETER_BLOCK_NUMMER,
						String.class), null, null);

		final IObservableList berechneteEndBlockNummern = new ComputedList(
				StrassenKnoten.class) {
			@Override
			protected List<String> calculate() {
				final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
						.getValue();
				List<String> ergebnis = new ArrayList<String>();
				if (streckenAbschnitt.isStartGleichEndKnoten()
						&& streckenAbschnitt.getEndSegment() != null) {
					ergebnis = strassenTeilSegmenteCache
							.getBlockNummern(streckenAbschnitt.getEndSegment());
				} else if (streckenAbschnitt.getEndASS() != null) {
					ergebnis = strassenTeilSegmenteCache
							.getBlockNummern(streckenAbschnitt.getEndASS());
				}

				final UIJob job = new SelectFirstElementOfComboViewerJob(
						endBlockNummerComboViewer);
				job.schedule(1);

				return ergebnis;
			}
		};
		if (endBlockNummerComboViewer != null
				&& endBlockNummerComboViewer.getCombo() != null
				&& !endBlockNummerComboViewer.getCombo().isDisposed()) {
			endBlockNummerComboViewer.setInput(berechneteEndBlockNummern);
		}

		bc.bindValue(SWTObservables.observeEnabled(endBlockNummerComboViewer
				.getControl()), new ComputedValue() {
			@Override
			protected Object calculate() {
				final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
						.getValue();
				List<String> ergebnis = new ArrayList<String>();
				if (streckenAbschnitt.isStartGleichEndKnoten()
						&& streckenAbschnitt.getEndSegment() != null) {
					ergebnis = strassenTeilSegmenteCache
							.getBlockNummern(streckenAbschnitt.getEndSegment());
				} else if (streckenAbschnitt.getEndASS() != null) {
					ergebnis = strassenTeilSegmenteCache
							.getBlockNummern(streckenAbschnitt.getEndASS());
				}
				return ergebnis.size() > 1;
			}
		});

		// (2.2) Betriebskilometer
		endBetriebsKilometerBinding = bc.bindValue(
				SWTObservables
						.observeText(endBetriebsKilometerText, SWT.Modify),
				endBetriebsKilometerObservableValue,
				new UpdateValueStrategy().setConverter(
						StringToNumberConverter.toDouble(doubleNumberFormat,
								true)).setAfterConvertValidator(
						new IValidator() {
							public IStatus validate(final Object value) {
								final String key = EngstellenWrapper.END_BETRIEBS_KILOMETER;
								if (value instanceof Double) {
									final double wert = (Double) value;
									final Intervall intervall = (Intervall) endBetriebsKilometerBereichObservableValue
											.getValue();
									if (intervall != null) {
										String errorText = "Bitte geben Sie den End-Betriebskilometer im gltigen Wertebereich ein!";
										if (wert < intervall.getMin()
												|| wert > intervall.getMax()) {
											endBetriebsKilometerTextDecoration
													.setDescriptionText(errorText);
											endBetriebsKilometerTextDecoration
													.show();
											messageManager.addMessage(key,
													errorText, null,
													IMessageProvider.ERROR);
											return ValidationStatus
													.error(errorText);
										} else {

											final StreckenAbschnitt streckenAbschnitt = (StreckenAbschnitt) streckenAbschnittObservableValue
													.getValue();
											final Double startBetriebsKilometer = (Double) startBetriebsKilometerObservableValue
													.getValue();

											if (intervall.istAufsteigend()) {
												if (wert < startBetriebsKilometer
														&& streckenAbschnitt != null
														&& streckenAbschnitt
																.getAeussereStrassenSegmente()
																.size() < 2) {

													errorText = "Der End-Betriebskilometer darf nicht kleiner als der Start-Betriebskilometer sein!";
													endBetriebsKilometerTextDecoration
															.setDescriptionText(errorText);
													endBetriebsKilometerTextDecoration
															.show();
													messageManager
															.addMessage(
																	key,
																	errorText,
																	null,
																	IMessageProvider.ERROR);
													return ValidationStatus
															.error(errorText);
												}
											} else if (wert > startBetriebsKilometer
													&& streckenAbschnitt != null
													&& streckenAbschnitt
															.getAeussereStrassenSegmente()
															.size() < 2) {

												errorText = "Der End-Betriebskilometer darf nicht grer als der Start-Betriebskilometer sein!";
												endBetriebsKilometerTextDecoration
														.setDescriptionText(errorText);
												endBetriebsKilometerTextDecoration
														.show();
												messageManager.addMessage(key,
														errorText, null,
														IMessageProvider.ERROR);
												return ValidationStatus
														.error(errorText);
											}
										}
									}
								}
								messageManager.removeMessage(key);
								endBetriebsKilometerTextDecoration
										.setDescriptionText("");
								endBetriebsKilometerTextDecoration.hide();
								return Status.OK_STATUS;
							}
						}), new UpdateValueStrategy()
						.setConverter(NumberToStringConverter.fromDouble(
								doubleNumberFormat, true)));

		bc.bindValue(SWTObservables.observeEnabled(endBetriebsKilometerText),
				new ComputedValue() {
					@Override
					protected Object calculate() {
						final Intervall intervall = (Intervall) endBetriebsKilometerBereichObservableValue
								.getValue();
						return intervall != null;
					}
				}, null, null);

		// (2.3) Info-Label
		bc.bindValue(SWTObservables.observeText(endBetriebsKilometerInfoLabel),
				endBetriebsKilometerBereichObservableValue,
				new UpdateValueStrategy(UpdateValueStrategy.POLICY_NEVER),
				new UpdateValueStrategy()
						.setConverter(new IntervallToInfoStringConverter()));

		bc.bindValue(
				SWTObservables.observeForeground(endBetriebsKilometerInfoLabel),
				new ComputedValue() {
					@Override
					protected Object calculate() {
						final Intervall intervall = (Intervall) endBetriebsKilometerBereichObservableValue
								.getValue();
						if (intervall != null) {
							return BauEditorPlugin
									.getSystemColor(SWT.COLOR_BLACK);
						} else {
							return BauEditorPlugin
									.getSystemColor(SWT.COLOR_RED);
						}
					}
				}, null, null);
	}

	@Override
	public void createPartControl(final Composite parent) {

		// Initialisiere Formularseite
		final FormToolkit toolkit = new FormToolkit(parent.getDisplay());
		form = toolkit.createScrolledForm(parent);
		managedForm = new ManagedForm(toolkit, form);
		messageManager = managedForm.getMessageManager();
		form.setImage(titleImage);
		form.setText(((EngstellenEditorInput) getEditorInput()).getTyp());

		// Erzeuge Kopfbereich mit Symbolleiste
		toolkit.decorateFormHeading(form.getForm());
		final Composite headComposite = toolkit.createComposite(form.getForm()
				.getHead(), SWT.NONE);
		headComposite.setBackground(null);

		final TableWrapLayout layout = new TableWrapLayout();
		layout.numColumns = 5;
		layout.leftMargin = 15;
		layout.rightMargin = 2;
		layout.topMargin = 5;
		layout.bottomMargin = 5;
		layout.horizontalSpacing = 5;
		layout.verticalSpacing = 5;
		headComposite.setLayout(layout);

		erzeugeKopfBereich(toolkit, headComposite);
		form.setHeadClient(headComposite);

		// Erzeuge Hauptbereich mit Sections
		final Composite body = form.getBody();
		toolkit.paintBordersFor(body);

		final TableWrapLayout bodyLayout = new TableWrapLayout();
		bodyLayout.numColumns = 3;
		bodyLayout.leftMargin = 5;
		bodyLayout.rightMargin = 5;
		bodyLayout.topMargin = 10;
		bodyLayout.bottomMargin = 10;
		bodyLayout.horizontalSpacing = 10;
		bodyLayout.verticalSpacing = 20;
		body.setLayout(bodyLayout);

		erzeugeSections(toolkit, body);

		// Erzeuge Symbolleiste im Kopfbereich
		erzeugeKopfbereichSymbolleiste(toolkit);

		// Initialisiere
		setEnablement(true);
		bindValues();
		form.reflow(true);

		selectionProviderWrapper = new SelectionProviderWrapper();
		getSite().setSelectionProvider(selectionProviderWrapper);

		DefaultHelpContext.registerDefaultHelpContext(form,
				EngstellenEditor.class);
	}

	/**
	 * Erzeugt den Kopfbereich dieses Editors.
	 * 
	 * @param toolkit
	 *            das aktuelle FormToolkit
	 * @param parent
	 *            das Parent-Control
	 */
	protected abstract void erzeugeKopfBereich(final FormToolkit toolkit,
			final Composite parent);

	/**
	 * Erzeugt das Namenstextfeld im Kopfbereich dieses Editors.
	 * 
	 * @param toolkit
	 *            das aktuelle FormToolkit
	 * @param parent
	 *            das Parent-Control
	 * 
	 * @return das Textfeld
	 */
	protected Text erzeugeNamensTextFeld(final FormToolkit toolkit,
			final Composite parent) {

		final Label nameLabel = toolkit.createLabel(parent, "Name:");
		nameLabel.setBackground(null);
		nameLabel.setLayoutData(new TableWrapData(TableWrapData.LEFT,
				TableWrapData.MIDDLE));
		nameText = toolkit.createText(parent, "", SWT.BORDER);
		return nameText;
	}

	/**
	 * Erzeugt die Kopfbereichszeile fr die Ereignis-Definition.
	 * 
	 * @param toolkit
	 *            das aktuelle FormToolkit
	 * @param parent
	 *            das Parent-Control
	 * 
	 * @return das Composite mit smtlichen Widgets rechts von der Checkbox
	 */
	protected Composite erzeugeEreignisKopfbereichZeile(
			final FormToolkit toolkit, final Composite parent) {

		// Ereignis Checkbox
		ereignisCheckbox = toolkit.createButton(parent, "", SWT.CHECK);
		ereignisCheckbox.addFocusListener(getFocusListener(null));
		ereignisCheckbox.setBackground(null);
		ereignisCheckbox.setLayoutData(new TableWrapData(TableWrapData.RIGHT,
				TableWrapData.MIDDLE));

		// Ereignis Composite
		final Composite ereignisComposite = toolkit.createComposite(parent);
		ereignisComposite.setBackground(null);
		final TableWrapLayout layout = new TableWrapLayout();
		layout.numColumns = 3;
		layout.leftMargin = 0;
		layout.rightMargin = 0;
		layout.topMargin = 0;
		layout.bottomMargin = 5;
		layout.horizontalSpacing = 5;
		layout.verticalSpacing = 5;
		ereignisComposite.setLayout(layout);

		// Verknpfung Composite
		ereignisVerknuepfenStackLayout = new StackLayout();
		ereignisVerknuepfenComposite = toolkit
				.createComposite(ereignisComposite);
		ereignisVerknuepfenComposite.setBackground(null);
		ereignisVerknuepfenComposite.setLayout(ereignisVerknuepfenStackLayout);
		ereignisVerknuepfenComposite.setLayoutData(new TableWrapData(
				TableWrapData.FILL, TableWrapData.MIDDLE));

		// Verknpfe Label
		ereignisVerknuepfenLabel = toolkit.createLabel(
				ereignisVerknuepfenComposite,
				"Verknpfung mit Ereignis vom Typ:", SWT.NONE);
		ereignisVerknuepfenLabel.setBackground(null);
		ereignisVerknuepfenLabel.setLayoutData(new TableWrapData(
				TableWrapData.FILL, TableWrapData.MIDDLE));

		// Verknpfe Hyperlink
		ereignisVerknuepfenHyperlink = toolkit.createHyperlink(
				ereignisVerknuepfenComposite, "Verknpfung mit Ereignis",
				SWT.NONE);
		ereignisVerknuepfenHyperlink.addFocusListener(getFocusListener(null));
		ereignisVerknuepfenHyperlink.setBackground(null);
		ereignisVerknuepfenHyperlink
				.addHyperlinkListener(new HyperlinkAdapter() {
					@Override
					public void linkActivated(final HyperlinkEvent e) {
						final EreignisBearbeitenAktion aktion = new EreignisBearbeitenAktion(
								wrapper.getEreignis());
						aktion.run();
					}
				});
		ereignisVerknuepfenHyperlink.setLayoutData(new TableWrapData(
				TableWrapData.FILL, TableWrapData.MIDDLE));
		ereignisVerknuepfenStackLayout.topControl = ereignisVerknuepfenLabel;

		ereignisTypComboViewer = new ComboViewer(ereignisComposite,
				SWT.READ_ONLY);
		ereignisTypComboViewer
				.setLabelProvider(new SystemObjectTypeLabelProvider(true));
		ereignisTypComboViewer.setContentProvider(new ArrayContentProvider());
		ereignisTypComboViewer.setSorter(new ViewerSorter());
		ereignisTypComboViewer.getControl().addFocusListener(
				getFocusListener(ereignisTypComboViewer));
		ereignisTypComboViewer.getControl()
				.setLayoutData(
						new TableWrapData(TableWrapData.FILL_GRAB,
								TableWrapData.MIDDLE));

		// Button zum Anlegen neuer Ereignistypen
		neuerEreignisTypButton = toolkit.createButton(ereignisComposite, "",
				SWT.PUSH);
		neuerEreignisTypButton.addFocusListener(getFocusListener(null));
		neuerEreignisTypButton.setToolTipText("Neuen Ereignistyp anlegen");
		neuerEreignisTypButton.setImage(BauEditorPlugin.getDefault().getImage(
				BildDateiPfade.EREIGNISTYP_ANLEGEN));

		neuerEreignisTypButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				neuenEreignisTypAngelegt = true;
				final EreignisTypAnlegenAktion aktion = new EreignisTypAnlegenAktion();
				aktion.run();
				neuenEreignisTypAngelegt = false;
			}
		});

		return ereignisComposite;
	}

	/**
	 * Aktualisiert das Ereignis-Composite.
	 */
	private void aktualisiereEreignisVerknuepfenComposite() {
		final Display display = Display.getDefault();
		if (display != null && !display.isDisposed()) {
			display.syncExec(new Runnable() {
				@Override
				public void run() {
					if (ereignisVerknuepfenComposite == null
							|| ereignisVerknuepfenComposite.isDisposed()) {
						return;
					}
					if (wrapper.getEreignis() == null) {
						ereignisVerknuepfenStackLayout.topControl = ereignisVerknuepfenLabel;
					} else {
						ereignisVerknuepfenStackLayout.topControl = ereignisVerknuepfenHyperlink;
					}
					ereignisVerknuepfenComposite.layout();
				}
			});
		}
	}

	/**
	 * Aktualisiert den ComboViewer zur Auswahl des Ereignistyps.
	 * 
	 * @param ereignisTyp
	 *            der Ereignistyp, welcher ausgewhlt werden soll, oder
	 *            <code>null</code>
	 */
	private void aktualisiereEreignisTypenCombo(final EreignisTyp ereignisTyp) {

		final Job ereignisTypenAktualisierenJob = new UIJob(
				"Aktualisiere Ereignistypen") {

			@Override
			public IStatus runInUIThread(final IProgressMonitor monitor) {

				if (ereignisTypComboViewer == null
						|| ereignisTypComboViewer.getCombo() == null
						|| ereignisTypComboViewer.getCombo().isDisposed()) {
					return Status.OK_STATUS;
				}

				final boolean viewerEnablement = ereignisTypComboViewer
						.getControl().isEnabled();

				// (0) Merke den zuvor selektierte Ereignistyp
				Object first = null;
				final IStructuredSelection selection = (IStructuredSelection) ereignisTypComboViewer
						.getSelection();
				if (viewerEnablement && selection != null
						&& !selection.isEmpty()) {
					first = selection.getFirstElement();
				}

				// (1) Aktualisiere den ComboViewer - setze den neuen Input
				final Object input = ereignisTypComboViewer.getInput();
				final AenderbareMenge<EreignisTyp> ereignisTypen = BauEditorPlugin
						.getDefault().getAOE().getEreignisTypen();
				if (input == null) {
					ereignisTypComboViewer.setInput(ereignisTypen);
				} else {
					ereignisTypComboViewer.refresh(true);
				}

				// (2) Selektiere ggf. den bergebenen Ereignistyp
				if (ereignisTyp != null && ereignisTypen != null
						&& ereignisTypen.contains(ereignisTyp)) {
					ereignisTypComboViewer
							.setSelection(new StructuredSelection(ereignisTyp));
				} else

				// (3) Selektiere ggf. den zuvor selektierten Ereignistyp erneut
				if (first != null && ereignisTypen.contains(first)) {
					ereignisTypComboViewer
							.setSelection(new StructuredSelection(first));
				} else

				// (4) Bei leerer Selektion (also leere Selektion zuvor oder
				// wenn die zuvorige Selektion nicht mehr auswhlbar ist),
				// whle standardmig einen Ereignistyp aus, welcher das Wort
				// "Baustelle" bzw. "Unfall" im Namen trgt
				if (!viewerEnablement
						|| "".equals(ereignisTypComboViewer.getCombo()
								.getText())) {
					final List<EreignisTyp> sortierteEreignisTypen = new ArrayList<EreignisTyp>(
							ereignisTypen);
					Collections.sort(sortierteEreignisTypen,
							new Comparator<EreignisTyp>() {
								@Override
								public int compare(final EreignisTyp o1,
										final EreignisTyp o2) {
									return o1.getName().compareTo(o2.getName());
								}
							});
					final String typName = ((EngstellenEditorInput) getEditorInput())
							.getTyp().toLowerCase();
					for (final EreignisTyp ereignisTyp : sortierteEreignisTypen) {
						if (ereignisTyp.getName().toLowerCase()
								.contains(typName)) {
							ereignisTypComboViewer
									.setSelection(new StructuredSelection(
											ereignisTyp));
							break;
						}
					}
				}

				// (5) Bei leerer Selektion (es gab also keinen Ereignistyp mit
				// passendem Namen), selektiere wenigstens den ersten Eintrag
				if ("".equals(ereignisTypComboViewer.getCombo().getText())
						&& ereignisTypComboViewer.getCombo().getItemCount() > 0) {
					ereignisTypComboViewer.getCombo().select(0);
				}

				return Status.OK_STATUS;
			}
		};
		ereignisTypenAktualisierenJob.schedule();
	}

	/**
	 * Erzeugt den Kopfbereich.
	 * 
	 * @param toolkit
	 *            das aktuelle FormToolkit
	 */
	protected void erzeugeKopfbereichSymbolleiste(final FormToolkit toolkit) {
		final IToolBarManager toolbar = form.getForm().getToolBarManager();

		// final ToggleVisibleComponentsAction segmenteSichtbarkeitsAction = new
		// ToggleVisibleComponentsAction(
		// "Segmente ausblenden", form, segmenteSection, null,
		// dummyComposite);
		// toolbar.add(segmenteSichtbarkeitsAction);
		// final Separator separator = new Separator();
		// toolbar.add(separator);

		final ControlContribution refesh = new ControlContribution(
				"Zurcksetzen") {
			@Override
			protected Control createControl(final Composite parent) {
				refreshButton = toolkit.createButton(parent, "", SWT.PUSH);
				refreshButton.setBackground(null);
				refreshButton.setToolTipText("Zurcksetzen");
				refreshButton.setImage(BauEditorPlugin.getDefault().getImage(
						BildDateiPfade.AKTUALISIEREN));
				refreshButton.addSelectionListener(new SelectionAdapter() {
					@Override
					public void widgetSelected(final SelectionEvent e) {
						doRefesh();
					}
				});
				refreshButton.setEnabled(false);
				return refreshButton;
			}
		};
		toolbar.add(refesh);

		// save contribution item
		final ControlContribution save = new ControlContribution("Speichern") {

			@Override
			protected Control createControl(final Composite parent) {
				saveButton = toolkit.createButton(parent, "", SWT.PUSH);
				saveButton.setBackground(null);
				saveButton.setToolTipText("Speichern");
				saveButton.setImage(BauEditorPlugin.getDefault().getImage(
						ISharedImages.IMG_ETOOL_SAVE_EDIT));
				saveButton.addSelectionListener(new SelectionAdapter() {
					@Override
					public void widgetSelected(final SelectionEvent e) {
						doSave(new NullProgressMonitor());
					}
				});
				return saveButton;
			}
		};
		toolbar.add(save);

		form.getForm().updateToolBar();
		toolbar.update(true);
		form.getForm().setToolBarVerticalAlignment(SWT.TOP);
	}

	/**
	 * Erzeugt smtliche Sections (Bereiche) dieses Editors.
	 * 
	 * @param toolkit
	 *            das aktuelle FormToolkit
	 * @param composite
	 *            das Parent-Control
	 */
	protected abstract void erzeugeSections(FormToolkit toolkit,
			Composite composite);

	/**
	 * Erzeugt die Lage-Section.
	 * 
	 * @param toolkit
	 *            das aktuelle FormToolkit
	 * @param parent
	 *            das Parent-Composite
	 * 
	 * @return die Section
	 */
	protected Section erzeugeLageSection(final FormToolkit toolkit,
			final Composite parent) {

		final int textWidth = 230;
		final int blockNummerWidth = 30;

		final Section section = toolkit.createSection(parent,
				SECTION_STYLE_MIT_TWISTIE);
		section.setText("Lage");

		final Composite composite = toolkit.createComposite(section);
		final TableWrapLayout layout = new TableWrapLayout();
		layout.numColumns = 5;
		layout.topMargin = 5;
		layout.verticalSpacing = 5;
		layout.horizontalSpacing = 10;
		composite.setLayout(layout);
		section.setClient(composite);

		// (1.1) Strae
		final Label strasseLabel = toolkit.createLabel(composite, "Strae:");
		strasseLabel.setLayoutData(new TableWrapData(TableWrapData.LEFT,
				TableWrapData.MIDDLE));
		strasseComboViewer = new ComboViewer(composite, SWT.READ_ONLY);
		strasseComboViewer.getControl().addFocusListener(
				getFocusListener(strasseComboViewer));
		strasseComboViewer.setLabelProvider(new SystemObjectTypeLabelProvider(
				true));
		strasseComboViewer.setContentProvider(new ArrayContentProvider());
		strasseComboViewer.getCombo()
				.setLayoutData(
						new TableWrapData(TableWrapData.FILL,
								TableWrapData.FILL, 1, 4));

		// (1.2) Richtung
		final Label richtungLabel = toolkit.createLabel(composite, "Richtung:");
		richtungLabel.setLayoutData(new TableWrapData(TableWrapData.LEFT,
				TableWrapData.MIDDLE));
		richtungComposite = toolkit.createComposite(composite);
		final TableWrapLayout richtungCompositeLayout = new TableWrapLayout();
		richtungCompositeLayout.numColumns = 2;
		richtungComposite.setLayout(richtungCompositeLayout);
		richtungComposite.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL, 1, 4));

		positiveRichtungButton = toolkit.createButton(richtungComposite,
				RichtungTextComputedValue.DEFAULT_TEXT_POSITIVE_RICHTUNG,
				SWT.RADIO);
		positiveRichtungButton.addFocusListener(getFocusListener(null));
		negativeRichtungButton = toolkit.createButton(richtungComposite,
				RichtungTextComputedValue.DEFAULT_TEXT_NEGATIVE_RICHTUNG,
				SWT.RADIO);
		negativeRichtungButton.addFocusListener(getFocusListener(null));
		negativeRichtungButton.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL));
		if (BauEditorPlugin.getDefault().isStrasseEindeutig()) {
			richtungLabel.setVisible(false);
			richtungComposite.setVisible(false);
		}
		// (2.1) Startknoten
		toolkit.createLabel(composite, "von:");
		startKnotenComboViewer = new ComboViewer(composite, SWT.READ_ONLY);
		startKnotenComboViewer.getControl().addFocusListener(
				getFocusListener(startKnotenComboViewer));
		startKnotenComboViewer
				.setLabelProvider(new SystemObjectTypeLabelProvider(true));
		startKnotenComboViewer
				.setContentProvider(new ObservableListContentProvider());
		startKnotenComboViewer.getCombo().setLayoutData(
				new TableWrapData(TableWrapData.FILL_GRAB, TableWrapData.FILL,
						1, 4));

		// (2.2) Startbetriebskilometer
		toolkit.createLabel(composite, "");
		final Label startBetriebsKilometerLabel = toolkit.createLabel(
				composite, "Betriebskilometer:");
		startBetriebsKilometerLabel.setLayoutData(new TableWrapData(
				TableWrapData.RIGHT, TableWrapData.MIDDLE, 1, 2));

		// Beachte: Das Start-BK-Textfeld und die Starts-BlockNr-Combobox werden
		// in ein Composite mit GridLayout gepackt, damit bei diesen auf die
		// Breite Einfluss genommen werden kann
		final Composite startBetriebsKilometerComposite = toolkit
				.createComposite(composite);
		startBetriebsKilometerComposite.setLayoutData(new TableWrapData(
				TableWrapData.FILL, TableWrapData.FILL));
		GridLayoutFactory.fillDefaults().numColumns(2)
				.applyTo(startBetriebsKilometerComposite);

		startBetriebsKilometerText = toolkit.createText(
				startBetriebsKilometerComposite, "", SWT.BORDER);
		startBetriebsKilometerTextDecoration = DecorationHelper
				.erzeugeErrorControlDecoration(startBetriebsKilometerText, "",
						FieldDecorationRegistry.DEC_ERROR);
		startBetriebsKilometerText.addKeyListener(new DoubleKeyListener(
				startBetriebsKilometerText, 3));
		startBetriebsKilometerText.addFocusListener(new DefaultFocusListener() {
			@Override
			public void focusLost(final FocusEvent e) {
				if (startBetriebsKilometerText != null
						&& !startBetriebsKilometerText.isDisposed()
						&& startBetriebsKilometerBinding != null
						&& !startBetriebsKilometerBinding.isDisposed()
						&& (!hatGueltigenText(startBetriebsKilometerText) || (startBetriebsKilometerTextDecoration != null
								&& startBetriebsKilometerTextDecoration
										.getDescriptionText() != null && !""
								.equals(startBetriebsKilometerTextDecoration
										.getDescriptionText())))) {

					startBetriebsKilometerText.setText(""
							+ wrapper.getStreckenAbschnitt()
									.getStartBetriebsKilometer());
					startBetriebsKilometerBinding.updateModelToTarget();
					startBetriebsKilometerBinding.validateTargetToModel();
				}
			}
		});
		GridDataFactory.fillDefaults().grab(true, false)
				.applyTo(startBetriebsKilometerText);

		startBlockNummerComboViewer = new ComboViewer(
				startBetriebsKilometerComposite, SWT.READ_ONLY);
		startBlockNummerComboViewer.getControl().addFocusListener(
				getFocusListener(null));
		startBlockNummerComboViewer
				.setContentProvider(new ObservableListContentProvider());
		startBlockNummerComboViewer.getCombo().setToolTipText("Blocknummer");
		startBlockNummerComboViewer.setSorter(new ViewerSorter());
		GridDataFactory.fillDefaults().hint(blockNummerWidth, SWT.DEFAULT)
				.applyTo(startBlockNummerComboViewer.getControl());

		startBetriebsKilometerInfoLabel = toolkit.createLabel(composite,
				"0 - 0 km");
		startBetriebsKilometerInfoLabel.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL));

		// (2.3) Start Offset
		toolkit.createLabel(composite, "");
		final Label startOffsetLabel = toolkit
				.createLabel(composite, "Offset:");
		startOffsetLabel
				.setToolTipText("Offset auf dem ersten\nueren Straensegment.");
		startOffsetLabel.setLayoutData(new TableWrapData(TableWrapData.RIGHT,
				TableWrapData.MIDDLE, 1, 2));

		// Beachte: Das Start-Offset-Textfeld wird in ein Composite mit
		// GridLayout gepackt, damit bei diesem auf die Breite Einfluss genommen
		// werden kann
		final Composite startOffsetComposite = toolkit
				.createComposite(composite);
		startOffsetComposite.setLayoutData(new TableWrapData(
				TableWrapData.FILL, TableWrapData.FILL));
		GridLayoutFactory.fillDefaults().applyTo(startOffsetComposite);

		startOffsetText = toolkit.createText(startOffsetComposite, "",
				SWT.BORDER);
		startOffsetTextDecoration = DecorationHelper
				.erzeugeErrorControlDecoration(startOffsetText, "",
						FieldDecorationRegistry.DEC_ERROR);
		startOffsetText
				.addKeyListener(new DoubleKeyListener(startOffsetText, 3));
		startOffsetText.addFocusListener(new DefaultFocusListener() {
			@Override
			public void focusLost(final FocusEvent e) {
				if (startOffsetText != null
						&& !startOffsetText.isDisposed()
						&& startOffsetBinding != null
						&& !startOffsetBinding.isDisposed()
						&& (!hatGueltigenText(startOffsetText) || (startOffsetTextDecoration != null
								&& startOffsetTextDecoration
										.getDescriptionText() != null && !""
								.equals(startOffsetTextDecoration
										.getDescriptionText())))) {

					startOffsetText.setText(""
							+ wrapper.getStreckenAbschnitt().getStartOffset());
					startOffsetBinding.updateModelToTarget();
					startOffsetBinding.validateTargetToModel();
				}
			}
		});
		GridDataFactory.fillDefaults().hint(textWidth, SWT.DEFAULT)
				.applyTo(startOffsetText);

		startOffsetInfoLabel = toolkit.createLabel(composite, "max: 0 km");
		startOffsetInfoLabel.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL));

		// (3.1) Endknoten
		toolkit.createLabel(composite, "bis:");
		endKnotenComboViewer = new ComboViewer(composite, SWT.READ_ONLY);
		endKnotenComboViewer.getControl().addFocusListener(
				getFocusListener(endKnotenComboViewer));
		endKnotenComboViewer
				.setLabelProvider(new SystemObjectTypeLabelProvider(true));
		endKnotenComboViewer
				.setContentProvider(new ObservableListContentProvider());
		endKnotenComboViewer.getCombo().setLayoutData(
				new TableWrapData(TableWrapData.FILL_GRAB, TableWrapData.FILL,
						1, 4));

		// (3.2) Endbetriebskilometer
		toolkit.createLabel(composite, "");
		final Label endBetriebsKilometerLabel = toolkit.createLabel(composite,
				"Betriebskilometer:");
		endBetriebsKilometerLabel.setLayoutData(new TableWrapData(
				TableWrapData.RIGHT, TableWrapData.MIDDLE, 1, 2));

		// Beachte: Das End-BK-Textfeld und die End-BlockNr-Combobox werden in
		// ein Composite mit GridLayout gepackt, damit bei diesen auf die Breite
		// Einfluss genommen werden kann
		final Composite endBetriebsKilometerComposite = toolkit
				.createComposite(composite);
		endBetriebsKilometerComposite.setLayoutData(new TableWrapData(
				TableWrapData.FILL, TableWrapData.FILL));
		GridLayoutFactory.fillDefaults().numColumns(2)
				.applyTo(endBetriebsKilometerComposite);

		endBetriebsKilometerText = toolkit.createText(
				endBetriebsKilometerComposite, "", SWT.BORDER);
		endBetriebsKilometerTextDecoration = DecorationHelper
				.erzeugeErrorControlDecoration(endBetriebsKilometerText, "",
						FieldDecorationRegistry.DEC_ERROR);
		endBetriebsKilometerText.addKeyListener(new DoubleKeyListener(
				endBetriebsKilometerText, 3));
		endBetriebsKilometerText.addFocusListener(new DefaultFocusListener() {
			@Override
			public void focusLost(final FocusEvent e) {
				if (endBetriebsKilometerText != null
						&& !endBetriebsKilometerText.isDisposed()
						&& endBetriebsKilometerBinding != null
						&& !endBetriebsKilometerBinding.isDisposed()
						&& (!hatGueltigenText(endBetriebsKilometerText) || (endBetriebsKilometerTextDecoration != null
								&& endBetriebsKilometerTextDecoration
										.getDescriptionText() != null && !""
								.equals(endBetriebsKilometerTextDecoration
										.getDescriptionText())))) {

					endBetriebsKilometerText.setText(""
							+ wrapper.getStreckenAbschnitt()
									.getEndBetriebsKilometer());
					endBetriebsKilometerBinding.updateModelToTarget();
					endBetriebsKilometerBinding.validateTargetToModel();
				}
			}
		});
		GridDataFactory.fillDefaults().grab(true, false)
				.applyTo(endBetriebsKilometerText);

		endBlockNummerComboViewer = new ComboViewer(
				endBetriebsKilometerComposite, SWT.READ_ONLY);
		endBlockNummerComboViewer.getControl().addFocusListener(
				getFocusListener(null));
		endBlockNummerComboViewer
				.setContentProvider(new ObservableListContentProvider());
		endBlockNummerComboViewer.getCombo().setToolTipText("Blocknummer");
		endBlockNummerComboViewer.setSorter(new ViewerSorter());
		endBlockNummerComboViewer.getCombo().setLayoutData(
				new TableWrapData(TableWrapData.FILL, TableWrapData.FILL));
		GridDataFactory.fillDefaults().hint(blockNummerWidth, SWT.DEFAULT)
				.applyTo(endBlockNummerComboViewer.getControl());

		endBetriebsKilometerInfoLabel = toolkit.createLabel(composite,
				"0 - 0 km");
		endBetriebsKilometerInfoLabel.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL));

		// (3.3) End Offset
		toolkit.createLabel(composite, "");
		final Label endOffsetLabel = toolkit.createLabel(composite, "Offset:");
		endOffsetLabel
				.setToolTipText("Offset auf dem letzten ueren\nStraensegment beginnend beim\nvorletzten Straenknoten.");
		endOffsetLabel.setLayoutData(new TableWrapData(TableWrapData.RIGHT,
				TableWrapData.MIDDLE, 1, 2));

		// Beachte: Das End-Offset-Textfeld wird in ein Composite mit GridLayout
		// gepackt, damit bei diesem auf die Breite Einfluss genommen werden
		// kann
		final Composite endOffsetComposite = toolkit.createComposite(composite);
		endOffsetComposite.setLayoutData(new TableWrapData(TableWrapData.FILL,
				TableWrapData.FILL));
		GridLayoutFactory.fillDefaults().applyTo(endOffsetComposite);

		endOffsetText = toolkit.createText(endOffsetComposite, "", SWT.BORDER);
		endOffsetTextDecoration = DecorationHelper
				.erzeugeErrorControlDecoration(endOffsetText, "",
						FieldDecorationRegistry.DEC_ERROR);
		endOffsetText.addKeyListener(new DoubleKeyListener(endOffsetText, 3));
		endOffsetText.addFocusListener(new DefaultFocusListener() {
			@Override
			public void focusLost(final FocusEvent e) {
				if (endOffsetText != null
						&& !endOffsetText.isDisposed()
						&& endOffsetBinding != null
						&& !endOffsetBinding.isDisposed()
						&& (!hatGueltigenText(endOffsetText) || (endOffsetTextDecoration != null
								&& endOffsetTextDecoration.getDescriptionText() != null && !""
								.equals(endOffsetTextDecoration
										.getDescriptionText())))) {

					endOffsetText.setText(""
							+ wrapper.getStreckenAbschnitt().getEndOffset());
					endOffsetBinding.updateModelToTarget();
					endOffsetBinding.validateTargetToModel();
				}
			}
		});
		GridDataFactory.fillDefaults().hint(textWidth, SWT.DEFAULT)
				.applyTo(endOffsetText);

		endOffsetInfoLabel = toolkit.createLabel(composite, "max: 0 km");
		endOffsetInfoLabel.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL));

		return section;
	}

	/**
	 * Liefert <code>true</code> zurck, wenn das gegebene Text-Widget einen
	 * gltigen Text hat. Ein gltiger Text darf kein Komma am Anfang oder Ende
	 * haben.
	 * 
	 * @param textWidget
	 *            das Text-Widget
	 * 
	 * @return <code>true</code>, wenn das gegebene Text-Widget einen gltigen
	 *         Text hat, ansonsten <code>false</code>
	 */
	private boolean hatGueltigenText(final Text textWidget) {
		if (textWidget != null && !textWidget.isDisposed()
				&& textWidget.getText() != null) {
			final String text = textWidget.getText();
			return !text.startsWith(",") && !text.endsWith(",");
		}
		return true;
	}

	/**
	 * Erzeugt die Dauer-Section.
	 * 
	 * @param toolkit
	 *            das Forms-Toolkit
	 * @param parent
	 *            das Parent Composite
	 * 
	 * @return die Section
	 */
	protected Section erzeugeDauerSection(final FormToolkit toolkit,
			final Composite parent) {

		final Section section = toolkit.createSection(parent,
				SECTION_STYLE_MIT_TWISTIE);
		section.setText("Dauer");

		final Composite composite = toolkit.createComposite(section);
		section.setClient(composite);

		// Beachte: In diesem Bereich wird ausnahmsweise ein GridLayout
		// verwendet, da alle Widgets eine feste Gre haben. Auerdem
		// bentigen die DatumZeit- und ZeitDauer-Widgets ein GridLayout.
		GridLayoutFactory.fillDefaults().numColumns(3).spacing(SWT.DEFAULT, 0)
				.equalWidth(false).applyTo(composite);

		// von Zeitpunkt
		toolkit.createLabel(composite, "von:");
		vonDatumZeit = new DatumZeit(composite, SWT.NONE, Eingabetyp.datumuhr,
				false, false);
		for (final Control c : vonDatumZeit.getChildren()) {
			c.addFocusListener(getFocusListener(null));
		}
		GridDataFactory.fillDefaults().align(SWT.FILL, SWT.CENTER)
				.grab(true, false).applyTo(vonDatumZeit);
		aktualisiereStartZeitButton = toolkit.createButton(composite, "",
				SWT.PUSH);
		aktualisiereStartZeitButton.addFocusListener(getFocusListener(null));
		aktualisiereStartZeitButton
				.setToolTipText("Setze Startzeitpunkt\nauf aktuelles Datum/Zeit.");
		aktualisiereStartZeitButton.setImage(BauEditorPlugin.getDefault()
				.getImage(BildDateiPfade.AKTUELLE_ZEIT));
		aktualisiereStartZeitButton
				.addSelectionListener(new SelectionAdapter() {
					@Override
					public void widgetSelected(final SelectionEvent e) {
						wrapper.setStartZeit(new Date());
					}
				});

		// bis Zeitpunkt
		toolkit.createLabel(composite, "bis:");
		bisDatumZeit = new DatumZeit(composite, SWT.NONE, Eingabetyp.datumuhr,
				false, false);
		for (final Control c : bisDatumZeit.getChildren()) {
			c.addFocusListener(getFocusListener(null));
		}
		GridDataFactory.fillDefaults().align(SWT.FILL, SWT.CENTER)
				.grab(true, false).applyTo(bisDatumZeit);
		aktualisiereEndZeitButton = toolkit.createButton(composite, "",
				SWT.PUSH);
		aktualisiereEndZeitButton.addFocusListener(getFocusListener(null));
		aktualisiereEndZeitButton
				.setToolTipText("Setze Endzeitpunkt\nauf aktuelles Datum/Zeit.");
		aktualisiereEndZeitButton.setImage(BauEditorPlugin.getDefault()
				.getImage(BildDateiPfade.AKTUELLE_ZEIT));
		aktualisiereEndZeitButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				wrapper.setEndZeit(new Date());
			}
		});

		// Dauer
		toolkit.createLabel(composite, "Dauer:");
		zeitDauer = new CompositeZeitDauerExtended(composite, SWT.NONE, 0, true);
		zeitDauer.setZeitklassenDarstellen(true, true, true, true, true, true,
				false);
		zeitDauer.setZeitKlassenTextEditierbar(false);
		zeitDauer.setZeitDauerInBezugAufAnfangsZeitpunkt(1000 * 60);
		for (final Control c : zeitDauer.getChildren()) {
			c.addFocusListener(getFocusListener(null));
		}
		GridDataFactory.fillDefaults().grab(true, false).applyTo(zeitDauer);

		dauerUnbekanntButton = toolkit.createButton(composite, "", SWT.PUSH);
		dauerUnbekanntButton.addFocusListener(getFocusListener(null));
		dauerUnbekanntButton.setToolTipText("Deklariere Dauer\nals unbekannt.");
		dauerUnbekanntButton.setImage(BauEditorPlugin.getDefault().getImage(
				BildDateiPfade.ENTFERNEN));
		dauerUnbekanntButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				if (vonDatumZeit != null && !vonDatumZeit.isDisposed()) {
					wrapper.setEndZeit(vonDatumZeit.getDatum());
				}
			}
		});

		// Toolbar
		erzeugeDauerSectionToolbar(section, toolkit);

		return section;
	}

	/**
	 * Erzeugt die Toolbar der Dauer-Section.
	 * 
	 * @param section
	 *            die Section
	 * @param toolkit
	 *            das Forms-Toolkit
	 */
	private void erzeugeDauerSectionToolbar(final Section section,
			final FormToolkit toolkit) {
		final ToolBarManager toolBarManager = new ToolBarManager(SWT.FLAT);
		final ToolBar toolbar = toolBarManager.createControl(section);

		final Cursor handCursor = new Cursor(Display.getCurrent(),
				SWT.CURSOR_HAND);
		toolbar.setCursor(handCursor);
		toolbar.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(final DisposeEvent e) {
				if (handCursor != null && !handCursor.isDisposed()) {
					handCursor.dispose();
				}
			}
		});

		systemKalenderAction = new UebernehmeSystemKalenderZeitbereichAction(
				getSite().getShell(), wrapper);
		toolBarManager.add(systemKalenderAction);

		toolBarManager.update(true);
		section.setTextClient(toolbar);
	}

	/**
	 * Erzeugt die Segmente-Section.
	 * 
	 * @param toolkit
	 *            das Forms-Toolkit
	 * @param parent
	 *            das Parent Composite
	 * 
	 * @return die Section
	 */
	protected Control erzeugeSegmenteSection(final FormToolkit toolkit,
			final Composite parent) {

		final Composite segmenteComposite = toolkit.createComposite(parent,
				SWT.NONE);
		GridLayoutFactory.fillDefaults().applyTo(segmenteComposite);

		segmenteSection = toolkit.createSection(segmenteComposite,
				SECTION_STYLE);
		segmenteSection.setText("Segmente");

		final Composite composite = toolkit.createComposite(segmenteSection);
		segmenteSection.setClient(composite);
		GridDataFactory.fillDefaults().grab(false, true).hint(280, SWT.DEFAULT)
				.applyTo(segmenteSection);
		final FillLayout fillLayout = new FillLayout();
		fillLayout.marginHeight = 5;
		composite.setLayout(fillLayout);

		// (1) Erzeuge FigureCanvas
		final FigureCanvas figureCanvas = new FigureCanvas(composite,
				SWT.BORDER);
		figureCanvas.setVerticalScrollBarVisibility(FigureCanvas.AUTOMATIC);
		figureCanvas.setHorizontalScrollBarVisibility(FigureCanvas.NEVER);
		figureCanvas.setBackground(ColorConstants.white);
		figureCanvas.setForeground(ColorConstants.white);

		// (2) Initialisiere Root-LayerPane
		segmenteLayeredPane = new LayeredPane();
		figureCanvas.setContents(segmenteLayeredPane);
		segmenteLabelFont = new Font(null, "Arial", 8, SWT.NORMAL);

		// dummyComposite = toolkit.createComposite(segmenteComposite);
		// GridDataFactory.fillDefaults().grab(false, true).hint(1, SWT.DEFAULT)
		// .applyTo(dummyComposite);

		return segmenteComposite;
	}

	/**
	 * Aktualisiert den Segmente-Graph.
	 */
	@SuppressWarnings("unchecked")
	private void aktualisiereSegmenteGraph() {

		if (segmenteLayeredPane == null) {
			return;
		}

		// (1) Initialisiere Root-LayedPane
		final XYLayout rootLayout = new XYLayout();
		segmenteLayeredPane.setLayoutManager(rootLayout);
		segmenteLayeredPane.removeAll();

		final Layer figures = new Layer();
		final XYLayout figuresLayout = new XYLayout();
		figures.setLayoutManager(figuresLayout);

		final ConnectionLayer connections = new ConnectionLayer();
		final ConnectionRouter router = new FanRouter();
		connections.setConnectionRouter(router);

		segmenteLayeredPane.add(figures);
		segmenteLayeredPane.add(connections);

		// (2) erzeuge Graphen
		final Map<StrassenKnoten, StrassenKnotenFigureMitLabel> figureMap = new HashMap<StrassenKnoten, StrassenKnotenFigureMitLabel>();
		final Map<StrassenKnoten, Node> nodeMap = new HashMap<StrassenKnoten, Node>();
		final Map<PolylineConnection, AeusseresStrassenSegment> connectionMap = new HashMap<PolylineConnection, AeusseresStrassenSegment>();
		final DirectedGraph directedGraph = new DirectedGraph();

		// (2.1) erzeuge Knoten
		final StreckenAbschnitt aktuellerStreckenAbschnitt = wrapper
				.getStreckenAbschnitt();

		boolean existierenAlternativeInnereSegmente = false;
		for (final StrassenKnoten knoten : aktuellerStreckenAbschnitt
				.getStrassenKnoten()) {
			if (!figureMap.containsKey(knoten)) {
				final Node node = new Node();
				node.setPadding(new Insets(15, 10, 15, 10));
				node.setSize(new Dimension(220, 35));
				directedGraph.nodes.add(node);
				final StrassenKnotenFigureMitLabel figure = new StrassenKnotenFigureMitLabel(
						knoten, aktuellerStreckenAbschnitt);
				figure.addSelectionListener(new ISelectionListener() {
					@Override
					public void selectionChanged(final IWorkbenchPart part,
							final ISelection selection) {
						if (segmenteSelectionProvider != null
								&& selectionProviderWrapper != null) {
							segmenteSelectionProvider.setSelection(selection);
							selectionProviderWrapper
									.setSelectionProvider(segmenteSelectionProvider);
						}
					}
				});
				figure.addMouseListener(new MouseListener() {
					@Override
					public void mouseDoubleClicked(final MouseEvent me) {
					}

					@Override
					public void mousePressed(final MouseEvent me) {
					}

					@Override
					public void mouseReleased(final MouseEvent me) {
						if (segmenteSelectionProvider != null
								&& selectionProviderWrapper != null) {
							segmenteSelectionProvider
									.setSelection(new StructuredSelection(
											knoten));
							selectionProviderWrapper
									.setSelectionProvider(segmenteSelectionProvider);
						}
					}
				});
				if (segmenteLabelFont != null
						&& !segmenteLabelFont.isDisposed()) {
					figure.setFont(segmenteLabelFont);
				}
				figures.add(figure);
				figureMap.put(knoten, figure);
				nodeMap.put(knoten, node);
				if (!existierenAlternativeInnereSegmente) {
					existierenAlternativeInnereSegmente = aktuellerStreckenAbschnitt
							.getInnereStrassenSegmente(knoten).size() > 1;
				}
			}
		}

		// (2.2) erzeuge Kanten
		final List<StreckenAbschnitt> streckenAbschnitte = streckenCache
				.getStreckenAbschnitte(wrapper.getStrasse(),
						wrapper.getRichtung(), wrapper.getStartKnoten(),
						wrapper.getEndKnoten());
		final List<AeusseresStrassenSegment> aeussereSegmente = new ArrayList<AeusseresStrassenSegment>();
		for (final StreckenAbschnitt abschnitt : streckenAbschnitte) {
			for (final AeusseresStrassenSegment segment : abschnitt
					.getAeussereStrassenSegmente()) {
				if (!aeussereSegmente.contains(segment)) {
					aeussereSegmente.add(segment);
				}
			}
		}
		Collections.sort(aeussereSegmente,
				new Comparator<AeusseresStrassenSegment>() {
					public int compare(final AeusseresStrassenSegment s1,
							final AeusseresStrassenSegment s2) {
						return s1.getPid().compareTo(s2.getPid());
					}
				});
		for (final AeusseresStrassenSegment segment : aeussereSegmente) {
			if (!connectionMap.containsValue(segment)) {
				final StrassenKnoten vonKnoten = segment
						.getKdAeusseresStrassenSegment().getDatum()
						.getVonKnoten();
				final StrassenKnoten nachKnoten = segment
						.getKdAeusseresStrassenSegment().getDatum()
						.getNachKnoten();
				final Edge edge = new Edge(nodeMap.get(vonKnoten),
						nodeMap.get(nachKnoten));
				directedGraph.edges.add(edge);
				final boolean gehoertZuAktuellemStreckenAbschnitt = aktuellerStreckenAbschnitt
						.getAeussereStrassenSegmente().contains(segment);
				final PolylineConnection connection = createConnection(segment,
						figureMap.get(vonKnoten), figureMap.get(nachKnoten),
						gehoertZuAktuellemStreckenAbschnitt);
				connection.addMouseListener(new MouseListener() {
					public void mouseDoubleClicked(final MouseEvent me) {
						// do nothing
					}

					public void mousePressed(final MouseEvent me) {
						// do nothing
					}

					public void mouseReleased(final MouseEvent me) {
						final AeusseresStrassenSegment selektiertesSegment = connectionMap
								.get(connection);
						if (segmenteSelectionProvider != null
								&& selectionProviderWrapper != null) {
							segmenteSelectionProvider
									.setSelection(new StructuredSelection(
											selektiertesSegment));
							selectionProviderWrapper
									.setSelectionProvider(segmenteSelectionProvider);
						}
						if (!gehoertZuAktuellemStreckenAbschnitt
								&& selektiertesSegment != null) {
							wrapper.setAlternativesAeuesseresStrassenSegment(selektiertesSegment);
						}
					}
				});
				connectionMap.put(connection, segment);
				connections.add(connection);
			}
		}

		// (2.3) berechne und weise Layout zu
		final DirectedGraphLayout layout = new DirectedGraphLayout();
		layout.visit(directedGraph);
		for (final StrassenKnoten knoten : wrapper.getStreckenAbschnitt()
				.getStrassenKnoten()) {
			final Node node = nodeMap.get(knoten);
			final StrassenKnotenFigureMitLabel figure = figureMap.get(knoten);
			if (figure != null && node != null) {
				figuresLayout.setConstraint(figure, new Rectangle(node.x,
						node.y, node.width, node.height));
			}
		}

		// (3) Aktualisiere Layout und Gren
		final Dimension layoutSize = directedGraph.getLayoutSize();
		rootLayout.setConstraint(figures, new Rectangle(0, 0, layoutSize.width,
				layoutSize.height));
		rootLayout.setConstraint(connections, new Rectangle(0, 0,
				layoutSize.width, layoutSize.height));

		// (4) Setze roten Rahmen, wenn es alternative Straensegmente gibt
		if (streckenAbschnitte.size() > 1
				|| existierenAlternativeInnereSegmente) {
			segmenteLayeredPane
					.setBorder(new LineBorder(ColorConstants.red, 1));
		} else {
			segmenteLayeredPane.setBorder(new LineBorder(ColorConstants.white,
					1));
		}
	}

	/**
	 * Erzeugt eine PolyLineConnection.
	 * 
	 * @param segment
	 *            das Straensegment
	 * @param figure1
	 *            das Start-Figure
	 * @param figure2
	 *            das End-Figure
	 * @param gehoertZuAktuellemStreckenAbschnitt
	 *            <code>true</code>, wenn das Straensegment zum aktuellen
	 *            Streckenabschnitt gehrt
	 * 
	 * @return die PolyLoneConnection
	 */
	private PolylineConnection createConnection(
			final AeusseresStrassenSegment segment,
			final StrassenKnotenFigureMitLabel figure1,
			final StrassenKnotenFigureMitLabel figure2,
			final boolean gehoertZuAktuellemStreckenAbschnitt) {

		final PolylineConnection connection = new PolylineConnection();
		connection.setLineWidth(1);
		Color color = ColorConstants.black;
		if (!gehoertZuAktuellemStreckenAbschnitt) {
			color = ColorConstants.red;
		}
		connection.setForegroundColor(color);
		connection.setToolTip(TooltipUtil.erzeugeTooltip(segment.getPid()));
		connection.setSourceAnchor(figure1.getConnectionAnchor());
		connection.setTargetAnchor(figure2.getConnectionAnchor());

		final PolygonDecoration decoration = new PolygonDecoration();
		decoration.setTemplate(PolygonDecoration.TRIANGLE_TIP);
		connection.setTargetDecoration(decoration);

		return connection;
	}

	/**
	 * Erzeugt die Fahrstreifen-Section.
	 * 
	 * @param toolkit
	 *            das Forms-Toolkit
	 * @param parent
	 *            das Parent Composite
	 * 
	 * @return die Section
	 */
	protected Section erzeugeFahrstreifenSection(final FormToolkit toolkit,
			final Composite parent) {

		final Section section = toolkit.createSection(parent,
				SECTION_STYLE_MIT_TWISTIE);
		section.setText("Kapazitten / Gesperrte Fahrstreifen");

		final Composite composite = toolkit.createComposite(section);
		final TableWrapLayout layout = new TableWrapLayout();
		layout.numColumns = 4;
		layout.topMargin = 10;
		composite.setLayout(layout);
		section.setClient(composite);

		// Anzahl Fahrstreifen Info-Feld (Fz/h ReadOnly)
		final Label anzahlFahrstreifenLabel = toolkit.createLabel(composite,
				"Anzahl Fahrstreifen:");
		anzahlFahrstreifenLabel.setLayoutData(new TableWrapData(
				TableWrapData.LEFT, TableWrapData.TOP));

		anzahlFahrstreifenInfoLabel = toolkit.createLabel(composite,
				"unbekannt");
		final TableWrapData ld1 = new TableWrapData(TableWrapData.FILL,
				TableWrapData.FILL);
		ld1.indent = 6;
		anzahlFahrstreifenInfoLabel.setLayoutData(ld1);

		// Gesperrte Fahrstreifen
		final Label gesperrteFahrstreifenLabel = toolkit.createLabel(composite,
				"Gesperrte Fahrstreifen: ");
		gesperrteFahrstreifenLabel.setLayoutData(new TableWrapData(
				TableWrapData.FILL, TableWrapData.FILL_GRAB, 5, 1));
		final Composite tableComposite = new Composite(composite, SWT.NONE);
		final TableWrapData ld2 = new TableWrapData(TableWrapData.FILL,
				TableWrapData.FILL_GRAB, 5, 1);
		ld2.heightHint = 110;
		tableComposite.setLayoutData(ld2);

		final TableColumnLayout columnLayout = new TableColumnLayout();
		tableComposite.setLayout(columnLayout);
		fahrstreifenTableViewer = CheckboxTableViewer.newCheckList(
				tableComposite, SWT.SINGLE);
		fahrstreifenTableViewer
				.setContentProvider(new ObservableSetContentProvider());

		final Table table = fahrstreifenTableViewer.getTable();
		table.addFocusListener(getFocusListener(null));
		table.setHeaderVisible(false);
		table.setLinesVisible(false);
		table.setItemCount(AttFahrStreifenLage.getZustaende().size());
		table.setVisible(false);

		final TableColumn column = new TableColumn(table, SWT.NONE);
		column.setResizable(false);
		column.setMoveable(false);
		columnLayout.setColumnData(column, new ColumnWeightData(1));
		table.addListener(SWT.EraseItem, new Listener() {
			public void handleEvent(final Event event) {
				if ((event.detail & SWT.SELECTED) != 0) {
					event.detail &= ~SWT.SELECTED;
				}
			}
		});
		fahrstreifenTableViewer.getTable().setLayoutData(
				new TableWrapData(TableWrapData.FILL, TableWrapData.FILL));

		// Freie Fahrstreifen Info-Feld (Fz/h ReadOnly)
		// - wird berechnet aus der Differenz der Anzahl der Fahrstreifen am
		// ausgewhlten Startsegment und der Anzahl der gesperrten Fahrstreifen
		final Label freieFahrstreifenLabel = toolkit.createLabel(composite,
				"Anzahl freie Fahrstreifen:");
		freieFahrstreifenLabel.setLayoutData(new TableWrapData(
				TableWrapData.LEFT, TableWrapData.MIDDLE));

		freieFahrstreifenInfoLabel = toolkit
				.createLabel(composite, "unbekannt");
		final TableWrapData ld3 = new TableWrapData(TableWrapData.FILL,
				TableWrapData.FILL);
		ld3.indent = 6;
		freieFahrstreifenInfoLabel.setLayoutData(ld3);

		// Restkapazitt (Fz/h)
		final Integer maxVerkehrsStaerkeStunde = new Integer((int) WerteBereich
				.getWerteBereich(AttVerkehrsStaerkeStunde.class).getMaximum());

		final Label restKapazitaetLabel = toolkit.createLabel(composite,
				"Restkapazitt [Fz/(h*FS)]:");
		restKapazitaetLabel.setLayoutData(new TableWrapData(TableWrapData.LEFT,
				TableWrapData.MIDDLE));
		restKapazitaetText = toolkit.createText(composite, "", SWT.BORDER);
		restKapazitaetText.setTextLimit(maxVerkehrsStaerkeStunde.toString()
				.length());
		restKapazitaetText.addKeyListener(new DoubleKeyListener(
				restKapazitaetText, 0));
		restKapazitaetText.addFocusListener(new DefaultFocusListener() {
			@Override
			public void focusLost(final FocusEvent e) {
				if (wrapper != null && restKapazitaetText != null
						&& !restKapazitaetText.isDisposed()) {
					restKapazitaetText.setText(""
							+ wrapper.getRestKapazitaetProFahrstreifen());
				}
			}
		});
		restKapazitaetText.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL));

		// EngpassKapazitt (Fz/h * FS)
		// - wird berechnet aus dem Produkt: Anzahl freier Fahrstreifen und
		// durchschnittlicher Restkapzitt pro Fahrstreifen
		final Label engpassKapazitaetLabel = toolkit.createLabel(composite,
				"Engpasskapazitt [Fz/h]:");
		engpassKapazitaetLabel.setLayoutData(new TableWrapData(
				TableWrapData.LEFT, TableWrapData.TOP));
		engpassKapazitaetText = toolkit.createText(composite, "", SWT.BORDER);
		engpassKapazitaetText.setTextLimit(maxVerkehrsStaerkeStunde.toString()
				.length());
		engpassKapazitaetText.addKeyListener(new DoubleKeyListener(
				engpassKapazitaetText, 0));
		engpassKapazitaetText.addFocusListener(new DefaultFocusListener() {
			@Override
			public void focusLost(final FocusEvent e) {
				if (wrapper != null && engpassKapazitaetText != null
						&& !engpassKapazitaetText.isDisposed()) {
					engpassKapazitaetText.setText(""
							+ wrapper.getEngpassKapazitaet());
				}
			}
		});
		engpassKapazitaetText.setLayoutData(new TableWrapData(
				TableWrapData.FILL_GRAB, TableWrapData.FILL));

		final Label dummyLabel = toolkit.createLabel(composite, "");
		dummyLabel.setLayoutData(new TableWrapData(TableWrapData.FILL,
				TableWrapData.FILL, 1, 2));

		return section;
	}

	/**
	 * Erzeugt die Info-Section.
	 * 
	 * @param toolkit
	 *            das Forms-Toolkit
	 * @param parent
	 *            das Parent Composite
	 * 
	 * @return die Section
	 */
	protected Section erzeugeInfoSection(final FormToolkit toolkit,
			final Composite parent) {

		final Section section = toolkit.createSection(parent,
				SECTION_STYLE_MIT_TWISTIE);

		final Composite composite = toolkit.createComposite(section);
		final TableWrapLayout layout = new TableWrapLayout();
		layout.numColumns = 2;
		layout.topMargin = 10;
		composite.setLayout(layout);
		section.setClient(composite);

		// Section Text und Description
		section.setText("Info");
		final StyledText styledText = new StyledText(section, SWT.WRAP
				| SWT.READ_ONLY);
		styledText
				.setText("Hinweis: Diese Informationen knnen nur beim Anlegen einer neuen Engstelle definiert werden.");
		styledText.setBackground(section.getBackground());
		final StyleRange styleRange = new StyleRange();
		styleRange.start = 0;
		styleRange.length = 8;
		styleRange.underline = true;
		styleRange.foreground = PlatformUI.getWorkbench().getDisplay()
				.getSystemColor(SWT.COLOR_DARK_YELLOW);
		styledText.setStyleRange(styleRange);
		section.setDescriptionControl(styledText);

		// Kurzinfo
		final Label kurzinfoLabel = toolkit.createLabel(composite, "Kurzinfo:");
		kurzinfoLabel.setLayoutData(new TableWrapData(TableWrapData.FILL,
				TableWrapData.MIDDLE));

		kurzinfoText = toolkit.createText(composite, "", SWT.BORDER);
		kurzinfoText.addFocusListener(getFocusListener(null));
		kurzinfoText.setLayoutData(new TableWrapData(TableWrapData.FILL_GRAB,
				TableWrapData.FILL));

		// Beschreibung
		final Label beschreibungLabel = toolkit.createLabel(composite,
				"Beschreibung:");
		beschreibungLabel.setLayoutData(new TableWrapData(TableWrapData.FILL,
				TableWrapData.TOP));

		beschreibungText = toolkit.createText(composite,
				"", SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER); //$NON-NLS-1$
		beschreibungText.addFocusListener(getFocusListener(null));
		final TableWrapData twd = new TableWrapData(TableWrapData.FILL_GRAB,
				TableWrapData.FILL);
		twd.heightHint = 50;
		beschreibungText.setLayoutData(twd);

		// optionale Erweiterung
		erzeugeInfoSectionErweiterung(toolkit, composite);

		return section;
	}

	/**
	 * Diese Methode ermglicht Unterklassen, den Bereich "Info" mit
	 * zustzlichen Feldern zu erweitern.
	 * 
	 * @param toolkit
	 *            das Forms-Toolkit
	 * @param parent
	 *            das Parent Composite
	 */
	protected void erzeugeInfoSectionErweiterung(final FormToolkit toolkit,
			final Composite parent) {
		// tut nix - aber kann berschrieben werden.
	}

	/**
	 * Liefert den MessageManager dieses Editors zurck.
	 * 
	 * @return den MessageManager dieses Editors
	 */
	protected IMessageManager getMessageManager() {
		return messageManager;
	}

	/**
	 * Aktiviert bzw. deaktiviert smtliche Widgets dieses Editors.
	 * 
	 * @param enabled
	 *            <code>true</code>, wenn smtliche Widgets aktiviert werden
	 *            sollen, ansonsten <code>false</code>
	 */
	protected void setEnablement(final boolean enabled) {

		// header
		if (nameText != null && !nameText.isDisposed()) {
			nameText.setEnabled(enabled);
		}
		if (saveButton != null && !saveButton.isDisposed()) {
			saveButton.setEnabled(enabled && wrapper.isDirty());
		}
		if (refreshButton != null && !refreshButton.isDisposed()) {
			refreshButton.setEnabled(enabled && !wrapper.isNeuesElement()
					&& wrapper.isDirty());
		}

		// header - ereignis-widgets
		if (ereignisCheckbox != null && !ereignisCheckbox.isDisposed()) {
			ereignisCheckbox.setEnabled(enabled);
		}
		if (ereignisTypComboViewer != null
				&& ereignisTypComboViewer.getCombo() != null
				&& !ereignisTypComboViewer.getCombo().isDisposed()) {
			ereignisTypComboViewer.getCombo().setEnabled(enabled);
		}
		if (neuerEreignisTypButton != null
				&& !neuerEreignisTypButton.isDisposed()) {
			neuerEreignisTypButton.setEnabled(enabled);
		}
		if (ereignisVerknuepfenHyperlink != null
				&& !ereignisVerknuepfenHyperlink.isDisposed()) {
			ereignisVerknuepfenHyperlink.setEnabled(enabled);
		}

		// dauer
		if (systemKalenderAction != null) {
			systemKalenderAction.setEnabled(enabled);
		}
		if (vonDatumZeit != null && !vonDatumZeit.isDisposed()) {
			vonDatumZeit.setEnabled(enabled);
		}
		if (aktualisiereStartZeitButton != null
				&& !aktualisiereStartZeitButton.isDisposed()) {
			aktualisiereStartZeitButton.setEnabled(enabled);
		}
		if (bisDatumZeit != null && !bisDatumZeit.isDisposed()) {
			bisDatumZeit.setEnabled(enabled);
		}
		if (aktualisiereEndZeitButton != null
				&& !aktualisiereEndZeitButton.isDisposed()) {
			aktualisiereEndZeitButton.setEnabled(enabled);
		}
		if (zeitDauer != null && !zeitDauer.isDisposed()) {
			zeitDauer.setEnabled(enabled);
		}
		if (dauerUnbekanntButton != null && !dauerUnbekanntButton.isDisposed()) {
			dauerUnbekanntButton.setEnabled(enabled);
		}

		// lage
		if (strasseComboViewer != null && strasseComboViewer.getCombo() != null
				&& !strasseComboViewer.getCombo().isDisposed()) {
			strasseComboViewer.getCombo().setEnabled(enabled);
		}
		if (positiveRichtungButton != null
				&& !positiveRichtungButton.isDisposed()) {
			positiveRichtungButton.setEnabled(enabled
					&& wrapper.isRichtungsAuswahlMoeglich());
		}
		if (negativeRichtungButton != null
				&& !negativeRichtungButton.isDisposed()) {
			negativeRichtungButton.setEnabled(enabled
					&& wrapper.isRichtungsAuswahlMoeglich());
		}
		if (startKnotenComboViewer != null
				&& startKnotenComboViewer.getCombo() != null
				&& !startKnotenComboViewer.getCombo().isDisposed()) {
			startKnotenComboViewer.getCombo().setEnabled(enabled);
		}
		if (endKnotenComboViewer != null
				&& endKnotenComboViewer.getCombo() != null
				&& !endKnotenComboViewer.getCombo().isDisposed()) {
			endKnotenComboViewer.getCombo().setEnabled(enabled);
		}
		if (startOffsetText != null && !startOffsetText.isDisposed()) {
			startOffsetText.setEnabled(enabled);
		}
		if (endOffsetText != null && !endOffsetText.isDisposed()) {
			endOffsetText.setEnabled(enabled);
		}
		if (startBetriebsKilometerText != null
				&& !startBetriebsKilometerText.isDisposed()) {
			startBetriebsKilometerText.setEnabled(enabled
					&& wrapper.getStreckenAbschnitt()
							.getStartBetriebsKilometerBereich() != null);
		}
		if (endBetriebsKilometerText != null
				&& !endBetriebsKilometerText.isDisposed()) {
			endBetriebsKilometerText.setEnabled(enabled
					&& wrapper.getStreckenAbschnitt()
							.getEndBetriebsKilometerBereich() != null);
		}

		// fahrstreifen
		if (fahrstreifenTableViewer != null
				&& fahrstreifenTableViewer.getTable() != null
				&& !fahrstreifenTableViewer.getTable().isDisposed()) {
			fahrstreifenTableViewer.getTable().setEnabled(enabled);
		}

		// kapazitt
		if (restKapazitaetText != null && !restKapazitaetText.isDisposed()) {
			restKapazitaetText.setEnabled(enabled);
		}
		if (engpassKapazitaetText != null
				&& !engpassKapazitaetText.isDisposed()) {
			engpassKapazitaetText.setEnabled(enabled);
		}

		// info
		if (kurzinfoText != null && !kurzinfoText.isDisposed()) {
			kurzinfoText.setEditable(enabled && wrapper.isNeuesElement());
		}
		if (beschreibungText != null && !beschreibungText.isDisposed()) {
			beschreibungText.setEditable(enabled && wrapper.isNeuesElement());
		}
	}

	/**
	 * Setzt smtliche Werte des Editors zurck.
	 */
	private void doRefesh() {
		if (wrapper != null) {
			final Situation situation = wrapper.getSituation();
			final EngstellenCache engstellenCache = BauEditorPlugin
					.getDefault().getEngstellenCache();

			EngstellenWrapper neuerWrapper = null;
			if (situation instanceof Baustelle) {
				final BaustellenWrapper baustellenWrapper = engstellenCache
						.getBaustellenWrapper((Baustelle) situation);
				if (baustellenWrapper != null) {
					neuerWrapper = new BaustellenWrapper(baustellenWrapper);
				}

			} else if (situation instanceof Unfall) {
				final UnfallWrapper unfallWrapper = engstellenCache
						.getUnfallWrapper((Unfall) situation);
				if (unfallWrapper != null) {
					neuerWrapper = new UnfallWrapper(unfallWrapper);
				}
			}

			if (neuerWrapper != null) {
				wrapper = neuerWrapper;
				bindValues();
				setEnablement(true);
				wrapper.setDirty(true);
				wrapper.setDirty(false);
			}
		}
	}

	@Override
	public void doSave(final IProgressMonitor monitor) {

		if (form != null && !form.isDisposed()
				&& form.getMessageType() == IMessageProvider.ERROR) {
			MessageDialog
					.openInformation(PlatformUI.getWorkbench()
							.getActiveWorkbenchWindow().getShell(),
							"Information",
							"Speichern nicht mglich! Beheben Sie bitte zunchst smtliche Fehler.");
			return;
		}

		if (wrapper.isDirty()) {

			// (0) ffne Urlasser-Dialog
			final StringBuffer buf = new StringBuffer();
			buf.append(((EngstellenEditorInput) getEditorInput()).getTyp());
			buf.append(" '");
			buf.append(wrapper.getName());
			buf.append("' ");
			if (wrapper.isNeuesElement()) {
				buf.append("angelegt.");
			} else {
				buf.append("bearbeitet.");
			}
			final UrlasserDialog dialog = new UrlasserDialog(PlatformUI
					.getWorkbench().getActiveWorkbenchWindow().getShell());
			final Collection<ResultData> datenListe = new ArrayList<ResultData>();
			final UrlasserDialogInfo info = dialog
					.anzeigen(datenListe, DaVVerbindung.getInstanz()
							.getDaVBenutzer(), null, buf.toString(),
							DaVVerbindung.getInstanz().getDaVBenutzer());

			if (info.getEingabeOk()) {

				setEnablement(false);
				isBusy = true;
				if (form != null && !form.isDisposed()) {
					form.setBusy(isBusy);
				}

				final BackgroundUIJob job = new BackgroundUIJob(
						"Engstelle speichern") {

					private IStatus status;

					@Override
					protected IStatus runInBGThread(
							final IProgressMonitor monitor) {

						synchronized (lock) {

							final List<DynamischesObjekt> liste = new ArrayList<DynamischesObjekt>();
							status = EngstellenVerwaltung.speicherEngstelle(
									info, wrapper, liste);
							neuesEreignis = null;
							neuAngelegteSituation = null;
							for (final DynamischesObjekt obj : liste) {
								if (neuAngelegteSituation == null
										&& obj instanceof Situation) {
									neuAngelegteSituation = (Situation) obj;
								} else if (neuesEreignis == null
										&& obj instanceof Ereignis) {
									neuesEreignis = (Ereignis) obj;
								}
							}
						}
						return Status.OK_STATUS;
					}

					@Override
					protected void runInUIThread(final IProgressMonitor monitor) {
						if (status.getSeverity() == IStatus.ERROR) {
							MessageDialog.openError(PlatformUI.getWorkbench()
									.getActiveWorkbenchWindow().getShell(),
									"Fehler", status.getMessage());
							setEnablement(true);
							isBusy = false;
							if (form != null && !form.isDisposed()) {
								form.setBusy(isBusy);
							}
						} else if (checkSaveJob != null) {
							checkSaveJob.schedule(TIMEOUT);
						}
					}
				};
				job.schedule();
			}
		}
	}

	@Override
	public void doSaveAs() {
		// wird nicht untersttzt
	}

	/**
	 * Setzt den Dirty-State dieses Editors.
	 * 
	 * @param dirty
	 *            der neue Dirty-State
	 */
	protected void setDirty(final boolean dirty) {
		if (wrapper != null) {
			wrapper.setDirty(dirty);
		}
		boolean buttonEnablement = wrapper.isDirty();
		if (saveButton.getEnabled() != buttonEnablement) {
			saveButton.setEnabled(buttonEnablement);
		}
		buttonEnablement = buttonEnablement && !wrapper.isNeuesElement();
		if (refreshButton.getEnabled() != buttonEnablement) {
			refreshButton.setEnabled(buttonEnablement);
		}
		firePropertyChange(PROP_DIRTY);
	}

	@Override
	public boolean isDirty() {
		if (wrapper == null) {
			return false;
		}
		return wrapper.isDirty();
	}

	@Override
	public boolean isSaveAsAllowed() {
		return false;
	}

	@Override
	public void setFocus() {
		if (nameText != null && !nameText.isDisposed()) {
			nameText.setFocus();
			nameText.forceFocus();
		}
	}

	@Override
	public void dispose() {
		if (checkSaveJob != null) {
			checkSaveJob.done(Status.CANCEL_STATUS);
			checkSaveJob = null;
		}
		if (updateEditorJob != null) {
			updateEditorJob.done(Status.CANCEL_STATUS);
			updateEditorJob = null;
		}
		BauEditorPlugin.getDefault().getEngstellenCache()
				.removeEngstellenListener(engstellenListener);
		EreignisKalenderVerwaltung.getInstanz().removeEreignisKalenderListener(
				ereignisKalenderListener);
		if (titleImage != null && !titleImage.isDisposed()) {
			titleImage.dispose();
		}
		if (segmenteLabelFont != null && !segmenteLabelFont.isDisposed()) {
			segmenteLabelFont.dispose();
		}
		super.dispose();
	}

	/**
	 * Hilfsklasse, welches die in einem Urlasser-Dialog abgefragten Werte
	 * speichert.
	 * 
	 * @author BitCtrl Systems GmbH, Andreas Meissner
	 * @version $Id: EngstellenEditor.java,v 1.2 2014/11/14 07:29:40 Pittner Exp $
	 */
	public class UrlasserInfo {

		/** Referenz auf ein Benutzer-Systemobjekt. */
		private final Benutzer benutzer;
		/** Der Ursache. */
		private final String ursache;
		/** Der Veranlasser. */
		private final String veranlasser;

		/**
		 * Der Konstruktor.
		 * 
		 * @param benutzer
		 *            der Benutzer
		 * @param ursache
		 *            die Ursache
		 * @param veranlasser
		 *            der Veranlasser
		 */
		public UrlasserInfo(final Benutzer benutzer, final String ursache,
				final String veranlasser) {
			this.benutzer = benutzer;
			this.ursache = ursache;
			this.veranlasser = veranlasser;
		}

		/**
		 * Liefert den Namen des Benutzers zurck.
		 * 
		 * @return den Namen des Benutzers
		 */
		public Benutzer getBenutzer() {
			return benutzer;
		}

		/**
		 * Liefert die Ursache zurck.
		 * 
		 * @return die Ursache
		 */
		public String getUrsache() {
			return ursache;
		}

		/**
		 * Liefert den Namen des Veranlassers zurck.
		 * 
		 * @return den Namen des Veranlassers
		 */
		public String getVeranlasser() {
			return veranlasser;
		}
	}

	/**
	 * Liefert das zu der Engstelle gehrende Wrapper-Objekt zurck.
	 * 
	 * @return das zu der Engstelle gehrende Wrapper-Objekt
	 */
	protected EngstellenWrapper getWrapper() {
		return wrapper;
	}

	/**
	 * Liefert den Default-FocusListener zurck.
	 * 
	 * @param viewer
	 *            einen Viewer oder <code>null</code>
	 * 
	 * @return den Default-FocusListener
	 */
	protected FocusListener getFocusListener(final Viewer viewer) {
		if (viewer != null) {
			return new FocusAdapter() {
				@Override
				public void focusGained(final FocusEvent e) {
					if (selectionProviderWrapper != null) {
						selectionProviderWrapper.setSelectionProvider(viewer);
					}
				}
			};
		}
		return defaultFocusListener;
	}

	/**
	 * Liefert den Prfix fr die PID zurck.
	 * 
	 * @return den Prfix fr die PID
	 */
	protected abstract String getPIDPraefix();

	/**
	 * Fgt eine neu angelegte Situation der entsprechenden Menge im
	 * Verkehrsmodellnetz hinzu.
	 * 
	 * @param situation
	 *            die neu angelegte Situation
	 * 
	 * @return <code>true</code>, wenn die Situation der Menge hinzugefgt
	 *         werden konnte, ansonsten <code>false</code>
	 */
	protected abstract boolean fuegeZuMengeHinzu(Situation situation);

	/**
	 * Liefert die Klasse zu der in diesem Editor editierten Engstellen zurck.
	 * 
	 * @return die Klasse zu der in diesem Editor editierten Engstellen
	 */
	protected abstract Class<? extends Situation> getEngstellenClass();

	/**
	 * Liefert den Beschreibungstext zurck, welcher dem dazugehrigen Ereignis
	 * angefgt werden soll.
	 * 
	 * @param nameEngstelle
	 *            der Name der Engstelle
	 * 
	 * @return den Beschreibungstext, welcher dem dazugehrigen Ereignis
	 *         angefgt werden soll
	 */
	protected abstract String getEreignisBeschreibung(String nameEngstelle);
}
