/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/*
 * Rahmenwerk-Plug-in "Baustellen- und Unfalleingabe"
 * Copyright (C) 2009 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.baueditor.sts.views;

/**
 * Bean, welches die Einstellung der Ansicht 'Engstellen-Navigator' speichert.
 * Dies beinhaltet lediglich die CheckStates der Aktionen.
 * 
 * @author BitCtrl Systems GmbH, Andreas Meissner
 * @version $Id: EngstellenNavigatorViewPartEinstellungen.java,v 1.2 2014/11/14 07:29:42 Pittner Exp $
 */
public class EngstellenNavigatorViewPartEinstellungen extends
		AbstractBauEditorViewPartEinstellungen {

	/** Check-State der Aktion 'Zeige Text-Filter'. */
	private boolean textFilterActionChecked;

	/** Check-State der Aktion 'Filter leere Straen'. */
	private boolean filterActionChecked;

	/**
	 * Der Default-Konstruktor.
	 */
	public EngstellenNavigatorViewPartEinstellungen() {
		filterActionChecked = true;
		textFilterActionChecked = true;
	}

	/**
	 * Liefert <code>true</code> zurck, wenn die Aktion 'Zeige Text-Filter'
	 * aktiviert ist.
	 * 
	 * @return <code>true</code>, wenn die Aktion 'Zeige Text-Filter' aktiviert
	 *         ist, ansonsten false
	 */
	public boolean isTextFilterActionChecked() {
		return textFilterActionChecked;
	}

	/**
	 * Liefert <code>true</code> zurck, wenn die Aktion 'Filter leere Straen'
	 * aktiviert ist.
	 * 
	 * @return <code>true</code>, wenn die Aktion 'Filter leere Straen'
	 *         aktiviert ist, ansonsten false
	 */
	public boolean isFilterActionChecked() {
		return filterActionChecked;
	}

	/**
	 * Setzt das Flag, welches angibt, ob die Aktion 'Zeige Text-Filter'
	 * aktiviert sein soll.
	 * 
	 * @param textFilterActionChecked
	 *            der Zustand der Aktion
	 */
	public void setTextFilterActionChecked(final boolean textFilterActionChecked) {
		this.textFilterActionChecked = textFilterActionChecked;
	}

	/**
	 * Setzt das Flag, welches angibt, ob die Aktion 'Filter leere Straen'
	 * aktiviert sein soll.
	 * 
	 * @param editorActionChecked
	 *            der Zustand der Aktion
	 */
	public void setFilterActionChecked(final boolean editorActionChecked) {
		filterActionChecked = editorActionChecked;
	}
}
