/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.parameter.tsf.mqZuordnung;

import java.util.ArrayList;
import java.util.List;

import de.bsvrz.dav.daf.main.config.SystemObject;

public class EngstelleWrapper
{
  private long _startOffset;
  private long _endOffset;
  private long _laenge;
  private List<SystemObject> _listStrasseSegment = new ArrayList<SystemObject>();
  
  public EngstelleWrapper()
  {
    super();
    _startOffset = 0l;
    _endOffset = 0l;
    _laenge = 0l;
    _listStrasseSegment = new ArrayList<SystemObject>();
  }
  
  public EngstelleWrapper(long startOffset, long endOffset, long laenge, List<SystemObject> listStrasseSegment)
  {
    super();
    _startOffset = startOffset;
    _endOffset = endOffset;
    _laenge = laenge;
    _listStrasseSegment = listStrasseSegment;
  }

  public long getStartOffset()
  {
    return _startOffset;
  }

  public void setStartOffset(long startOffset)
  {
    _startOffset = startOffset;
  }

  public long getEndOffset()
  {
    return _endOffset;
  }

  public void setEndOffset(long endOffset)
  {
    _endOffset = endOffset;
  }

  public long getLaenge()
  {
    return _laenge;
  }

  public void setLaenge(long laenge)
  {
    _laenge = laenge;
  }

  public List<SystemObject> getListStrasseSegment()
  {
    return _listStrasseSegment;
  }

  public void setListStrasseSegment(List<SystemObject> listStrasseSegment)
  {
    _listStrasseSegment = listStrasseSegment;
  }
    
  @Override
  public String toString()
  {
    return "EngstelleWrapper [_endOffset=" + _endOffset + ", _laenge=" + _laenge + ", _listStrasseSegment="
        + _listStrasseSegment + ", _startOffset=" + _startOffset + "]";
  }  
}
