/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.parameter.tsf.mqZuordnung;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import de.bsvrz.buv.rw.basislib.ort.FilterStrassenSegmentOffset;
import de.bsvrz.buv.rw.basislib.ort.FilterBetriebskilometer.Richtung;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.SystemObject;

/**
 * Darstellung des Fensters zur Parameternderung ohne ButtonLeiste
 * 
 * @author Krause
 *
 */
public class MqZuweisungCompositeParameter3 extends Composite
{
  private static final boolean _isDebug = false;
  
  private List<String> _listObjGruppe;
  
  private Composite _composite;

  private MyComparator _comp = new MyComparator();
  
  private Group _groupDefinitionen11;

  private Composite _composite0 = null;

  private Composite _composite1 = null;

  private org.eclipse.swt.widgets.List _list1 = null;

  private org.eclipse.swt.widgets.List _list2 = null;
  
  private Button _addButton = null;

  private Button _subButton = null;

  private Label _label = null;
  
  private Label _label1 = null;
  
  private ResultData _resultData;

//  private Button _btnInput;
  
//  private List<EngstelleWrapper> _valuesList2 = new ArrayList<EngstelleWrapper>();

  private Text _text1;

  private Text _text3;

  private Text _text2;

  private EngstelleWrapper _wrapper = new EngstelleWrapper();

  private OrtsangabeComposite _ortCompVon;

  private OrtsangabeComposite _ortCompBis;

  private ClientDavInterface _connection;

  MqZuweisungCompositeParameter3(Composite parent, int style, List<String> listObjGruppe,
		  ResultData resultData)
  {
    super(parent, style);
    _listObjGruppe = listObjGruppe;
    _resultData = resultData;
    _connection = DaVVerbindung.getInstanz().getDaVVerbindung();
    initialize();
  }
  
  /**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    if ( _isDebug )
      System.out.println(this.getClass().getName() + ":initialize");
    
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.heightHint = -1;
    gridData1.widthHint = -1;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;
    setLayout(new GridLayout(1, false));
    setLayoutData(gridData1);
    GridLayout gridLayout = new GridLayout();
    gridLayout.makeColumnsEqualWidth = false;
    gridLayout.numColumns = 1;
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.heightHint = -1;
    gridData2.widthHint = -1;
    gridData2.horizontalIndent = 0;
    gridData2.verticalAlignment = GridData.FILL;

    _composite = new Composite(this, SWT.NONE);
    _composite.setLayoutData(gridData2);
    _composite.setLayout(gridLayout);

    
    GridData gridData92 = new GridData();
    gridData92.horizontalAlignment = GridData.FILL;
    gridData92.grabExcessHorizontalSpace = true;
    gridData92.verticalAlignment = GridData.FILL;
    gridData92.grabExcessVerticalSpace = true;
//    gridData92.horizontalSpan = 3;
    
    _ortCompVon = new OrtsangabeComposite(_composite, SWT.NONE, DaVVerbindung.getInstanz().getDaVVerbindung(), "Start-Offset");
    _ortCompVon.setLayoutData(gridData92);         
    
    _ortCompBis = new OrtsangabeComposite(_composite, SWT.NONE, DaVVerbindung.getInstanz().getDaVVerbindung(), "Ende-Offset");
    _ortCompBis.setLayoutData(gridData92);         
    
//    createMessquerschnittAuswahl();

//    updateData(null);
  }
  
   
//  public org.eclipse.swt.widgets.List getList1()
//  {
//    return _list1;
//  }
//
//  public org.eclipse.swt.widgets.List getList2()
//  {
//    return _list2;
//  }

  public void updateData(EngstelleWrapper wrapper)
  {
    
    _wrapper = null;
    
//	  _list1.removeAll();  
//    for ( String str : _listObjGruppe )
//    {
//      _list1.add( str );
//    }
//    
//    String[] items = _list1.getItems();
//    java.util.Arrays.sort( items, _comp );
//    _list1.setItems( items );
//
//    _list2.removeAll();
//    if (wrapper != null)
//    {
//      _wrapper  = wrapper;
//      
//      for (String value : wrapper.getListStrasseSegment())
//      {
//        _list2.add(value);
//        _list1.remove(value);
//      }
//      String[] items2 = _list2.getItems();
//      java.util.Arrays.sort(items2, _comp);
//      _list2.setItems(items2);
//    }
    
    if (wrapper != null)
    {
      _wrapper  = wrapper;
      
      
      
      if (wrapper.getListStrasseSegment().size() > 0){        
        SystemObject soSs = wrapper.getListStrasseSegment().get(0);
        String pidStrasseVon = ermittleStrasseVonStrassenSegment(soSs);
//        String pidVon = wrapper.getListStrasseSegment().get(0).getPid();
        long kmOffVon = wrapper.getStartOffset();
        _ortCompVon.setStrassenSegment(pidStrasseVon, soSs.getPid(), kmOffVon);
//        _ortCompVon.setBetriebskilometer(pidStrasseVon, Richtung.WEST, kmVon, "KeineAngabe");
      }
      if (wrapper.getListStrasseSegment().size() > 1){
        SystemObject soSs = wrapper.getListStrasseSegment().get(1);
        String pidStrasseBis = ermittleStrasseVonStrassenSegment(soSs);
        long kmOffBis = wrapper.getEndOffset();        
        _ortCompBis.setStrassenSegment(pidStrasseBis, soSs.getPid(), kmOffBis);
//        _ortCompBis.setBetriebskilometer(pidStrasseBis, Richtung.WEST, kmBis, "KeineAngabe");
      }      
    }    
  }

  private String ermittleStrasseVonStrassenSegment(SystemObject soSs)
  {
    AttributeGroup atg = _connection.getDataModel().getAttributeGroup("atg.straenSegment");
    Data cd = soSs.getConfigurationData(atg);
    String pidStrasse = cd.getItem("gehrtZuStrae").asReferenceValue().getSystemObjectPid();
    return pidStrasse;
  }


  /**
   * Methode erteugt die Darstellung der Auswahl der Messquerschnitte
   * 
   */
  private void createMessquerschnittAuswahl()
  {
    FillLayout fillLayout = new FillLayout();
    fillLayout.type = org.eclipse.swt.SWT.HORIZONTAL;
    
    RowLayout rowLayout3 = new RowLayout();
    rowLayout3.type = org.eclipse.swt.SWT.VERTICAL;
    rowLayout3.justify = false;
    rowLayout3.wrap = false;
    rowLayout3.pack = false;
    rowLayout3.spacing = 25;
    rowLayout3.fill = false;
    
    GridData gridData22 = new GridData();
    gridData22.horizontalAlignment = GridData.CENTER;
    gridData22.grabExcessVerticalSpace = false;
    gridData22.grabExcessHorizontalSpace = false;
    gridData22.verticalAlignment = GridData.CENTER;

    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.verticalAlignment = GridData.FILL;
    
    _groupDefinitionen11 = new Group(_composite, SWT.NONE);
    _groupDefinitionen11.setText("TSF-Engstellen");
    _groupDefinitionen11.setLayout(fillLayout);
    _groupDefinitionen11.setLayoutData(gridData2);
    
    GridData gridData41 = new GridData();
    gridData41.horizontalAlignment = GridData.FILL;
    gridData41.grabExcessHorizontalSpace = true;
    gridData41.verticalAlignment = GridData.FILL;
    gridData41.grabExcessVerticalSpace = true;
    gridData41.widthHint = 200;
    
    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.CENTER;
    gridData21.verticalAlignment = GridData.CENTER;
    
    GridData gridData12 = new GridData();
    gridData12.horizontalAlignment = GridData.CENTER;
    gridData12.verticalAlignment = GridData.CENTER;
    
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.FILL;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.FILL;
    gridData3.grabExcessVerticalSpace = true;
    gridData3.widthHint = 200;

    //GridLayout mit Anzahl Spalten
    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 3;
    gridLayout.marginHeight = 5;
    gridLayout.marginWidth = 5;
    
    _composite0 = new Composite(_groupDefinitionen11, SWT.NONE);
    _composite0.setLayout(gridLayout);
    _label = new Label(_composite0, SWT.NONE);
    _label.setText("verfgbare StrassenSegmente");
    _label.setLayoutData(gridData12);
    new Label(_composite0, SWT.NONE);
    _label1 = new Label(_composite0, SWT.NONE);
    _label1.setText("zugeordnete StrassenSegmente");
    _label1.setLayoutData(gridData21);
//    new Label(_composite0, SWT.NONE);
    
    _list1 = new org.eclipse.swt.widgets.List(_composite0, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
    _list1.setLayoutData(gridData3);

    _composite1 = new Composite(_composite0, SWT.NONE);
    _composite1.setLayoutData(gridData22);
    _composite1.setLayout(rowLayout3);
    _addButton = new Button(_composite1, SWT.NONE);
    _addButton.setText("<");
    _addButton.addMouseListener(new MouseAdapter() {
      @Override
      public void mouseDown(MouseEvent e)
      {
        String[] selection = _list2.getSelection();
        for (String string : selection)
        {
          _list1.add(string);
          _wrapper.getListStrasseSegment().remove(string);
          _list2.remove(string);
        }

        String[] items = _list1.getItems();
        java.util.Arrays.sort(items, _comp);
        _list1.setItems(items);

        String[] items2 = _list2.getItems();
        java.util.Arrays.sort(items2, _comp);
        _list2.setItems(items2);

      }
    });
    _subButton = new Button(_composite1, SWT.NONE);
    _subButton.setText(">");
    _subButton.addMouseListener(new MouseAdapter() {
      @Override
      public void mouseDown(MouseEvent e)
      {
        String[] selection = _list1.getSelection();
        for (String string : selection)
        {
          _list2.add(string);
//          _wrapper.getListStrasseSegment().add(string);
          _list1.remove(string);
        }

        String[] items = _list2.getItems();
        java.util.Arrays.sort(items, _comp);
        _list2.setItems(items);

        String[] items2 = _list1.getItems();
        java.util.Arrays.sort(items2, _comp);
        _list1.setItems(items2);

      }
    });
    _list2 = new org.eclipse.swt.widgets.List(_composite0, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
    _list2.setLayoutData(gridData41);
    _list2.addSelectionListener(new SelectionAdapter() {
      
      @Override
      public void widgetSelected(SelectionEvent e)
      {
        
        String[] selection = _list2.getSelection();
        if (selection != null && selection.length > 0)
        {
          Object object = _wrapper.getListStrasseSegment().get(0);
          if (object instanceof EngstelleWrapper)
          {
            EngstelleWrapper wrapper = (EngstelleWrapper)object; 
            _text1.setText("" + wrapper.getStartOffset());
            _text2.setText("" + wrapper.getEndOffset());
            _text2.setText("" + wrapper.getLaenge());
//            _btnInput.setSelection(verwenden);            
          }
        }        
      }      
    });    
    
    GridData gridData91 = new GridData();
    gridData91.horizontalAlignment = GridData.FILL;
    gridData91.grabExcessHorizontalSpace = true;
    gridData91.verticalAlignment = GridData.FILL;
    gridData91.grabExcessVerticalSpace = true;
    gridData91.horizontalSpan = 3;
    
    _text1 = new Text(_composite0, SWT.BORDER);
    _text1.setLayoutData(gridData91);
    _text1.setText("Start Offset");
    _text1.addModifyListener(new ModifyListener() {
      
      @Override
      public void modifyText(ModifyEvent e)
      {
        String[] selection = _list2.getSelection();
        if (selection != null && selection.length > 0)
        {
          for (String name : selection)
          {
            if (_wrapper.getListStrasseSegment().contains(name)){
              _wrapper.setStartOffset(new Long(_text1.getText()));
            }
          }          
        }
        
      }
    });
    
    _text2 = new Text(_composite0, SWT.BORDER);
    _text2.setLayoutData(gridData91);
    _text2.setText("Ende Offset");
    _text2.addModifyListener(new ModifyListener() {
      
      @Override
      public void modifyText(ModifyEvent e)
      {
        String[] selection = _list2.getSelection();
        if (selection != null && selection.length > 0)
        {
          for (String name : selection)
          {
            if (_wrapper.getListStrasseSegment().contains(name)){
              _wrapper.setEndOffset(new Long(_text2.getText()));
            }             
          }          
        }
        
      }
    });
    
    _text3 = new Text(_composite0, SWT.BORDER);
    _text3.setLayoutData(gridData91);
    _text3.setText("Lnge");
    _text3.addModifyListener(new ModifyListener() {
      
      @Override
      public void modifyText(ModifyEvent e)
      {
        String[] selection = _list2.getSelection();
        if (selection != null && selection.length > 0)
        {
          for (String name : selection)
          {
            if (_wrapper.getListStrasseSegment().contains(name)){
              _wrapper.setLaenge(new Long(_text3.getText()));
            }
          }          
        }        
      }
    });
  }

  /**
   * Interne Klasse zum Vergleich
   * 
   * @author Krause
   * 
   */
  private class MyComparator implements Comparator<String>
  {

    @Override
    public int compare(String o1, String o2)
    {
      int ret = 0;
      
      //String-Sortierung
      if ( o1 != null )
        ret = o1.compareTo( o2 );
     
//      //Integer-Sortierung
//      Integer i1 = new Integer(o1);
//      Integer i2 = new Integer(o2);
//
//      if (i1 < i2)
//        ret = -1;
//      else if (i1 == i2)
//        ret = 0;
//      else if (i1 > i2)
//        ret = 1;
      
      return ret;
      
    }

  }
  
  public ResultData getResultData() {
		return _resultData;
  }
  
  public void setResultData(ResultData resultData) {
		_resultData = resultData;
  }

  public EngstelleWrapper getWrapper()
  {
    long kmVon = 0;
    String pidSsVon = _ortCompVon.getFilterStrassenSegmentOffset().getPidSelektiertesStrassenSegment();
    if (pidSsVon != null){
      SystemObject soVon = _connection.getDataModel().getObject(pidSsVon);
      kmVon = _ortCompVon.getFilterStrassenSegmentOffset().getKm();
      _wrapper.setStartOffset(kmVon);      
      if (soVon != null && !_wrapper.getListStrasseSegment().contains(soVon)){      
        _wrapper.getListStrasseSegment().add(soVon);
      }
    }
    long kmBis = 0;
    String pidSsbis = _ortCompBis.getFilterStrassenSegmentOffset().getPidSelektiertesStrassenSegment();
    if (pidSsVon != null){
      kmBis = _ortCompBis.getFilterStrassenSegmentOffset().getKm();
      _wrapper.setEndOffset(kmBis);
      SystemObject soBis = _connection.getDataModel().getObject(pidSsbis);
      if (soBis != null && !_wrapper.getListStrasseSegment().contains(soBis)){        
        _wrapper.getListStrasseSegment().add(soBis);
      }
    }
    
    long laenge = kmBis - kmVon;
    if (laenge < 0)
      _wrapper.setLaenge(-1);
    else
      _wrapper.setLaenge(laenge);        
    
    return _wrapper;
  }
 
}
