/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.pua.a81.projektInfo;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import de.bsvrz.buv.plugin.pua.basis.expose.IPIGanglinienKonvertierung;

public class ProjektInfoAqBefehle implements IPIGanglinienKonvertierung
{
//  protected int SPALTE_BLINKER_LINKS = 0;
//  protected int SPALTE_TSF_LINKS = 1;
//  protected int SPALTE_BAQ_LINKS = 1;
//  protected int SPALTE_ATYP_4UEFS = 2;
//  protected int SPALTE_BTYP_4UEFS_3UEFS = 3;
//  protected int SPALTE_CTYP_4UEFS_3UEFS = 4;
//  protected int SPALTE_ATYP_3UEFS = 5;
//  protected int SPALTE_BTYP_3UEFS_2UEFS = 6;
//  protected int SPALTE_CTYP_3UEFS_2UEFS = 7;
//  protected int SPALTE_ATYP_2UEFS = 8;
//  protected int SPALTE_BTYP_2UEFS_1UEFS = 9;
//  protected int SPALTE_CTYP_2UEFS_1UEFS = 10;
//  protected int SPALTE_BLINKER_WAQ = 10;
//  protected int SPALTE_ATYP_1UEFS = 11;
//  protected int SPALTE_WAQ = 11;
//  protected int SPALTE_BTYP_1UEFS_HFS = 12;
//  protected int SPALTE_CTYP_1UEFS_HFS = 13;
//  protected int SPALTE_ATYP_HFS = 14;
//  protected int SPALTE_ATYP_1UEFS_EIN = 15;
//  protected int SPALTE_BTYP_1UEFS_HFS_EIN = 16;
//  protected int SPALTE_CTYP_1UEFS_HFS_EIN = 17;
//  protected int SPALTE_DTYP = 18;
//  protected int SPALTE_ATYP_HFS_EIN = 19;
//  protected int SPALTE_ATYP_TSF = 19;
//  protected int SPALTE_TSF_RECHTS = 20;
//  protected int SPALTE_BAQ_RECHTS = 20;
//  protected int SPALTE_BLINKER_RECHTS = 21;
//  protected int SPALTE_DZEILE = 22;
  protected int SPALTE_ATYP_3UEFS = 0;
  protected int SPALTE_BTYP_3UEFS_2UEFS = 1;
  protected int SPALTE_CTYP_3UEFS_2UEFS = 2;
  protected int SPALTE_ATYP_2UEFS = 3;
  protected int SPALTE_BLINKER_2UEFS_1UEFS = 4;
  protected int SPALTE_BTYP_2UEFS_1UEFS = 5;
  protected int SPALTE_CTYP_2UEFS_1UEFS = 6;
  protected int SPALTE_ATYP_1UEFS = 7;
  protected int SPALTE_BLINKER_1UEFS_HFS = 8;
  protected int SPALTE_BTYP_1UEFS_HFS = 9;
  protected int SPALTE_CTYP_1UEFS_HFS = 10;
  protected int SPALTE_ATYP_HFS = 11;
  protected int SPALTE_BLINKER_VZ = 12;
  protected int SPALTE_DZEILE = 13;
  
	protected final List<String> _ausgabeTabelleSpalten = new ArrayList<String>() 
	{
		{
      // SBA A8 Gesamt

//      add("Blinker links"); // 0
//      add("TSF/BAQ links"); // 1
//
//      add("A-Typ (4FS)"); // 2
//      add("B-Typ (4FS/3FS)"); // 3
//      add("C-Typ (4FS/3FS)"); // 4
//      
//      add("A-Typ (3FS)"); // 5
//      add("B-Typ (3FS/2FS)"); // 6
//      add("C-Typ (3FS/2FS)"); // 7
//      
//      add("A-Typ (2FS)"); // 8
//      add("B-Typ (2FS/1FS)"); // 9
//      add("C-Typ (2FS/1FS) / Bl. WAQ"); // 10
//      
//      add("A-Typ (1FS) / WAQ"); // 11
//      add("B-Typ (1FS/HFS)"); // 12
//      add("C-Typ (1FS/HFS)"); //13
//      
//      add("A-Typ (HFS)"); //14
//
//      add("A-Typ (1FS Ein)"); // 15
//      add("B-Typ (1FS/HFS Ein)"); // 16
//      add("C-Typ (1FS/HFS Ein)"); //17
//
//      add("d-Typ (TSF)"); //18
//
//      add("A-Typ (TSF / HFS Ein)"); //19
//
//      add("TSF/BAQ rechts"); // 20
//      add("Blinker rechts"); // 21
//
//      add("D-Zeile"); // 22

      // SBA A81 Gesamt

      add("A-Typ (3FS)"); // 0
      add("B-Typ (3FS/2FS)"); // 1
      add("C-Typ (3FS/2FS)"); // 2
      
      add("A-Typ (2FS)"); // 3
      add("Blinker (2FS/1FS)"); // 4
      add("B-Typ (2FS/1FS)"); // 5
      add("C-Typ (2FS/1FS)"); // 6
      
      add("A-Typ (1FS)"); // 7
      add("Blinker (1FS/HFS)"); // 8
      add("B-Typ (1FS/HFS)"); // 9
      add("C-Typ (1FS/HFS)"); // 10
      
      add("A-Typ (HFS)"); // 11
      
      add("Blinker VZ"); // 12

      add("D-Zeile"); // 13
		}
	};
	
	protected final Map<String, Integer> _spaltenIndexRelativ = new HashMap<String, Integer>() 
	{
		{
		  // N01
      put("anzeige.A81.5139.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5139.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5139.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5139.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5139.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5139.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5139.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5139.HFB.N.anzeige8", SPALTE_DZEILE);

      // N02
      put("anzeige.A81.5137.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5137.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5137.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5137.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5137.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5137.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5137.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5137.HFB.N.anzeige8", SPALTE_DZEILE);

      // N03
      put("anzeige.A81.5135.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5135.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5135.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5135.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5135.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5135.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5135.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5135.HFB.N.anzeige8", SPALTE_DZEILE);

      // N04
      put("anzeige.A81.5134.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5134.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5134.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5134.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5134.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5134.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5134.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N05
      put("anzeige.A81.5133.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5133.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5133.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5133.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5133.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5133.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5133.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N06
      put("anzeige.A81.5129.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5129.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5129.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5129.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5129.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5129.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5129.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5129.HFB.N.anzeige8", SPALTE_DZEILE);

      // N07
      put("anzeige.A81.5124.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5124.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5124.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5124.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5124.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5124.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5124.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N08
      put("anzeige.A81.5118.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5118.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5118.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5118.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5118.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5118.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5118.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5118.HFB.N.anzeige8", SPALTE_DZEILE);

      // N09
      put("anzeige.A81.5114.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5114.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5114.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5114.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5114.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5114.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5114.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N10
      put("anzeige.A81.5109.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5109.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5109.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5109.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5109.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5109.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5109.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5109.HFB.N.anzeige8", SPALTE_DZEILE);

      // N11     
      put("anzeige.A81.5108.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5108.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5108.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5108.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5108.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5108.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5108.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N12     
      put("anzeige.A81.5107.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5107.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5107.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5107.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5107.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5107.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5107.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N13
      put("anzeige.A81.5105.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5105.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5105.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5105.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5105.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5105.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5105.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N14
      put("anzeige.A81.5104.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5104.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5104.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5104.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5104.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5104.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5104.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5104.HFB.N.anzeige8", SPALTE_DZEILE);

      // N15
      put("anzeige.A81.5102.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5102.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5102.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5102.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5102.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5102.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5102.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // N16     
      put("anzeige.A81.5101.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5101.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5101.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5101.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5101.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5101.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5101.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      
      // S01
      put("anzeige.A81.5001.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5001.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5001.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5001.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5001.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5001.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5001.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5001.HFB.S.anzeige8", SPALTE_DZEILE);
      
      // S02
      put("anzeige.A81.5002.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5002.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5002.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5002.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5002.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5002.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5002.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      
      // S03     
      put("anzeige.A81.5003.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5003.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5003.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5003.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5003.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5003.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5003.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // S04     
      put("anzeige.A81.5004.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5004.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5004.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5004.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5004.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5004.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5004.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5004.HFB.S.anzeige8", SPALTE_DZEILE);

      // S05     
      put("anzeige.A81.5005.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5005.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5005.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5005.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5005.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5005.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5005.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // S06     
      put("anzeige.A81.5006.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5006.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5006.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5006.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5006.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5006.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5006.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);

      // S07     
      put("anzeige.A81.5007.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5007.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5007.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5007.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5007.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5007.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5007.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5007.HFB.S.anzeige8", SPALTE_DZEILE);

      // S08     
      put("anzeige.A81.5008.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5008.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5008.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5008.HFB.S.anzeige4", SPALTE_ATYP_3UEFS);
      put("anzeige.A81.5008.HFB.S.anzeige5", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5008.HFB.S.anzeige6", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5008.HFB.S.anzeige7", SPALTE_BTYP_3UEFS_2UEFS);
      put("anzeige.A81.5008.HFB.S.anzeige8", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5008.HFB.S.anzeige9", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5008.HFB.S.anzeige10", SPALTE_CTYP_3UEFS_2UEFS);
      put("anzeige.A81.5008.HFB.S.anzeige11", SPALTE_DZEILE);

      // S09     
      put("anzeige.A81.5013.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5013.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5013.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5013.HFB.S.anzeige4", SPALTE_ATYP_3UEFS);
      put("anzeige.A81.5013.HFB.S.anzeige5", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5013.HFB.S.anzeige6", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5013.HFB.S.anzeige7", SPALTE_BTYP_3UEFS_2UEFS);
      put("anzeige.A81.5013.HFB.S.anzeige8", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5013.HFB.S.anzeige9", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5013.HFB.S.anzeige10", SPALTE_CTYP_3UEFS_2UEFS);
      
      // S10     
      put("anzeige.A81.5018.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5018.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5018.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5018.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5018.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5018.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5018.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5018.HFB.S.anzeige8", SPALTE_DZEILE);
      
      // S11     
      put("anzeige.A81.5019.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5019.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5019.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5019.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5019.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5019.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5019.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      
      // S12     
      put("anzeige.A81.5024.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5024.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5024.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5024.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5024.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5024.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5024.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      
      // S13     
      put("anzeige.A81.5025.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5025.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5025.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5025.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5025.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5025.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5025.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5025.HFB.S.anzeige8", SPALTE_DZEILE);
      
      // S14     
      put("anzeige.A81.5026.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5026.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5026.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5026.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5026.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5026.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5026.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      
      // S15     
      put("anzeige.A81.5028.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5028.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5028.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5028.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5028.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5028.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5028.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      
      // S16    
      put("anzeige.A81.5029.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5029.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5029.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5029.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5029.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5029.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5029.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5029.HFB.S.anzeige8", SPALTE_DZEILE);
      
      // S17    
      put("anzeige.A81.5030.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5030.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5030.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5030.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5030.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5030.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5030.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5030.HFB.S.anzeige8", SPALTE_DZEILE);
      
      // N2a
      put("anzeige.A81.5404.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5404.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5404.HFB.N.anzeige3", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5404.HFB.N.anzeige4", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5404.HFB.N.anzeige5", SPALTE_BLINKER_1UEFS_HFS);
      put("anzeige.A81.5404.HFB.N.anzeige6", SPALTE_BLINKER_VZ);
      
      //N2b
      put("anzeige.A81.5403.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5403.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5403.HFB.N.anzeige3", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5403.HFB.N.anzeige4", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5403.HFB.N.anzeige5", SPALTE_BLINKER_1UEFS_HFS);
      put("anzeige.A81.5403.HFB.N.anzeige6", SPALTE_BLINKER_VZ);
      
      //N4
      put("anzeige.A81.5406.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5406.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5406.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5406.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5406.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5406.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5406.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5406.HFB.N.anzeige8", SPALTE_BLINKER_1UEFS_HFS);
      put("anzeige.A81.5406.HFB.N.anzeige9", SPALTE_BLINKER_2UEFS_1UEFS);
      
      //N5
      put("anzeige.A81.5407.HFB.N.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5407.HFB.N.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5407.HFB.N.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5407.HFB.N.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5407.HFB.N.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5407.HFB.N.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5407.HFB.N.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5407.HFB.N.anzeige8", SPALTE_BLINKER_1UEFS_HFS);
      put("anzeige.A81.5407.HFB.N.anzeige9", SPALTE_BLINKER_2UEFS_1UEFS);
      
      //S2
      put("anzeige.A81.5202.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5202.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5202.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5202.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5202.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5202.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5202.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5202.HFB.S.anzeige8", SPALTE_BLINKER_1UEFS_HFS);
      put("anzeige.A81.5202.HFB.S.anzeige9", SPALTE_BLINKER_2UEFS_1UEFS);
      put("anzeige.A81.5202.HFB.S.anzeige10", SPALTE_BLINKER_VZ);
      
      //S4
      put("anzeige.A81.5204.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5204.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5204.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5204.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5204.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5204.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5204.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5204.HFB.S.anzeige8", SPALTE_BLINKER_1UEFS_HFS);
      put("anzeige.A81.5204.HFB.S.anzeige9", SPALTE_BLINKER_2UEFS_1UEFS);
      put("anzeige.A81.5204.HFB.S.anzeige10", SPALTE_BLINKER_VZ);
      
      //S5
      put("anzeige.A81.5205.HFB.S.anzeige1", SPALTE_ATYP_HFS);
      put("anzeige.A81.5205.HFB.S.anzeige2", SPALTE_ATYP_1UEFS);
      put("anzeige.A81.5205.HFB.S.anzeige3", SPALTE_ATYP_2UEFS);
      put("anzeige.A81.5205.HFB.S.anzeige4", SPALTE_BTYP_1UEFS_HFS);
      put("anzeige.A81.5205.HFB.S.anzeige5", SPALTE_BTYP_2UEFS_1UEFS);
      put("anzeige.A81.5205.HFB.S.anzeige6", SPALTE_CTYP_1UEFS_HFS);
      put("anzeige.A81.5205.HFB.S.anzeige7", SPALTE_CTYP_2UEFS_1UEFS);
      put("anzeige.A81.5205.HFB.S.anzeige8", SPALTE_BLINKER_1UEFS_HFS);
      put("anzeige.A81.5205.HFB.S.anzeige9", SPALTE_BLINKER_2UEFS_1UEFS);
		}
	 };
	 
	protected final Map<String, String> _bildInhalt = new HashMap<String, String>() 
	{
		{
  		put("Beibehalten", "Beibehalten");
      put("Beliebig", "Beliebig");
      put("DontCare", "don't care");
      put("Dunkel", "Aus");
      put("TLS.500Meter", "500 m");
      put("TLS.1000Meter", "1000 m");
      put("TLS.1500Meter", "1500 m");
      put("TLS.2000Meter", "2000 m");
      put("TLS.2500Meter", "2500 m");
      put("TLS.7Komma5Tonnen", "7,5 t");
      put("TLS-AS.Gltte", "Gltte");
      put("TLS-AS.lspur", "lspur");
      put("TLS.Auf500Meter", "Auf 500 m");
      put("TLS.Auf1000Meter", "Auf 1000 m");
      put("TLS.Auf1500Meter", "Auf 1500 m");
      put("TLS.Auf2000Meter", "Auf 2000 m");
      put("TLS.Auf2500Meter", "Auf 2500 m");
      put("TLS.Baustelle", "Baustelle");
      put("TLS.EndeAllerStreckenverbote", "Ende alles");
      put("TLS.EndeUeberholverbotAllgemein", "Ende V");
      put("TLS.EndeUeberholverbotLkw", "Ende V Lkw");
      put("TLS.EndeZulaessigeHoechst100", "Ende 100 km/h");
      put("TLS.EndeZulaessigeHoechst120", "Ende 120 km/h");
      put("TLS.EndeZulaessigeHoechst40", "Ende 40 km/h");
      put("TLS.EndeZulaessigeHoechst50", "Ende 50 km/h");
      put("TLS.EndeZulaessigeHoechst60", "Ende 60 km/h");
      put("TLS.EndeZulaessigeHoechst80", "Ende 80 km/h");
      put("TLS.EndeZulaessigeHoechst130", "Ende 130 km/h");
      put("TLS.FahrstreifenGesperrt", "Gesperrt");
      put("TLS.FahrstreifenHalten", "Halten");
      put("TLS.FahrstreifenWechselnNachLinks", "Links");
      put("TLS.FahrstreifenWechselnNachRechts", "Rechts");
      put("TLS.Gefahrenstelle", "Gefahr");
      put("TLS.GelbesBlinklicht", "Blinken");
      put("TLS.Glaettegefahr", "Gltte");
      put("TLS.Naesse", "Nsse");
      put("TLS.Nebel", "Nebel");
      put("TLS.Schleudergefahr", "Schleuder");
      put("TLS.Sicht", "Sicht");
      put("TLS.Smog", "Smog");
      put("TLS.Stau", "Stau");
      put("TLS.Staugefahr", "Staugefahr");
      put("TLS.UeberholverbotAllgemein", "V");
      put("TLS.UeberholverbotLkw", "V Lkw");
      put("TLS.Unfall", "Unfall");
      put("TLS.ZulaessigeHoechst100", "100 km/h");
      put("TLS.ZulaessigeHoechst120", "120 km/h");
      put("TLS.ZulaessigeHoechst40", "40 km/h");
      put("TLS.ZulaessigeHoechst50", "50 km/h");
      put("TLS.ZulaessigeHoechst60", "60 km/h");
      put("TLS.ZulaessigeHoechst80", "80 km/h");
      put("TLS.ZulaessigeHoechst130", "130 km/h");
      put("TLS.3000Meter", "3000 m");
      put("TLS.1Kilometer", "1 km");
      put("TLS.1Komma5Kilometer", "1,5 km");
      put("TLS.2Kilometer", "2 km");
      put("TLS.2Komma5Kilometer", "2,5 km");
      put("TLS.3Kilometer", "3 km");
      put("TLS.Tiere", "Tiere");
      put("TLS.Kontrolle", "Kontrolle");
      put("TLS.Oelspur", "lspur");
        
      put("TLS.DunkelStau", "Dunkel im Stau");
        
      put("TLS.BlockabfertigungLkw", "Blockabfertigung Lkw");
      put("TLS.BlockabfertigungLkwStop", "Blockabfertigung Lkw Stop");
               
      put("TLS.Neutral", "neutral");
      put("TLS.Unbeklebt", "neutral");
                
      put("TLS.SeitenstreifenBefahren", "Seitenstreifen befahren");
      put("TLS.SeitenstreifenNichtBefahren", "Seitenstreifen nicht befahren");
      put("TLS.SeitenstreifenRaeumen", "Seitenstreifen rumen");
                  
      put("TLS.PrismaSeite1", "Prisma Seite 1");
      put("TLS.PrismaSeite2", "Prisma Seite 2");
      put("TLS.PrismaSeite3", "Prisma Seite 3");
      put("TLS.PrismaSeite4", "Prisma Seite 4");	
	  }	 
  };
  
  protected final Map<String, Integer> _bildInhaltWerte = new HashMap<String, Integer>() 
  {
    {
      // Allgemein
      put("Dunkel", 160);
      
      // A-Zeichen 
      put("TLS.EndeZulaessigeHoechst130", 140);
      put("TLS.EndeZulaessigeHoechst120", 140);
      put("TLS.EndeZulaessigeHoechst100", 140);
      put("TLS.EndeZulaessigeHoechst80", 140);
      put("TLS.EndeZulaessigeHoechst60", 140);
      put("TLS.EndeZulaessigeHoechst50", 140);
      put("TLS.EndeZulaessigeHoechst40", 140);
      
      put("TLS.ZulaessigeHoechst130", 130);
      put("TLS.ZulaessigeHoechst120", 120);
      put("TLS.ZulaessigeHoechst100", 100);
      put("TLS.ZulaessigeHoechst80", 80);
      put("TLS.ZulaessigeHoechst60", 60);
      put("TLS.ZulaessigeHoechst50", 50);
      put("TLS.ZulaessigeHoechst40", 40);
             
      put("TLS.DunkelStau", 20);
      
      put("TLS.FahrstreifenWechselnNachRechts", 10);
      put("TLS.FahrstreifenWechselnNachLinks", 10);
      put("TLS.FahrstreifenGesperrt", 5);
      
      // B-Zeichen
      put("TLS.Glaettegefahr", 180);
      put("TLS-AS.Gltte", 180);
      
      put("TLS.EndeAllerStreckenverbote", 130);
      put("TLS.EndeUeberholverbotAllgemein", 130);
      put("TLS.EndeUeberholverbotLkw", 130);
      
      put("TLS.UeberholverbotAllgemein", 110);
      put("TLS.UeberholverbotLkw", 90);
      put("TLS.Baustelle", 70);
      put("TLS.Gefahrenstelle", 50);
      put("TLS.Schleudergefahr", 30);
      put("TLS.Stau", 15);
    }  
  };
	
	public int getAnzahlAttribute() 
	{
		return _ausgabeTabelleSpalten.size();
	}
	 
	public List<String> getAusgabeTabelleSpalten() 
	{
		return Collections.unmodifiableList(_ausgabeTabelleSpalten);
	}
	
	public int getSpaltenIndexRelativ(String pid) 
	{
		Integer result = _spaltenIndexRelativ.get(pid);
		return result != null ? result : -1;
	}
	
	public String getBildInhalt(String bildInhalt) 
	{
		return _bildInhalt.get(bildInhalt);
	}
	
	public boolean isAttributKonvertierbar(String attribut) {
	  return attribut != null && (attribut.startsWith("A-Typ") || attribut.startsWith("B-Typ")); 
	}
	
	public String getWertKonvertiert(String attribut, String value, String objekt) {
	  
	    String key = null;
	    
	    for (Map.Entry<String, String> entry: _bildInhalt.entrySet()) {
	      if (entry.getValue().equals(value)) {
	        key = entry.getKey();
	        break;
	      }
	    }
	    
	    if (key != null) {
	      Integer result = _bildInhaltWerte.get(key);
	      if (result == null) {
	        result = 200;
	      }
	      return String.valueOf(result);
	    }
	    else {
	      return null;  
	    }
	}

  @Override
  public String getAttributKonvertiert(String attribut)
  {
    String result = attribut;
    if (isAttributKonvertierbar(attribut)) {
      int kla = attribut.indexOf("[");
      int klz = attribut.indexOf("]"); 
      if (kla < 0 || klz < kla)
      {
        result = attribut.trim() + " [km/h]";
      }
    }
    return result ;
  }
  
  @Override
  public long getMilliesTreppenfunktionErgaenzen()
  {
    return 1000;
  }
  
  @Override
  public boolean anfangAuffuellen() {
    return true;
  }
  
  @Override
  public boolean endeAuffuellen() {
    return true;
  }
  
  protected final List<String> _zuIgnorierendeWerte = new ArrayList<String>() {
    {
      add("");
    }
  };
  
  @Override
  public Collection<String> getZuIgnorierendeWerte() {
    return Collections.unmodifiableList(_zuIgnorierendeWerte);
  }
	
}
