/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Vector;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import de.bsvrz.buv.plugin.pua.basis.protokolleUpdateListener.ProtokolleUpdateListener;
import de.bsvrz.buv.plugin.pua.basis.pua.ZugriffPua;
import de.bsvrz.buv.plugin.pua.basis.pua.daten.ProtokollInformationen;
import de.bsvrz.buv.rw.rw.dav.BenutzerAngemeldet;

/**
 * Klasse realisiert einen Thread zur Entkopplung des Zugriffs auf die PUA
 * 
 * @author Pittner
 * 
 */
public class AktualisiereThread implements Runnable {

	private SimpleDateFormat _sdf = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss");

	private ZugriffPua _zugriffPuA;

	private Thread _t;

	public AktualisiereThread() {
		// TODO Auto-generated constructor stub
		_zugriffPuA = ZugriffPua.getInstanz(DaVKommunikation.getInstanz()
				.holeDaVVerbindung());
		_t = new Thread(this);
		_t.start();

	}

	private boolean aktualisiereUngeleseneProtokolle() {
		boolean b = _zugriffPuA.aktualisiereListeUngeleseneProtokolle(BenutzerAngemeldet.getInstanz().getName());

		if (b) {

			Vector<ProtokollInformationen> lup = _zugriffPuA
					.getListeUngeleseneProtokolle();

			List<ProtokollInformationen> list = new ArrayList<ProtokollInformationen>();

			for (ProtokollInformationen pi : lup) {
				list.add(pi);
			}

			final List<ProtokollInformationen> flist = list;

			String s = "Stand: " + _sdf.format(new Date());
			ProtokolleUpdateListener.getInstanz()
					.notifyProtokolleDataUpdateListener(
							new Object[] { flist, s });
		}
		return b;

	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		while (true) {
			aktualisiereUngeleseneProtokolle();
			try {
				Thread.sleep(5000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void stop() {
		// TODO Auto-generated method stub
		_t.stop();
	}

}
