/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis.actions;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.pua.basis.Activator;
import de.bsvrz.buv.plugin.pua.basis.expose.IObjektProvider;
import de.bsvrz.buv.plugin.pua.basis.extension.SkriptInfo;
import de.bsvrz.buv.plugin.pua.basis.views.ProtokollierungView;

public class ActionSkriptDefault  implements IWorkbenchWindowActionDelegate {
	@Override
	public void run(IAction action)
	{
		String secondaryViewId = action.getId();
				
	    try
	    {
	    	starteViewWithSecondaryId(secondaryViewId);	
	    }
	    catch (PartInitException e)
	    {
	      String msg = "Die Sicht " + ProtokollierungView.class.getName() +
	      	" mit der Id " + ProtokollierungView.ID + " und der Secondary Id "+
	      	" konnte nicht geffnet werden";
	      Activator.getDefault().getLog().log(new Status(Status.ERROR, Activator.PLUGIN_ID, msg, e));
	      System.err.println(msg);
	      e.printStackTrace(System.err);
	    }
	  }

	  @Override
	  public void selectionChanged(IAction action, ISelection selection)
	  {
	  }

	  @Override
	  public void dispose()
	  {
	  }

	  @Override
	  public void init(IWorkbenchWindow window)
	  {
	  }
	  
	  private void starteViewWithSecondaryId(String secondaryId) throws PartInitException
	  {
		IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
	    IWorkbenchPage page = dw.getActivePage();	  
	    page.showView(ProtokollierungView.ID, secondaryId, IWorkbenchPage.VIEW_ACTIVATE);
	  }

}
