/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.diagram;

import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.awt.RenderingHints;
import java.lang.reflect.Field;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.GregorianCalendar;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import com.swarco.sts.chart.control.AbscissaImage;
import com.swarco.sts.chart.control.AbscissaLabel;
import com.swarco.sts.chart.control.AbscissaPanel;
import com.swarco.sts.chart.control.TAxis;
import com.swarco.sts.chart.control.TChart;
import com.swarco.sts.chart.control.TChartComponent;
import com.swarco.sts.chart.control.TSeries;
import com.swarco.sts.chart.control.event.TActionEvent;
import com.swarco.sts.chart.control.event.TActionListener;
import com.swarco.sts.chart.control.format.defaults.TDecimalFormat;
import com.swarco.sts.chart.control.format.interfaces.TFormat;
import com.swarco.sts.chart.control.graphics.interfaces.TGraphicsSettings;
import com.swarco.sts.chart.control.label.defaults.TPdfCapableLabel;
import com.swarco.sts.chart.control.label.defaults.TRenderableLabel;
import com.swarco.sts.chart.control.label.interfaces.TAxisLabelSize;
import com.swarco.sts.chart.control.label.interfaces.TRenderableComponent;
import com.swarco.sts.chart.control.layout.DynamicBorderLayout;
import com.swarco.sts.chart.control.layout.TableLayout;
import com.swarco.sts.chart.control.legend.interfaces.TSeriesLegendAgent;
import com.swarco.sts.chart.control.series.defaults.TDefaultSeriesBreakRenderer;
import com.swarco.sts.chart.control.series.defaults.TDefaultSeriesMarkerRenderer;
import com.swarco.sts.chart.control.series.defaults.TSeriesBarsRenderSettings;
import com.swarco.sts.chart.control.series.defaults.TSeriesLinesRenderSettings;
import com.swarco.sts.chart.control.series.defaults.TSeriesQuantizedLinesRenderSettings;
import com.swarco.sts.chart.control.series.defaults.TSeriesStackedBarsRenderSettings;
import com.swarco.sts.chart.control.series.interfaces.TSeriesBreakRenderer;
import com.swarco.sts.chart.control.series.interfaces.TSeriesGroup;
import com.swarco.sts.chart.control.series.interfaces.TSeriesMarkerRenderer;
import com.swarco.sts.chart.control.series.interfaces.TSeriesRenderSettings;
import com.swarco.sts.chart.control.tooltip.interfaces.TToolTipFormat;
import com.swarco.sts.chart.control.utilities.CPairHolder;
import com.swarco.sts.chart.impl.layout.TFlowLayout;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.IStreckenProfilDataUpdateListener;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.IStreckenProfilDaten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.IStreckenProfilToolTipDecoration;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilDataUpdateEvent;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilDiagrammData;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilGrafischeEigenschaftenData;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilKonfigurationData;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilKonfigurationData.BezeichnungFahrtRichtung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.daten.StreckenProfilKonfigurationData.BildTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.type.StreckenProfilElementTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.type.StreckenProfilInhaltTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.Tupel;

public class StreckenProfilZuDiagrammZwischenschicht2 implements IStreckenProfilDataUpdateListener
{
  private final static String X_ACHSE_BESCHRIFTUNG = "Kilometrierung [km]";
  private static Integer[] LINIEN_DICKEN_WERTE = null;
  private final static Hashtable LINIEN_ART_STRICHE_WERTE = new Hashtable();
  private final static Hashtable LINIEN_ART_PUNKTE_WERTE = new Hashtable();
  private final static Hashtable LINIEN_ART_PUNKT_STRICH_WERTE = new Hashtable();
  private final static Hashtable KNOTEN_LINIEN_DICKE_WERTE = new Hashtable();
  private final static Hashtable KNOTEN_GROESSE_WERTE = new Hashtable();
  private TChart diagramm = null;
  private JPanel xAchseBeschriftungPanel = null;
  private TPdfCapableLabel xAchseBeschriftung = null;
  private Vector datenreihen = new Vector();
  private Hashtable datenreihenSammlung = new Hashtable();
  private Hashtable datenreihenSortierungSammlung = new Hashtable();
  private TFlowLayout legendenLayout = null;
  private JPanel legendenAnzeige = null;
  private Vector legendenListe = null;
  private JPanel streckenProfilAnzeige = null;
  private Hashtable gestapelteBalkenDatenreihenGruppeSammlung = null;
  private TSeriesGroup balkenDatenreihenGruppe = null;
  private TSeriesGroup linienDatenreihenGruppe = null;
  private TSeriesGroup quantisierteLinienDatenreihenGruppen = null;
  private Vector geschwindigkeitBeschraenkungDatenreiheVerwaltungListe = null;
  private Vector zustaendeAnzeigeLeistenListe = null;
  private Hashtable zustaendeAnzeigeLeisten = null;
  private String titel = null;
  private long letzterZeitstempel = Long.MIN_VALUE;
  private SimpleDateFormat datumZeitFormatierer = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss");
  private GregorianCalendar kalender = new GregorianCalendar();
  private TPdfCapableLabel titelAnzeige = null;
  private StreckenProfilKonfigurationData aktuelleKonfiguration = null;
  private StreckenProfilKmLegende kmLegende = null;
  private TSeries pseudoDatenreihe = null;
  private TActionListener sichtbarkeitDatenreiheZuhoerer = null; 
  private StreckenProfilGeschwindigkeitBeschraenkungLegende geschwindigkeitBeschraenkungLegende = null;
  private String streckenBezeichnung = null;
  private String editor = null;
  private StreckenProfilDiagrammData letzteStreckenProfilDiagrammDaten = null;
  private JPanel legendenMitAbstandAnzeige = null;
  
  static
  {
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE = new Integer[]{new Integer(1), new Integer(2), new Integer(3), new Integer(4)};
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_STRICHE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[0], new float[]{7.0f, 5.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_STRICHE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[1], new float[]{9.0f, 6.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_STRICHE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[2], new float[]{11.0f, 8.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_STRICHE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[3], new float[]{13.0f, 9.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKTE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[0], new float[]{2.0f, 2.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKTE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[1], new float[]{1.0f, 4.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKTE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[2], new float[]{1.0f, 6.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKTE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[3], new float[]{1.0f, 8.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKT_STRICH_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[0], new float[]{2.0f, 3.0f, 7.0f, 3.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKT_STRICH_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[1], new float[]{1.0f, 4.0f, 9.0f, 4.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKT_STRICH_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[2], new float[]{1.0f, 6.0f, 11.0f, 6.0f});
    StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKT_STRICH_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[3], new float[]{1.0f, 8.0f, 13.0f, 8.0f});
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_LINIEN_DICKE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[0], new Integer(1));
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_LINIEN_DICKE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[1], new Integer(1));
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_LINIEN_DICKE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[2], new Integer(2));
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_LINIEN_DICKE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[3], new Integer(2));
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[0], new Integer(8));
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[1], new Integer(9));
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[2], new Integer(10));
    StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.put(StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[3], new Integer(11));
  }
  
  /* public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Throwable t)
    {
    }
    
    final StreckenProfilZuDiagrammZwischenschicht zwischenschicht = new StreckenProfilZuDiagrammZwischenschicht("", BezeichnungFahrtRichtung.NO);
    JFrame dialogfenster = new JFrame("Test Streckenprofil");
    ((JPanel) dialogfenster.getContentPane()).setPreferredSize(new Dimension(1000, 500));
    dialogfenster.getContentPane().setLayout(new BorderLayout());
    dialogfenster.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    JButton export = new JButton("PDF exportieren");
    export.addActionListener(new ActionListener()
    {
      @Override
      public void actionPerformed(ActionEvent e)
      {
        zwischenschicht.diagramm.exportToPdf(TChart.PDF_A4_LANDSCAPE, new File("d:\\test.pdf"), null, null);
      }
    });
    dialogfenster.getContentPane().add(zwischenschicht.getStreckenProfilAnzeige(), BorderLayout.CENTER);
    dialogfenster.getContentPane().add(export, BorderLayout.SOUTH);
    dialogfenster.pack();
    dialogfenster.setVisible(true);

    StreckenProfilKonfiguration.oeffneKonfigurationsDialog();
  } */
  
  /**
   * Legt eine Zwischenschicht an, die die Streckenprofildaten mit einem Diagramm verbindet und eine
   * grafische Anzeige (JPanel) des ganzen liefert.
   * 
   * @param titel Der Basistitel (wird immer wieder bei neuen Daten mit dem aktuellen Zeitstempel ergnzt).
   */
  public StreckenProfilZuDiagrammZwischenschicht2(String ersterTitel, String editor, String streckenBezeichnung)
  {
//    this.fahrtrichtung = fahrtrichtung;
    this.streckenBezeichnung = streckenBezeichnung;
    this.editor = editor;
    
    long exceptionalCases = TChart.EXCEPTIONAL_CASE_DISTRIBUTED_BARS;
//    if(fahrtrichtung == StreckenProfilKonfigurationData.BezeichnungFahrtRichtung.SW)
//    {
//      exceptionalCases |= TChart.EXCEPTIONAL_CASE_MIRRORED_X_AXIS;
//    }
    diagramm = new TChart(exceptionalCases);

    Hashtable renderingHints = new Hashtable();
    renderingHints.put(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
    renderingHints.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    renderingHints.put(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
    renderingHints.put(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_DISABLE);
    renderingHints.put(RenderingHints.KEY_FRACTIONALMETRICS, RenderingHints.VALUE_FRACTIONALMETRICS_ON);
    renderingHints.put(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
    renderingHints.put(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
    renderingHints.put(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
    diagramm.setRenderingHints(renderingHints);

    sichtbarkeitDatenreiheZuhoerer = new TActionListener()
    {
      public void actionPerformed(TActionEvent actionEvent)
      {
        if(actionEvent.isAction(TSeries.SERIES_VISIBILITY))
        {
          boolean datenreiheSichtbar = false;
          for(int i = 0; i < datenreihen.size(); i++)
          {
            if(((DatenreiheVerwaltung)datenreihen.elementAt(i)).isVisible())
            {
              datenreiheSichtbar = true;
              break;
            }
          }
          if(!datenreiheSichtbar)
          {
            fuegePseudoDatenreiheHinzu(aktuelleKonfiguration.getStartKm(), aktuelleKonfiguration.getEndeKm());
            aktualisiereDiagramm();
          }
        }
      }
    };
    
    diagramm.getAxis(TAxis.AC_X).setLabelFormat(new TKmFormatierung());
    diagramm.getAxis(TAxis.AC_X).setLabelRotation(90);
    diagramm.getAxis(TAxis.AC_X).setHeader("");
    xAchseBeschriftungPanel = new JPanel();
    xAchseBeschriftungPanel.setLayout(new BorderLayout());
    xAchseBeschriftungPanel.setBackground(diagramm.getChartComponent().getBackground());
    xAchseBeschriftung = new TPdfCapableLabel();
    xAchseBeschriftung.setHorizontalAlignment(SwingConstants.CENTER);
    xAchseBeschriftung.setFont(diagramm.getBaseFont());
    xAchseBeschriftung.setBackground(diagramm.getChartComponent().getBackground());
    xAchseBeschriftungPanel.add(xAchseBeschriftung, BorderLayout.CENTER);
    
    gestapelteBalkenDatenreihenGruppeSammlung = new Hashtable();
    balkenDatenreihenGruppe = diagramm.addSeriesGroup(TSeries.SC_BARS);
    linienDatenreihenGruppe = diagramm.addSeriesGroup(TSeries.SC_LINES);
    quantisierteLinienDatenreihenGruppen = diagramm.addSeriesGroup(TSeries.SC_QUANTIZED_LINES);
    geschwindigkeitBeschraenkungDatenreiheVerwaltungListe = new Vector();

    streckenProfilAnzeige = new JPanel();
    streckenProfilAnzeige.setLayout(new BorderLayout(3, 3));
    this.titel = ersterTitel;
    titelAnzeige = new TPdfCapableLabel(titel == null ? "" : titel);
    titelAnzeige.setOpaque(true);
    titelAnzeige.setBackground(diagramm.getChartComponent().getBackground());
    titelAnzeige.setHorizontalAlignment(TPdfCapableLabel.CENTER);
    titelAnzeige.setFont(diagramm.getBaseFont().deriveFont(Font.BOLD, diagramm.getBaseFont().getSize2D() * 1.5f));
    
    zustaendeAnzeigeLeistenListe = new Vector();
    zustaendeAnzeigeLeisten = new Hashtable();
    JPanel abszisseAnzeigeOben = new JPanel();
    JPanel abszisseAnzeigeUnten = new JPanel();
    abszisseAnzeigeOben.setBackground(diagramm.getChartComponent().getBackground());
    abszisseAnzeigeUnten.setBackground(diagramm.getChartComponent().getBackground());

    int anzahlBildzeichenTypen = StreckenProfilKonfigurationData.BezeichnungBildzeichenTypen.numberOfEntities();
    if(anzahlBildzeichenTypen > 0)
    {
      Vector zustaendeAnzeigeListeAlle = new Vector();
      Vector zustaendeAnzeigeListeOben = new Vector();
      Vector zustaendeAnzeigeListeUnten = new Vector();
      StreckenProfilBilderTexteHinweistexteFormatierer _formatierer = new StreckenProfilBilderTexteHinweistexteFormatierer();
      for(int i = 0; i < anzahlBildzeichenTypen; i++)
      {
        StreckenProfilKonfigurationData.BildzeichenTypKonfiguration bildzeichenTypKonfiguration = StreckenProfilKonfigurationData.BezeichnungBildzeichenTypen.get(i).getBildzeichenTypKonfiguration();
        Dimension maximaleGroesse = null;
        if(bildzeichenTypKonfiguration.getBildTyp() == BildTyp.BILD)
        {
          List inhalteZeichen = StreckenProfilInhaltTyp.getInhalteAusElementTyp(bildzeichenTypKonfiguration.getElementTyp());
          List fahrtRichtungen = null;
          if(bildzeichenTypKonfiguration.getElementTyp().equals(StreckenProfilElementTyp.WZG_A) 
              || bildzeichenTypKonfiguration.getElementTyp().equals(StreckenProfilElementTyp.WZG_B) 
              || bildzeichenTypKonfiguration.getElementTyp().equals(StreckenProfilElementTyp.WZG_C))
          {
            fahrtRichtungen = new ArrayList();
            fahrtRichtungen.add(StreckenProfilKonfigurationData.BezeichnungFahrtRichtung.SW);
            fahrtRichtungen.add(StreckenProfilKonfigurationData.BezeichnungFahrtRichtung.NO);
          }
          if(inhalteZeichen.size() > 0)
          {
            maximaleGroesse = StreckenProfilBildverwaltung.getMaximaleBildgroesse(bildzeichenTypKonfiguration.getElementTyp(), inhalteZeichen, fahrtRichtungen);
          }
        }
        else if(bildzeichenTypKonfiguration.getBildTyp() == BildTyp.TEXT)
        {
          if(bildzeichenTypKonfiguration.isInhalteUeberlappen() && bildzeichenTypKonfiguration.isDynamischeHoehe())
          {
            maximaleGroesse = new Dimension(0, 0);
          }
          else
          {
            // hier die anderen Faelle ausprogrammieren (wird momentan nicht benoetigt)
          }
        }
        
        if(maximaleGroesse != null)
        {
          AbscissaPanel zustaendeAnzeige = null;          
          if(bildzeichenTypKonfiguration.isInhalteUeberlappen())
          {
            // TODO ausdehnung
            zustaendeAnzeige = new AbscissaPanel(maximaleGroesse.height, 0, 3, AbscissaPanel.ALIGN_TOP, bildzeichenTypKonfiguration.isAusdehnungAuswerten());
          }
          else
          {
            // TODO ausdehnung 
            zustaendeAnzeige = new AbscissaPanel(8, maximaleGroesse, 0, 3, AbscissaPanel.ALIGN_TOP, bildzeichenTypKonfiguration.isAusdehnungAuswerten());
          }
          zustaendeAnzeige.setToolTipFormat(_formatierer);
          if(bildzeichenTypKonfiguration.isObenAnordnen())
          {
            zustaendeAnzeigeListeOben.add(zustaendeAnzeige);
          }
          else
          {
            zustaendeAnzeigeListeUnten.add(zustaendeAnzeige);
          }
          zustaendeAnzeigeListeAlle.add(zustaendeAnzeige);
          zustaendeAnzeigeLeistenListe.add(zustaendeAnzeige);
          zustaendeAnzeigeLeisten.put(bildzeichenTypKonfiguration.getElementTyp().getType(), new Tupel(bildzeichenTypKonfiguration.getElementTyp(), zustaendeAnzeige));
        }
      }
      
      if(zustaendeAnzeigeListeOben.size() > 0)
      {
        double[] rows = new double[zustaendeAnzeigeListeOben.size()];
        for(int i = 0; i < zustaendeAnzeigeListeOben.size(); i++)
        {
          rows[i] = TableLayout.PREFERRED;
        }
        double[][] rowLayoutDefinition = {{TableLayout.FILL}, rows};
        abszisseAnzeigeOben.setLayout(new TableLayout(rowLayoutDefinition));
        for(int i = 0; i < zustaendeAnzeigeListeOben.size(); i++)
        {
          AbscissaPanel zustaendeAnzeige = (AbscissaPanel)zustaendeAnzeigeListeOben.elementAt(i);
          diagramm.attachAbscissaPanel(zustaendeAnzeige);
          abszisseAnzeigeOben.add(zustaendeAnzeige, "0, " + i);
        }
      }

      if(zustaendeAnzeigeListeUnten.size() > 0)
      {
        double[] rows = new double[zustaendeAnzeigeListeUnten.size()];
        for(int i = 0; i < zustaendeAnzeigeListeUnten.size(); i++)
        {
          rows[i] = TableLayout.PREFERRED;
        }
        double[][] rowLayoutDefinition = {{TableLayout.FILL}, rows};
        abszisseAnzeigeUnten.setLayout(new TableLayout(rowLayoutDefinition));
        for(int i = 0; i < zustaendeAnzeigeListeUnten.size(); i++)
        {
          AbscissaPanel zustaendeAnzeige = (AbscissaPanel)zustaendeAnzeigeListeUnten.elementAt(i);
          diagramm.attachAbscissaPanel(zustaendeAnzeige);
          abszisseAnzeigeUnten.add(zustaendeAnzeige, "0, " + i);
        }
      }

      if(zustaendeAnzeigeListeAlle.size() > 0)
      {
        AbscissaPanel.finalizeLabels(diagramm, zustaendeAnzeigeListeAlle);
      }
    }
    int titelAbstand = 10;
    JPanel titelAbszisseAnzeige = new JPanel();
    titelAbszisseAnzeige.setLayout(new BorderLayout(0, titelAbstand));
    titelAbszisseAnzeige.setBackground(diagramm.getChartComponent().getBackground());
    titelAbszisseAnzeige.add(titelAnzeige, BorderLayout.NORTH);
    titelAbszisseAnzeige.add(abszisseAnzeigeOben, BorderLayout.CENTER);
    diagramm.getChartComponent().add(titelAbszisseAnzeige, TChartComponent.TOP_CENTER);
    
    JPanel xAchseAbszisseBeschriftungAnzeige = new JPanel();
    xAchseAbszisseBeschriftungAnzeige.setLayout(new DynamicBorderLayout(0, 10));
    xAchseAbszisseBeschriftungAnzeige.setBackground(diagramm.getChartComponent().getBackground());
    xAchseAbszisseBeschriftungAnzeige.add(abszisseAnzeigeUnten, BorderLayout.NORTH);
    xAchseAbszisseBeschriftungAnzeige.add(xAchseBeschriftungPanel, BorderLayout.CENTER);
    diagramm.getChartComponent().add(xAchseAbszisseBeschriftungAnzeige, TChartComponent.BOTTOM_CENTER);
        
    legendenMitAbstandAnzeige = new JPanel();
    legendenMitAbstandAnzeige.setLayout(new BorderLayout());
    JPanel abstandAnzeige = new JPanel();
    abstandAnzeige.setBackground(diagramm.getChartComponent().getBackground());
    titelAnzeige.setText("g_");
    abstandAnzeige.setPreferredSize(new Dimension(1, titelAnzeige.getPreferredSize().height + titelAbstand));
    titelAnzeige.setText("");
    legendenMitAbstandAnzeige.add(abstandAnzeige, BorderLayout.NORTH);
    legendenAnzeige = new JPanel();
    legendenAnzeige.setOpaque(false);
    legendenAnzeige.setBorder(BorderFactory.createEmptyBorder(0, 20, 0, 0));
    legendenLayout = new TFlowLayout(TFlowLayout.GROW_TO_HEIGHT, 25, 0);
    legendenLayout.addHeightSnatcher(abstandAnzeige);
    legendenAnzeige.setLayout(legendenLayout);
    legendenMitAbstandAnzeige.add(legendenAnzeige, BorderLayout.CENTER);
    legendenMitAbstandAnzeige.setBackground(diagramm.getChartComponent().getBackground());
    diagramm.getChartComponent().add(legendenMitAbstandAnzeige, TChartComponent.RIGHT);
    legendenListe = new Vector();
    kmLegende = new StreckenProfilKmLegende(diagramm.getBaseFont());
    
    streckenProfilAnzeige.setBackground(diagramm.getChartComponent().getBackground());
    streckenProfilAnzeige.add(diagramm.getChartComponent(), BorderLayout.CENTER);
  }
  
  public void destroy()
  {
    diagramm.destroy();
  }

  public TChart getChart()
  {
    return (diagramm);
  }

  public void setSideLegendVisible(boolean visible)
  {
    if(visible)
    {
      SwingUtilities.invokeLater(new Runnable()
      {
        public void run()
        {
          Component[] components = diagramm.getChartComponent().getComponents();
          boolean found = false;
          if(components != null)
          {
            for(int i = 0; i < components.length; i++)
            {
              if(components[i] == legendenMitAbstandAnzeige)
              {
                found = true;
                break;
              }
            }
          }
          if(!found)
          {
            diagramm.getChartComponent().add(legendenMitAbstandAnzeige, TChartComponent.RIGHT);
            diagramm.getChartComponent().validate();
          }
        }
      });
    }
    else
    {
      SwingUtilities.invokeLater(new Runnable()
      {
        public void run()
        {
          diagramm.getChartComponent().remove(legendenMitAbstandAnzeige);
          diagramm.getChartComponent().validate();
        }
      });
    }
  }
  
  private TSeriesGroup getDatenreiheGruppe(String einheitenzeichen)
  {
    TSeriesGroup ret = (TSeriesGroup)gestapelteBalkenDatenreihenGruppeSammlung.get(einheitenzeichen);
    
    if(ret == null)
    {
      ret = diagramm.addSeriesGroup(0, TSeries.SC_STACKED_BARS);
      gestapelteBalkenDatenreihenGruppeSammlung.put(einheitenzeichen,  ret);
    }
    
    return (ret);
  }
  
  /**
   * Gibt den grafischen Teil (also das Diagramm mit Titel und A-, B-, C-Zeichen, usw.) zurck.
   * 
   * @return Der grafische Teil der Zwischenschicht
   */
  public JPanel getStreckenProfilAnzeige()
  {
    return (streckenProfilAnzeige);
  }
  
  /* (non-Javadoc)
   * @see de.bsvrz.buv.plugin.streckenprofil.sts.daten.IStreckenProfilDataUpdateListener#streckenProfilDataUpdate(de.bsvrz.buv.plugin.streckenprofil.sts.daten.StreckenProfilDataUpdateEvent)
   */
  public void streckenProfilDataUpdate(StreckenProfilDataUpdateEvent e)
  {
    final IStreckenProfilDaten daten = e.getStreckenProfilDaten();
    if(daten instanceof StreckenProfilKonfigurationData)
    {
      final StreckenProfilKonfigurationData data = (StreckenProfilKonfigurationData)daten;
      if (data.getEditor().equals(editor.toString())){
        bearbeiteAufgabe(new Runnable()
        {
          public void run()
          {
            erzeugeDatenreihen(data);
            aktualisiereDiagramm();
          }
        });        
      }
    }
    else if(daten instanceof StreckenProfilGrafischeEigenschaftenData)
    {
      final StreckenProfilGrafischeEigenschaftenData data = (StreckenProfilGrafischeEigenschaftenData)daten;
      if (data.getEditor().equals(editor.toString())){
        bearbeiteAufgabe(new Runnable()
        {
          public void run()
          {
            if(setGrafischeEigenschaften(data));
            {
              aktualisiereDiagramm();
            }
          }
        });        
      }
    }
    else if(daten instanceof StreckenProfilDiagrammData)
    {
      final StreckenProfilDiagrammData temp = (StreckenProfilDiagrammData)daten;
      if (temp.getEditor().equals(editor.toString())){
        // long start = System.nanoTime();
        final StreckenProfilDiagrammData differenzdaten = StreckenProfilDiagrammData.erzeugeDifferenzdaten(letzteStreckenProfilDiagrammDaten, (StreckenProfilDiagrammData)daten);
        letzteStreckenProfilDiagrammDaten = (StreckenProfilDiagrammData)daten;
        // System.out.println("Datenaufbereitung: " + ((System.nanoTime() - start) / 1000000.0) + " millis...");
        
        bearbeiteAufgabe(new Runnable()
        {
          public void run()
          {
            try
            {
              setDaten(differenzdaten);
//              setDaten((StreckenProfilDiagrammData)daten);
              aktualisiereDiagramm();
            }
            catch(Throwable t)
            {
              t.printStackTrace();
            }
          }
        });        
      }      
    }
  }

  private void bearbeiteAufgabe(Runnable aufgabe)
  {
    if(SwingUtilities.isEventDispatchThread())
    {
      aufgabe.run();
    }
    else
    {
      SwingUtilities.invokeLater(aufgabe);
    }
  }
  
  private void aktualisiereDiagramm()
  {
    diagramm.updateData(false);
    diagramm.repaint(false);
  }
  
  private boolean erzeugeDatenreihen(StreckenProfilKonfigurationData konfiguration)
  {
    boolean ret = false;
    
    if(konfiguration != null && !konfiguration.equals(aktuelleKonfiguration) && konfiguration.getEditor().equals(this.editor))
    {
      String neuerTitel = konfiguration.getBezeichnung();
      if(neuerTitel == null)
      {
        neuerTitel = "";
      }
      if(!titel.equals(neuerTitel))
      {
        titelAnzeige.setText(neuerTitel);
        titelAnzeige.revalidate();
        titel = neuerTitel;
      }
      
      
//      letzterZeitstempel = 0l;

//      StreckenProfilKonfigurationData.BezeichnungFahrtRichtung fahrtRichtung = konfiguration.getFahrtrichtung();
      xAchseBeschriftung.setText(StreckenProfilZuDiagrammZwischenschicht2.X_ACHSE_BESCHRIFTUNG + "  (Fahrtrichtung " + streckenBezeichnung + ")");
      aktuelleKonfiguration = (StreckenProfilKonfigurationData)konfiguration.clone();
      Hashtable datenreihenKopie = kopiereDatenreihen(datenreihen);
      datenreihen.clear();
      datenreihenSammlung.clear();
      datenreihenSortierungSammlung.clear();
      int sortierungsnummer = 0;

      boolean[] geschwindigkeitBeschraenkung = konfiguration.getGeschwindigkeitBeschraenkung();
      geschwindigkeitBeschraenkungDatenreiheVerwaltungListe.clear();
      for(int b = 0; b < geschwindigkeitBeschraenkung.length; b++)
      {
        String beschraenkung = StreckenProfilKonfigurationData.BezeichnungGeschwindigkeitBeschraenkung.get(b).toString();
        String datenreiheName = beschraenkung;
        DatenreiheVerwaltung datenreiheVerwaltung = (DatenreiheVerwaltung)datenreihenKopie.remove(datenreiheName);
        if(datenreiheVerwaltung == null)
        {
          datenreiheVerwaltung = new DatenreiheVerwaltung(datenreiheName, StreckenProfilKonfigurationData.BezeichnungGeschwindigkeitBeschraenkung.get(b));
        }
        geschwindigkeitBeschraenkungDatenreiheVerwaltungListe.add(datenreiheVerwaltung);
        datenreiheVerwaltung.setAnzeigeImDiagramm(geschwindigkeitBeschraenkung[b]);        
        datenreihen.add(datenreiheVerwaltung);
        datenreihenSammlung.put(datenreiheName, datenreiheVerwaltung);
        datenreihenSortierungSammlung.put(datenreiheName, new Integer(sortierungsnummer));
        datenreiheVerwaltung.setSortierungsnummer(sortierungsnummer);
        sortierungsnummer++;
      }
      
      boolean[] verkehrsDatenQuellen = konfiguration.getVerkehrsdatenQuellen();
      boolean[] verkehrsDatenTypen = konfiguration.getVerkehrsdatenTypen();
      for(int t = 0; t < verkehrsDatenTypen.length; t++)
      {
        String datenTyp = StreckenProfilKonfigurationData.BezeichnungVerkehrsDatenTypen.get(t).toString();
        for(int q = 0; q < verkehrsDatenQuellen.length; q++)
        {
          String datenQuelle = StreckenProfilKonfigurationData.BezeichnungVerkehrsDatenQuellen.get(q).toString();
          String datenreiheName = datenQuelle + "-" + datenTyp;
          DatenreiheVerwaltung datenreiheVerwaltung = (DatenreiheVerwaltung)datenreihenKopie.remove(datenreiheName);
          if(datenreiheVerwaltung == null)
          {
            datenreiheVerwaltung = new DatenreiheVerwaltung(datenreiheName, StreckenProfilKonfigurationData.BezeichnungVerkehrsDatenTypen.get(t));
          }
          datenreiheVerwaltung.setAnzeigeImDiagramm(verkehrsDatenQuellen[q] && verkehrsDatenTypen[t]);
          datenreihen.add(datenreiheVerwaltung);
          datenreihenSammlung.put(datenreiheName, datenreiheVerwaltung);
          datenreihenSortierungSammlung.put(datenreiheName, new Integer(sortierungsnummer));
          datenreiheVerwaltung.setSortierungsnummer(sortierungsnummer);
          sortierungsnummer++;
        }
      }
      
      boolean[] umfeldDatenMesswerte = konfiguration.getUmfeldDatenMesswerte();
      for(int u = 0; u < umfeldDatenMesswerte.length; u++)
      {
        String datenMesswert = StreckenProfilKonfigurationData.BezeichnungUmfeldDatenMessWerte.get(u).toString();
        String datenreiheName = datenMesswert;
        DatenreiheVerwaltung datenreiheVerwaltung = (DatenreiheVerwaltung)datenreihenKopie.remove(datenreiheName);
        if(datenreiheVerwaltung == null)
        {
          datenreiheVerwaltung = new DatenreiheVerwaltung(datenreiheName, StreckenProfilKonfigurationData.BezeichnungUmfeldDatenMessWerte.get(u));
        }
        datenreiheVerwaltung.setAnzeigeImDiagramm(umfeldDatenMesswerte[u]);
        datenreihen.add(datenreiheVerwaltung);
        datenreihenSammlung.put(datenreiheName, datenreiheVerwaltung);
        datenreihenSortierungSammlung.put(datenreiheName, new Integer(sortierungsnummer));
        datenreiheVerwaltung.setSortierungsnummer(sortierungsnummer);
        sortierungsnummer++;
      }
      
      if(datenreihenKopie.size() > 0)
      {
        Enumeration unbenutzteDatenreihen = datenreihenKopie.elements();
        while(unbenutzteDatenreihen.hasMoreElements())
        {
          ((DatenreiheVerwaltung)unbenutzteDatenreihen.nextElement()).doBereinigen();
        }
        datenreihenKopie.clear();
      }
      datenreihenKopie = null;
      
      legendenAnzeige.removeAll();
      boolean keineDatenreiheSichtbar = true;
      for(int i = 0; i < datenreihen.size(); i++)
      {
        ((DatenreiheVerwaltung)datenreihen.elementAt(i)).datenreiheAktualisieren(this, diagramm);
        if(((DatenreiheVerwaltung)datenreihen.elementAt(i)).isVisible())
        {
          keineDatenreiheSichtbar = false;
        }
      }
      if(keineDatenreiheSichtbar)
      {
        fuegePseudoDatenreiheHinzu(aktuelleKonfiguration.getStartKm(), aktuelleKonfiguration.getEndeKm());
      }
      
      IStreckenProfilLegende legende = null;
      int maximaleBezeichnerBreite =  0;
      int maximaleFormelzeichenBreite = 0;
      int maximaleWertBreite = 0;
      int maximaleEinheitenzeichenBreite = 0;
      for(int i = 0; i < legendenListe.size(); i++)
      {
        legende = (IStreckenProfilLegende)legendenListe.elementAt(i);
        Dimension bezeichnerGroesse = legende.getBevorzugteBezeichnerGroesse();
        maximaleBezeichnerBreite = Math.max(maximaleBezeichnerBreite, bezeichnerGroesse.width);
        Dimension formelzeichenGroesse = legende.getBevorzugteFormelzeichenGroesse();
        maximaleFormelzeichenBreite = Math.max(maximaleFormelzeichenBreite, formelzeichenGroesse.width);
        Dimension wertGroesse = legende.getBevorzugteWertGroesse();
        maximaleWertBreite = Math.max(maximaleWertBreite, wertGroesse.width);
        Dimension eiheitenzeichenGroesse = legende.getBevorzugteEinheitenzeichenGroesse();
        maximaleEinheitenzeichenBreite = Math.max(maximaleEinheitenzeichenBreite, eiheitenzeichenGroesse.width);
      }
      for(int i = 0; i < legendenListe.size(); i++)
      {
        legende = (IStreckenProfilLegende)legendenListe.elementAt(i);
        legende.getLegendeAnzeige().putClientProperty("StreckenProfilLegende", legende);
        legende.setBevorzugteBezeichnerGroesse(new Dimension(maximaleBezeichnerBreite, legende.getBevorzugteBezeichnerGroesse().height));
        legende.setBevorzugteFormelzeichenGroesse(new Dimension(maximaleFormelzeichenBreite, legende.getBevorzugteFormelzeichenGroesse().height));
        legende.setBevorzugteWertGroesse(new Dimension(maximaleWertBreite, legende.getBevorzugteWertGroesse().height));
        legende.setBevorzugteEinheitenzeichenGroesse(new Dimension(maximaleEinheitenzeichenBreite, legende.getBevorzugteEinheitenzeichenGroesse().height));
        legendenAnzeige.add(legende.getLegendeAnzeige());
      }
      
      diagramm.getAxis(TAxis.AC_X).showZeroPoint(false);
      diagramm.getAxis(TAxis.AC_X).setRange(konfiguration.getStartKm(), konfiguration.getEndeKm());
      
      boolean[] bildzeichenTypen = konfiguration.getBildzeichenTypen();
      for(int z = 0; z < bildzeichenTypen.length; z++)
      {
        Tupel tupel = (Tupel)zustaendeAnzeigeLeisten.get(StreckenProfilKonfigurationData.BezeichnungBildzeichenTypen.get(z).toString());
        if(tupel != null)
        {
          AbscissaPanel zustaendeAnzeige = (AbscissaPanel)tupel.getSecond();
          if(zustaendeAnzeige.isShow() != bildzeichenTypen[z])
          {
            zustaendeAnzeige.setShow(bildzeichenTypen[z]);
            zustaendeAnzeige.revalidate();
          }
        }
      }
      AbscissaPanel.finalizeLabels(diagramm, zustaendeAnzeigeLeistenListe);      
      boolean zustaendeAnzeigeSichtbar = false;
      for(int i = 0; i < zustaendeAnzeigeLeistenListe.size(); i++)
      {
        if(((AbscissaPanel)zustaendeAnzeigeLeistenListe.elementAt(i)).isShow())
        {
          zustaendeAnzeigeSichtbar = true;
        }
      }
      
      if(legendenAnzeige.getComponentCount() <= 0)
      {
        if(zustaendeAnzeigeSichtbar)
        {
          fuegePseudoDatenreiheHinzu(konfiguration.getStartKm(), konfiguration.getEndeKm());
        }
      }
      else
      {
        diagramm.getAxis(TAxis.AC_X).addActionListener(kmLegende);
        legendenAnzeige.add(kmLegende.getKmAnzeige());
      }
      legendenAnzeige.revalidate();
      legendenListe.clear();
      
      ret = true;
    }
    
    return (ret);
  }

  private void fuegePseudoDatenreiheHinzu(long startKm, long endeKm)
  {
    if(pseudoDatenreihe == null)
    {
      setZeigeAbszissenAusschliesslich(true);
      pseudoDatenreihe = diagramm.createSeries("_abszisse_", "W", "W");
      pseudoDatenreihe.setRetainMode(true);
      long abstand = endeKm - startKm;
      long schrittweite = 100;
      if(abstand < 10)
      {
        schrittweite = 1;
      }
      else if(abstand < 100)
      {
        schrittweite = 1;
      }
      else if(abstand < 1000)
      {
        schrittweite = 10;
      }
      if(startKm + schrittweite >= endeKm)
      {
        pseudoDatenreihe.addPoint((double)startKm, 1.0);
        pseudoDatenreihe.addPoint((double)endeKm, 1.0);
      }
      else
      {
        long naechsterStartKm = -1;
        if(startKm % schrittweite != 0)
        {
          naechsterStartKm = ((startKm / schrittweite) + 1) * schrittweite; 
        }
        else
        {
          naechsterStartKm = startKm + schrittweite;
        }

        long naechsterEndeKm = -1;
        if(endeKm % schrittweite != 0)
        {
          naechsterEndeKm = (endeKm / schrittweite) * schrittweite;
        }
        else
        {
          naechsterEndeKm = endeKm - schrittweite;
        }
        
        pseudoDatenreihe.addPoint((double)startKm, 1.0);
        if(naechsterStartKm < endeKm && naechsterEndeKm > startKm && naechsterEndeKm >= naechsterStartKm)
        {
          for(long i = naechsterStartKm; i <= naechsterEndeKm; i += schrittweite)
          {
            pseudoDatenreihe.addPoint((double)i, 1.0);
          }
        }
        pseudoDatenreihe.addPoint((double)endeKm, 1.0);
      }
      pseudoDatenreihe.setVisible(true);
    }
  }
  
  void entfernePseudoDatenreihe()
  {
    if(pseudoDatenreihe != null)
    {
      setZeigeAbszissenAusschliesslich(false);
      pseudoDatenreihe.destroy();
      pseudoDatenreihe = null;
    }
  }
  
  private boolean setGrafischeEigenschaften(StreckenProfilGrafischeEigenschaftenData grafischeEigenschaften)
  {
    boolean ret = false;
    
    if(grafischeEigenschaften != null && grafischeEigenschaften.getEditor().equals(this.editor))
    {
      String bezeichner = grafischeEigenschaften.getBezeichnung();
      if(bezeichner != null)
      {
        DatenreiheVerwaltung datenreiheVerwaltung = null;
        for(int i = 0; i < datenreihen.size(); i++)
        {
          datenreiheVerwaltung = (DatenreiheVerwaltung)datenreihen.elementAt(i);
          if(bezeichner.equals(datenreiheVerwaltung.getDatenreiheName()))
          {
            break;
          }
          else
          {
            datenreiheVerwaltung = null;
          }
        }
        if(datenreiheVerwaltung != null)
        {
          if(datenreiheVerwaltung.isGeschwindigkeitBeschraenkung())
          {
            for(int i = 0; i < geschwindigkeitBeschraenkungDatenreiheVerwaltungListe.size(); i++)
            {
              boolean grafischeEigenschaftenGesetzt = ((DatenreiheVerwaltung)geschwindigkeitBeschraenkungDatenreiheVerwaltungListe.elementAt(i)).setGrafischeEigenschaften(grafischeEigenschaften);
              if(!ret && grafischeEigenschaftenGesetzt)
              {
                ret = true;
              }
            }
          }
          else
          {
            ret = datenreiheVerwaltung.setGrafischeEigenschaften(grafischeEigenschaften);
          }
        }
      }
    }
    
    return (ret);
  }
  
  public void setDaten(StreckenProfilDiagrammData diagrammDaten)
  {
    if(diagrammDaten.getType() == IStreckenProfilDaten.DIAGRAMM_DATA && diagrammDaten.getEditor().equals(this.editor))
    {
      Long zeitstempel = diagrammDaten.getDatenZeit();
      
      boolean updateZeit = false;
      
      // Nur Online-Daten haben einen Zeitstempel. 
      // Statische Schilddaten sowie Bezeichungen der AQ, MQ und AS haben keinen
      if (zeitstempel != null){
        if (!diagrammDaten.isSimuAktiv()){
          if(zeitstempel > letzterZeitstempel)
          {
            updateZeit = true;
          }        
        }else{
          updateZeit = true; 
        }        
      }
      
      if (updateZeit){
        kalender.setTimeInMillis(zeitstempel);
        Date datumZeit = kalender.getTime();
        titelAnzeige.setText(titel + (titel.length() <= 0 ? "" : "  ") + "(" + datumZeitFormatierer.format(datumZeit) + ")");
        titelAnzeige.revalidate();
        letzterZeitstempel = zeitstempel;
      }
      
      Map<String, Map<String, SortedMap<Long, Object>>> mapObjektEbene = (Map<String, Map<String, SortedMap<Long, Object>>>)diagrammDaten.getDiagrammDaten();
      for(String objekt : mapObjektEbene.keySet())
      {
        Map<String, SortedMap<Long, Object>> mapDatenreiheEbene = (Map<String, SortedMap<Long, Object>>)mapObjektEbene.get(objekt);
        for(String bezeichner : mapDatenreiheEbene.keySet())
        {
          DatenreiheVerwaltung datenreiheVerwaltung = (DatenreiheVerwaltung)datenreihenSammlung.get(bezeichner);
          if(datenreiheVerwaltung != null)
          {
            SortedMap<Long, Object> mapDatenEbene = (SortedMap<Long, Object>)mapDatenreiheEbene.get(bezeichner);
            datenreiheVerwaltung.setDaten((TreeMap<Long, Object>)mapDatenEbene);
          }
          else
          {
            Tupel tupel = (Tupel)zustaendeAnzeigeLeisten.get(bezeichner);
            if(tupel != null)
            {
              StreckenProfilElementTyp elementTyp = (StreckenProfilElementTyp)tupel.getFirst();
              AbscissaPanel zustaendeAnzeige = (AbscissaPanel)tupel.getSecond();
              zustaendeAnzeige.clear();
              TreeMap<Long, Object> daten = (TreeMap<Long, Object>)mapDatenreiheEbene.get(bezeichner);
              for(Long xWert : daten.keySet())
              {
                Tupel yWert = (Tupel)daten.get(xWert);
                AbscissaLabel beschriftung = null;
                if(yWert.getSecond() instanceof StreckenProfilInhaltTyp)
                {
                  StreckenProfilInhaltTyp inhaltTyp = (StreckenProfilInhaltTyp)yWert.getSecond();
                  Object meta = null;
                  IStreckenProfilToolTipDecoration toolTipDecoration = (IStreckenProfilToolTipDecoration)yWert.getFirst();
                  if(toolTipDecoration != null)
                  {
                    String[] toolTipList = toolTipDecoration.getToolTipText();
                    
//                    for (String string : toolTipList)
//                    {
//                      System.out.println("---> StreckenProfilZuDiagrammZwischenschicht2.setDaten(TT): " + string);
//                    }
                    
                    if(toolTipList != null && toolTipList.length > 0)
                    {
                      meta = new CPairHolder(inhaltTyp, toolTipDecoration);
                    }
                  }
                  if(meta == null)
                  {
                    meta = new CPairHolder(inhaltTyp, null);
                  }
                  String pfad = StreckenProfilBildverwaltung.getBildPfad(elementTyp, inhaltTyp, BezeichnungFahrtRichtung.NO);
                  Image bild = null;
                  if(pfad != null)
                  {
                    bild = StreckenProfilBildverwaltung.getBild(pfad);
                    
                    
                    if(bild != null)
                    {
                      int ursprung = bild.getWidth(null) / 2; 
                      beschriftung = new AbscissaLabel(xWert.doubleValue(), AbscissaImage.createPictureImage(bild, ursprung, ursprung + "::" + pfad), meta);
                    }
                    else
                    {
                      System.out.println("Bild ist null 3: " + pfad);
                    }
                  }
                  else
                  {
                    System.out.println("Pfad ist null 3" + elementTyp.getType() + " ::: " + inhaltTyp.getType());
                  }
                }
                else if(yWert.getSecond() instanceof StreckenProfilKonfigurationData.TextKonfiguration)
                {
                  StreckenProfilKonfigurationData.TextKonfiguration textKonfiguration = (StreckenProfilKonfigurationData.TextKonfiguration)yWert.getSecond();
                  beschriftung = new AbscissaLabel(xWert.doubleValue(), AbscissaImage.createTextImage(textKonfiguration.getText(), textKonfiguration.getColor(), textKonfiguration.getFont(), textKonfiguration.getRotation(), textKonfiguration.toString()), new CPairHolder(textKonfiguration, null));
                }
                
                if(beschriftung == null)
                {
                  AbscissaImage error = AbscissaImage.createTextImage("e!", Color.RED, diagramm.getBaseFont(), 0.0, "e!");
                  beschriftung = new AbscissaLabel(xWert.doubleValue(), error, null);
                }
                zustaendeAnzeige.addLabel(beschriftung);
              }
              AbscissaPanel.finalizeLabels(diagramm, zustaendeAnzeigeLeistenListe);      
            }
          }
        }
      }
    }
  }
  
  class DatenreiheVerwaltung
  {
    private String datenreiheName = null;
    private StreckenProfilKonfigurationData.BezeichnungGeschwindigkeitBeschraenkung geschwindigkeitBeschraenkung = null;
    private StreckenProfilKonfigurationData.BezeichnungVerkehrsDatenTypen verkehrsdatenTyp = null;
    private StreckenProfilKonfigurationData.BezeichnungUmfeldDatenMessWerte umfelddatenMesswert = null;
    private boolean anzeigeImDiagramm = false;
    private boolean zuletztAngezeigtImDiagramm = false;
    private TSeries datenreihe = null;
    private int sortierungsnummer = -1;
    private TSeriesLegendAgent legendeAnzeige = null;
    private int datenreiheDarstellungsArt = TSeries.SC_LINES;
    private Color datenreiheBasisfarbe = Color.DARK_GRAY;
    private int datenreiheLinienDicke = 1;
    private StreckenProfilGrafischeEigenschaftenData.LinienArt datenreiheLinienArt = StreckenProfilGrafischeEigenschaftenData.LinienArt.LINIEN;
    private float[] datenreiheLinienArtWerte = null;
    private int knotenArt = TDefaultSeriesMarkerRenderer.M_NONE;
    private Color knotenFarbe = Color.DARK_GRAY;
    private TreeMap<Long, Object> aktuelleDaten = null;
    private boolean beschraenkteGrafischeEinstellungen = false;
    
    public DatenreiheVerwaltung(String datenreiheName, StreckenProfilKonfigurationData.BezeichnungVerkehrsDatenTypen verkehrsdatenTyp)
    {
      this.datenreiheName = datenreiheName;
      this.verkehrsdatenTyp = verkehrsdatenTyp;
    }
    
    public DatenreiheVerwaltung(String datenreiheName, StreckenProfilKonfigurationData.BezeichnungUmfeldDatenMessWerte umfelddatenMesswert)
    {
      this.datenreiheName = datenreiheName;
      this.umfelddatenMesswert = umfelddatenMesswert;
    }

    public DatenreiheVerwaltung(String datenreiheName, StreckenProfilKonfigurationData.BezeichnungGeschwindigkeitBeschraenkung geschwindigkeitBeschraenkung)
    {
      this.datenreiheName = datenreiheName;
      this.geschwindigkeitBeschraenkung = geschwindigkeitBeschraenkung;
      this.beschraenkteGrafischeEinstellungen = true;
    }

    public String getDatenreiheName()
    {
      return (datenreiheName);
    }
    
    public void setSortierungsnummer(int sortierungsnummer)
    {
      this.sortierungsnummer = sortierungsnummer;
    }
    
    public void setAnzeigeImDiagramm(boolean anzeigeImDiagramm)
    {
      this.anzeigeImDiagramm = anzeigeImDiagramm;
    }

    public boolean isGeschwindigkeitBeschraenkung()
    {
      return (geschwindigkeitBeschraenkung != null);
    }
    
    public boolean isVisible()
    {
      boolean ret = false;
      
      if(datenreihe != null)
      {
        ret = datenreihe.isVisible();
      }
      
      return (ret);
    }
    
    public void setDaten(TreeMap<Long, Object> datenOrg)
    {
      TreeMap<Long, Object> daten = new TreeMap<Long, Object>(datenOrg);
      if(anzeigeImDiagramm)
      {
        datenreihe.clear();
        
        for(Long xWert : daten.keySet())
        {
          Tupel yWert = (Tupel)daten.get(xWert);
          try
          {
        	  Object meta = null;
              IStreckenProfilToolTipDecoration toolTipDecoration = (IStreckenProfilToolTipDecoration)yWert.getFirst();
              if(toolTipDecoration != null)
              {
              	String[] toolTipList = toolTipDecoration.getToolTipText();
              	if(toolTipList != null && toolTipList.length > 0)
              	{
              		meta = toolTipDecoration;
              	}
              }
            datenreihe.addPoint(xWert.doubleValue(), Double.parseDouble((String)yWert.getSecond()), meta);
          }
          catch (Exception e)
          {
            // TODO: handle exception
          }
        }
      }
      aktuelleDaten = (TreeMap<Long, Object>)daten.clone();
    }
    
    public void datenreiheAktualisieren(StreckenProfilZuDiagrammZwischenschicht2 zwischenschicht, TChart diagramm)
    {
      if(anzeigeImDiagramm)
      {
        if(datenreihe == null)
        {
          if(geschwindigkeitBeschraenkung != null)
          {
            datenreihe = diagramm.createSeries(datenreiheName, geschwindigkeitBeschraenkung._formelzeichen, geschwindigkeitBeschraenkung._einheitenzeichen);
            datenreihe.setLabelFormat(new TDecimalFormat(3, 0));
            datenreihe.setToolTipFormat(new StreckenProfilHinweistexteFormatierer(3, 0));
            datenreihe.setBreakValue(geschwindigkeitBeschraenkung._datenlueckenWert.doubleValue());
            if(geschwindigkeitBeschraenkung._gemeinsameLegende.booleanValue())
            {
              if(geschwindigkeitBeschraenkungLegende == null)
              {
                geschwindigkeitBeschraenkungLegende = new StreckenProfilGeschwindigkeitBeschraenkungLegende(zwischenschicht, diagramm.getBaseFont(), 7, 0);
              }
              legendeAnzeige = geschwindigkeitBeschraenkungLegende;
            }
            else
            {
              legendeAnzeige = new StreckenProfilGeschwindigkeitBeschraenkungLegende(zwischenschicht, diagramm.getBaseFont(), 7, 0);
            }
            datenreiheDarstellungsArt = TSeries.SC_QUANTIZED_LINES;
          }
          else if(verkehrsdatenTyp != null)
          {
            datenreihe = diagramm.createSeries(datenreiheName, verkehrsdatenTyp._formelzeichen, verkehrsdatenTyp._einheitenzeichen);
            datenreihe.setLabelFormat(new TDecimalFormat(verkehrsdatenTyp._maximalWertGanzzahllaenge.intValue(), verkehrsdatenTyp._anzahlNachkommastellen.intValue()));
            datenreihe.setToolTipFormat(new StreckenProfilHinweistexteFormatierer(verkehrsdatenTyp._maximalWertGanzzahllaenge.intValue(), verkehrsdatenTyp._anzahlNachkommastellen.intValue()));
            datenreihe.setBreakValue(verkehrsdatenTyp._datenlueckenWert.doubleValue());
            legendeAnzeige = new StreckenProfilLegende(zwischenschicht, diagramm.getBaseFont(), verkehrsdatenTyp._maximalWertGanzzahllaenge.intValue(), verkehrsdatenTyp._anzahlNachkommastellen.intValue());
          }
          else
          {
            datenreihe = diagramm.createSeries(datenreiheName, umfelddatenMesswert._formelzeichen, umfelddatenMesswert._einheitenzeichen);
            datenreihe.setLabelFormat(new TDecimalFormat(umfelddatenMesswert._maximalWertGanzzahllaenge.intValue(), umfelddatenMesswert._anzahlNachkommastellen.intValue()));
            datenreihe.setToolTipFormat(new StreckenProfilHinweistexteFormatierer(umfelddatenMesswert._maximalWertGanzzahllaenge.intValue(), umfelddatenMesswert._anzahlNachkommastellen.intValue()));
            datenreihe.setBreakValue(umfelddatenMesswert._datenlueckenWert.doubleValue());
            legendeAnzeige = new StreckenProfilLegende(zwischenschicht, diagramm.getBaseFont(), umfelddatenMesswert._maximalWertGanzzahllaenge.intValue(), umfelddatenMesswert._anzahlNachkommastellen.intValue());
          }
          datenreihe.addActionListener(sichtbarkeitDatenreiheZuhoerer);
          datenreihe.setRetainMode(true);
          datenreihe.addLegend(legendeAnzeige);
          setGrafischeEigenschaften(null);
        }
        if(!legendenListe.contains(legendeAnzeige))
        {
          legendenListe.add(legendeAnzeige);
        }
        if(!zuletztAngezeigtImDiagramm)
        {
          zuletztAngezeigtImDiagramm = true;
          if(aktuelleDaten != null)
          {
            setDaten(aktuelleDaten);
          }
        }
      }
      else
      {
        zuletztAngezeigtImDiagramm = false;
        if(datenreihe != null)
        {
          legendeAnzeige = null;
          datenreihe.destroy();
          datenreihe = null;
        }
      }
    }
    
    public void doBereinigen()
    {
      if(legendeAnzeige != null)
      {
        legendenAnzeige.remove(legendeAnzeige.getLegendeAnzeige());
        legendeAnzeige = null;
      }
      if(datenreihe != null)
      {
        datenreihe.removeActionListener(sichtbarkeitDatenreiheZuhoerer);
        datenreihe.destroy();
        datenreihe = null;
      }
      datenreiheLinienArt = null;
      datenreiheLinienArtWerte = null;
    }
    
    public boolean setGrafischeEigenschaften(StreckenProfilGrafischeEigenschaftenData grafischeEigenschaften)
    {
      boolean ret = false;
      
      int datenreiheDarstellungsArt = TSeries.SC_UNDEFINED;
      Color datenreiheBasisfarbe = null;
      int datenreiheLinienDicke = 0;
      StreckenProfilGrafischeEigenschaftenData.LinienArt datenreiheLinienArt = null;
      float[] datenreiheLinienArtWerte = null;
      boolean knotenArtGeaendert = false;
      int knotenArt = TDefaultSeriesMarkerRenderer.M_NONE; 
      Color knotenFarbe = null;
      
      if(grafischeEigenschaften == null)
      {
        datenreiheDarstellungsArt = this.datenreiheDarstellungsArt;
        datenreiheBasisfarbe = this.datenreiheBasisfarbe;
        datenreiheLinienDicke = this.datenreiheLinienDicke;
        datenreiheLinienArt = this.datenreiheLinienArt;
        datenreiheLinienArtWerte = this.datenreiheLinienArtWerte;
        knotenArtGeaendert = true;
        knotenArt = this.knotenArt; 
        knotenFarbe = this.knotenFarbe;
      }
      else
      {
        datenreiheDarstellungsArt = TSeries.SC_UNDEFINED;
        if(grafischeEigenschaften.getTyp() != null && !beschraenkteGrafischeEinstellungen)
        {
          switch(grafischeEigenschaften.getTyp())
          {
            case LINIE:
            {
              datenreiheDarstellungsArt = TSeries.SC_LINES;
              break;
            }
            case BALKEN:
            {
              datenreiheDarstellungsArt = TSeries.SC_BARS;
              break;
            }
            case GESTAPELTE_BALEN:
            {
              datenreiheDarstellungsArt = TSeries.SC_STACKED_BARS;
              break;
            }
          }
        }

        datenreiheBasisfarbe = null;
        if(grafischeEigenschaften.getLinienFarbe() != null)
        {
          org.eclipse.swt.graphics.Color farbe = grafischeEigenschaften.getLinienFarbe();
          datenreiheBasisfarbe = new Color(farbe.getRed(), farbe.getGreen(), farbe.getBlue());
        }
        
        datenreiheLinienDicke = 0;
        if(grafischeEigenschaften.getLinienDicke() != null)
        {
          switch(grafischeEigenschaften.getLinienDicke())
          {
            case DUENN:
            {
              datenreiheLinienDicke = StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[0].intValue();
              break;
            }
            case NORMAL:
            {
              datenreiheLinienDicke = StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[1].intValue();
              break;
            }
            case DICK:
            {
              datenreiheLinienDicke = StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[2].intValue();
              break;
            }
            case DICKER:
            {
              datenreiheLinienDicke = StreckenProfilZuDiagrammZwischenschicht2.LINIEN_DICKEN_WERTE[3].intValue();
              break;
            }
          }
        }
        
        int resultierendeDatenreiheLinienDicke = this.datenreiheLinienDicke;
        if(datenreiheLinienDicke > 0)
        {
          resultierendeDatenreiheLinienDicke = datenreiheLinienDicke;
        }
        
        datenreiheLinienArt = null;
        datenreiheLinienArtWerte = null;
        if(grafischeEigenschaften.getLinienArt() != null)
        {
          switch(grafischeEigenschaften.getLinienArt())
          {
            case LINIEN:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = null;
              break;
            }
            case STRICHE:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = (float[])StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_STRICHE_WERTE.get(new Integer(resultierendeDatenreiheLinienDicke));
              break;
            }
            case PUNKTE:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = (float[])StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKTE_WERTE.get(new Integer(resultierendeDatenreiheLinienDicke));
              break;
            }
            case PUNKT_STRICH:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = (float[])StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKT_STRICH_WERTE.get(new Integer(resultierendeDatenreiheLinienDicke));
              break;
            }
          }
        }
        
        if(datenreiheLinienArt == null && datenreiheLinienDicke > 0)
        {
          switch(this.datenreiheLinienArt)
          {
            case LINIEN:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = null;
              break;
            }
            case STRICHE:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = (float[])StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_STRICHE_WERTE.get(new Integer(resultierendeDatenreiheLinienDicke));
              break;
            }
            case PUNKTE:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = (float[])StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKTE_WERTE.get(new Integer(resultierendeDatenreiheLinienDicke));
              break;
            }
            case PUNKT_STRICH:
            {
              datenreiheLinienArt = grafischeEigenschaften.getLinienArt();
              datenreiheLinienArtWerte = (float[])StreckenProfilZuDiagrammZwischenschicht2.LINIEN_ART_PUNKT_STRICH_WERTE.get(new Integer(resultierendeDatenreiheLinienDicke));
              break;
            }
          }
        }
        
        knotenArtGeaendert = false;
        knotenArt = TDefaultSeriesMarkerRenderer.M_NONE; 
        if(grafischeEigenschaften.getKnotenArt() != null && !beschraenkteGrafischeEinstellungen)
        {
          switch(grafischeEigenschaften.getKnotenArt())
          {
            case QUADRAT:
            {
              knotenArt = TDefaultSeriesMarkerRenderer.M_SQUARE;
              knotenArtGeaendert = true;
              break;
            }
            case KREIS:
            {
              knotenArt = TDefaultSeriesMarkerRenderer.M_CIRCLE;
              knotenArtGeaendert = true;
              break;
            }
            case KREUZ:
            {
              knotenArt = TDefaultSeriesMarkerRenderer.M_CROSS;
              knotenArtGeaendert = true;
              break;
            }
            case HAARKREUZ:
            {
              knotenArt = TDefaultSeriesMarkerRenderer.M_PLUS;
              knotenArtGeaendert = true;
              break;
            }
            case OHNE:
            {
              knotenArt = TDefaultSeriesMarkerRenderer.M_NONE;
              knotenArtGeaendert = true;
              break;
            }
          }
        }
        
        knotenFarbe = null;
        if(grafischeEigenschaften.getKnotenFuellFarbe() != null && !beschraenkteGrafischeEinstellungen)
        {
          org.eclipse.swt.graphics.Color farbe = grafischeEigenschaften.getKnotenFuellFarbe();
          knotenFarbe = new Color(farbe.getRed(), farbe.getGreen(), farbe.getBlue());
        }
      }
      
      boolean basisfarbeGesetzt = (datenreiheBasisfarbe != null && !datenreiheBasisfarbe.equals(this.datenreiheBasisfarbe)) || (grafischeEigenschaften == null);
      boolean linienDickeGesetzt = (datenreiheLinienDicke > 0 && datenreiheLinienDicke != this.datenreiheLinienDicke) || (grafischeEigenschaften == null);
      boolean linienArtGesetzt = (datenreiheLinienArt != null && (linienDickeGesetzt || !datenreiheLinienArt.equals(this.datenreiheLinienArt))) || (grafischeEigenschaften == null);
      boolean knotenArtGesetzt = (knotenArtGeaendert && knotenArt != this.knotenArt) || (grafischeEigenschaften == null);
      boolean knotenFarbeGesetzt = (knotenFarbe != null && !knotenFarbe.equals(this.knotenFarbe)) || (grafischeEigenschaften == null);
      
      if(datenreihe != null)
      {
        TSeriesRenderSettings zeichnenEinstellungen = datenreihe.getSeriesRenderSettings(this.datenreiheDarstellungsArt);
        TGraphicsSettings linieEinstellungen = zeichnenEinstellungen.getLineSettings();
        TGraphicsSettings aussenLinieEinstellungen = zeichnenEinstellungen.getOutlineSettings();
        TGraphicsSettings fuellEinstellungen = zeichnenEinstellungen.getFillSettings();
        TSeriesMarkerRenderer knotenZeichner = null;
        TSeriesBreakRenderer datenlueckeZeichner = null;
        if(!beschraenkteGrafischeEinstellungen)
        {
          if(linienDickeGesetzt)
          {
            int luekeGroesse = ((Integer)StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.get(datenreiheLinienDicke)).intValue();
            datenlueckeZeichner = new TDefaultSeriesBreakRenderer(TDefaultSeriesBreakRenderer.M_CROSS, luekeGroesse); 
          }
          else
          {
            int luekeGroesse = ((Integer)StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.get(this.datenreiheLinienDicke)).intValue();
            datenlueckeZeichner = new TDefaultSeriesBreakRenderer(TDefaultSeriesBreakRenderer.M_CROSS, luekeGroesse); 
          }
        }
        int minimaleBalkenbreite = 20;
        int maximaleBalkenbreite = 50;
        
        if(basisfarbeGesetzt)
        {
          linieEinstellungen.setColor(datenreiheBasisfarbe);
          datenreihe.setBaseColor(datenreiheBasisfarbe);
          this.datenreiheBasisfarbe = datenreiheBasisfarbe;
          ret = true;          
        }
        
        if(linienDickeGesetzt && !linienArtGesetzt)
        {
          BasicStroke zeichenstift = (BasicStroke)linieEinstellungen.getStroke();
          if(zeichenstift == null)
          {
            zeichenstift = new BasicStroke((float)datenreiheLinienDicke, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f, this.datenreiheLinienArtWerte, 0.0f);
          }
          else
          {
            zeichenstift = new BasicStroke((float)datenreiheLinienDicke, zeichenstift.getEndCap(), zeichenstift.getLineJoin(), zeichenstift.getMiterLimit(), this.datenreiheLinienArtWerte, zeichenstift.getDashPhase());
          }
          linieEinstellungen.setStroke(zeichenstift);
          this.datenreiheLinienDicke = datenreiheLinienDicke;
          ret = true;
        }
        else if(!linienDickeGesetzt && linienArtGesetzt)
        {
          BasicStroke zeichenstift = (BasicStroke)linieEinstellungen.getStroke();
          if(zeichenstift == null)
          {
            zeichenstift = new BasicStroke((float)this.datenreiheLinienDicke, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f, datenreiheLinienArtWerte, 0.0f);
          }
          else
          {
            zeichenstift = new BasicStroke((float)this.datenreiheLinienDicke, zeichenstift.getEndCap(), zeichenstift.getLineJoin(), zeichenstift.getMiterLimit(), datenreiheLinienArtWerte, zeichenstift.getDashPhase());
          }
          linieEinstellungen.setStroke(zeichenstift);
          this.datenreiheLinienArt = datenreiheLinienArt;
          this.datenreiheLinienArtWerte = datenreiheLinienArtWerte;
          ret = true;
        }
        else if(linienDickeGesetzt && linienArtGesetzt)
        {
          BasicStroke zeichenstift = (BasicStroke)linieEinstellungen.getStroke();
          if(zeichenstift == null)
          {
            zeichenstift = new BasicStroke((float)datenreiheLinienDicke, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f, datenreiheLinienArtWerte, 0.0f);
          }
          else
          {
            zeichenstift = new BasicStroke((float)datenreiheLinienDicke, zeichenstift.getEndCap(), zeichenstift.getLineJoin(), zeichenstift.getMiterLimit(), datenreiheLinienArtWerte, zeichenstift.getDashPhase());
          }
          linieEinstellungen.setStroke(zeichenstift);
          this.datenreiheLinienDicke = datenreiheLinienDicke;
          this.datenreiheLinienArt = datenreiheLinienArt;
          this.datenreiheLinienArtWerte = datenreiheLinienArtWerte;
          ret = true;
        }

        BasicStroke zeichenstift = (BasicStroke)linieEinstellungen.getStroke();
        if(zeichenstift != null)
        { 
          int linienDicke = (int)zeichenstift.getLineWidth();
          BasicStroke fuellStift = new BasicStroke(((Integer)StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_LINIEN_DICKE_WERTE.get(new Integer(linienDicke))).floatValue());
          fuellEinstellungen.setStroke(fuellStift);
        }
        
        if(knotenArtGesetzt)
        {
          if(knotenArt == TDefaultSeriesMarkerRenderer.M_NONE)
          {
            knotenZeichner = null;
          }
          else
          {
            int knotenGroesse = ((Integer)StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.get(this.datenreiheLinienDicke)).intValue();
            knotenZeichner = new TDefaultSeriesMarkerRenderer(knotenArt, knotenGroesse);
          }
          this.knotenArt = knotenArt;
          ret = true;
        }
        else
        {
          if(this.knotenArt == TDefaultSeriesMarkerRenderer.M_NONE)
          {
            knotenZeichner = null;
          }
          else
          {
            int knotenGroesse = ((Integer)StreckenProfilZuDiagrammZwischenschicht2.KNOTEN_GROESSE_WERTE.get(this.datenreiheLinienDicke)).intValue();
            knotenZeichner = new TDefaultSeriesMarkerRenderer(this.knotenArt, knotenGroesse);
          }
        }
        
        if(knotenFarbeGesetzt)
        {
          fuellEinstellungen.setColor(knotenFarbe);
          this.knotenFarbe = knotenFarbe;
          ret = true;
        }
        
        if(datenreihe != null)
        {
          if((datenreiheDarstellungsArt != TSeries.SC_UNDEFINED && datenreiheDarstellungsArt != this.datenreiheDarstellungsArt) || (grafischeEigenschaften == null))
          {
            switch(this.datenreiheDarstellungsArt)
            {
              case TSeries.SC_STACKED_BARS:
              {
                getDatenreiheGruppe(datenreihe.getUnitSymbol()).removeSeries(datenreihe);
                break;
              }
              case TSeries.SC_BARS:
              {
                balkenDatenreihenGruppe.removeSeries(datenreihe);
                break;
              }
              case TSeries.SC_LINES:
              {
                linienDatenreihenGruppe.removeSeries(datenreihe);
                break;
              }
              case TSeries.SC_QUANTIZED_LINES:
              {
                quantisierteLinienDatenreihenGruppen.removeSeries(datenreihe);
                break;
              }
            }
            
            TSeriesGroup datenreiheGruppe = null;
            switch(datenreiheDarstellungsArt)
            {
              case TSeries.SC_STACKED_BARS:
              {
                fuellEinstellungen.setColor(linieEinstellungen.getColor());
                datenreiheGruppe = getDatenreiheGruppe(datenreihe.getUnitSymbol());
                break;
              }
              case TSeries.SC_BARS:
              {
                fuellEinstellungen.setColor(linieEinstellungen.getColor());
                datenreiheGruppe = balkenDatenreihenGruppe;
                break;
              }
              case TSeries.SC_LINES:
              {
                fuellEinstellungen.setColor(this.knotenFarbe);
                datenreiheGruppe = linienDatenreihenGruppe;
                break;
              }
              case TSeries.SC_QUANTIZED_LINES:
              {
                fuellEinstellungen.setColor(this.knotenFarbe);
                datenreiheGruppe = quantisierteLinienDatenreihenGruppen;
              }
            }
            ((IStreckenProfilLegende)legendeAnzeige).setDatenreiheTyp(datenreiheDarstellungsArt);
            int datenreihenAnzahl = datenreiheGruppe.getSeriesCount();
            int index = -1;
            for(int i = 0; i < datenreihenAnzahl; i++)
            {
              String datenreiheName = datenreiheGruppe.getSeries(i).getCaption();
              if(sortierungsnummer < ((Integer)datenreihenSortierungSammlung.get(datenreiheName)).intValue())
              {
                index = i;
                break;
              }
            }
            if(index == -1)
            {
              datenreiheGruppe.addSeries(datenreihe);
            }
            else
            {
              datenreiheGruppe.addSeries(index, datenreihe);
            }
            
            if(datenreihe.isVisible())
            {
              String einheitenzeichen = datenreihe.getUnitSymbol();
              boolean balkenDatenreihe = datenreihe.isTypeOf(TSeries.SC_BARS);
              boolean gestapelteBalkenDatenreihe = datenreihe.isTypeOf(TSeries.SC_STACKED_BARS); 
              if(balkenDatenreihe || gestapelteBalkenDatenreihe)
              {
                TSeriesGroup[] datenreiheGruppeListe = datenreihe.getChart().getAllSeriesGroups();
                if(datenreiheGruppeListe != null)
                {
                  for(int i = 0; i < datenreiheGruppeListe.length; i++)
                  {
                    TSeriesGroup datenreiheGruppeTemp = datenreiheGruppeListe[i];
                    if(datenreiheGruppeTemp != null)
                    {
                      if(datenreiheGruppeTemp.getType() == TSeries.SC_BARS)
                      {
                        TSeries andereDatenreihe = null;
                        int anzahlDatenreihen = datenreiheGruppeTemp.getSeriesCount();
                        for(int j = 0; j < anzahlDatenreihen; j++)
                        {
                          andereDatenreihe = datenreiheGruppeTemp.getSeries(j);
                          if(datenreihe != andereDatenreihe && andereDatenreihe.isVisible())
                          {
                            andereDatenreihe.setVisible(false);
                          }
                        }
                      }
                      
                      if(datenreiheGruppeTemp.getType() == TSeries.SC_STACKED_BARS)
                      {
                        String anderesEinheitenzeichen = null;
                        if(datenreiheGruppeTemp.getSeriesCount() > 0)
                        {
                          anderesEinheitenzeichen = datenreiheGruppeTemp.getSeries(0).getUnitSymbol();
                        }
                        if(balkenDatenreihe || !einheitenzeichen.equals(anderesEinheitenzeichen))
                        {
                          TSeries andereDatenreihe = null;
                          int anzahlDatenreihen = datenreiheGruppeTemp.getSeriesCount();
                          for(int j = 0; j < anzahlDatenreihen; j++)
                          {
                            andereDatenreihe = datenreiheGruppeTemp.getSeries(j);
                            if(datenreihe != andereDatenreihe && andereDatenreihe.isVisible())
                            {
                              andereDatenreihe.setVisible(false);
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
            
            this.datenreiheDarstellungsArt = datenreiheDarstellungsArt;
            ret = true;
          }
          else if(basisfarbeGesetzt)
          {
            switch(this.datenreiheDarstellungsArt)
            {
              case TSeries.SC_STACKED_BARS:
              {
                fuellEinstellungen.setColor(linieEinstellungen.getColor());
                break;
              }
              case TSeries.SC_BARS:
              {
                fuellEinstellungen.setColor(linieEinstellungen.getColor());
                break;
              }
              case TSeries.SC_LINES:
              {
                fuellEinstellungen.setColor(this.knotenFarbe);
                break;
              }
              case TSeries.SC_QUANTIZED_LINES:
              {
                fuellEinstellungen.setColor(this.knotenFarbe);
              }
            }
          }
          
          if(ret)
          {
            switch(this.datenreiheDarstellungsArt)
            {
              case TSeries.SC_LINES:
              {
                datenreihe.setSeriesRenderSettings(this.datenreiheDarstellungsArt, new TSeriesLinesRenderSettings(linieEinstellungen, aussenLinieEinstellungen, fuellEinstellungen, knotenZeichner, datenlueckeZeichner));
                break; 
              }
              case TSeries.SC_BARS:
              {
                datenreihe.setSeriesRenderSettings(this.datenreiheDarstellungsArt, new TSeriesBarsRenderSettings(linieEinstellungen, aussenLinieEinstellungen, fuellEinstellungen, minimaleBalkenbreite, maximaleBalkenbreite, datenlueckeZeichner));
                break; 
              }
              case TSeries.SC_STACKED_BARS:
              {
                datenreihe.setSeriesRenderSettings(this.datenreiheDarstellungsArt, new TSeriesStackedBarsRenderSettings(linieEinstellungen, aussenLinieEinstellungen, fuellEinstellungen, minimaleBalkenbreite, maximaleBalkenbreite, datenlueckeZeichner));
                break; 
              }
              case TSeries.SC_QUANTIZED_LINES:
              {
                datenreihe.setSeriesRenderSettings(this.datenreiheDarstellungsArt, new TSeriesQuantizedLinesRenderSettings(linieEinstellungen, aussenLinieEinstellungen, fuellEinstellungen, knotenZeichner, datenlueckeZeichner));
                break; 
              }
            }
          }
        }
      }
      else
      {
        if(basisfarbeGesetzt)
        {
          this.datenreiheBasisfarbe = datenreiheBasisfarbe;
        }
        
        if(linienDickeGesetzt)
        {
          this.datenreiheLinienDicke = datenreiheLinienDicke;
        }
        
        if(linienArtGesetzt)
        {
          this.datenreiheLinienArt = datenreiheLinienArt;
          this.datenreiheLinienArtWerte = datenreiheLinienArtWerte;
        }
        
        if(knotenArtGesetzt)
        {
          this.knotenArt = knotenArt;
        }

        if(knotenFarbeGesetzt)
        {
          this.knotenFarbe = knotenFarbe;
        }
      }
      
      return (ret);
    }
  }

  // Helpers
  private Hashtable kopiereDatenreihen(Vector datenreihen)
  {
    Hashtable ret = null;

    if(datenreihen != null)
    {
      ret = new Hashtable();
      for(int i = 0; i < datenreihen.size(); i++)
      {
        DatenreiheVerwaltung datenreiheVerwaltung = (DatenreiheVerwaltung)datenreihen.elementAt(i);
        ret.put(datenreiheVerwaltung.datenreiheName, datenreiheVerwaltung);
      }
    }
    
    return (ret);
  }

  class StreckenProfilHinweistexteFormatierer implements TToolTipFormat
  {
    private DecimalFormat format = null;   
    
    public StreckenProfilHinweistexteFormatierer(int integerPlaces, int decimalPlaces)
    {
      String integerPattern = "";
      if(integerPlaces > 0)
      {
        for(int i = 0; i < integerPlaces - 1; i++)
        {
          integerPattern += "#";
        }
        integerPattern += "0";
      }

      String decimalPattern = "";
      if(decimalPlaces > 0)
      {
        decimalPattern += ".0";
        for(int i = 0; i < decimalPlaces - 1; i++)
        {
          decimalPattern += "0";
        }
      }
      format = new DecimalFormat(integerPattern + decimalPattern);
    }
    
    public String format(TSeries datenreihe, double xWert, double yWert, Object meta)
    {
        String ret = null;
    	
    	String wertezeile = datenreihe.getCaption() + ": " + datenreihe.getQuantitySymbol() + " = " + format.format(yWert) + " " + datenreihe.getUnitSymbol();
        if(meta != null)
    	{
        	String[] toolTipInfos = ((IStreckenProfilToolTipDecoration)meta).getToolTipText();
            ret = "<html><table><tr>";
            for(int i = 0; i < toolTipInfos.length; i++)
            {
          	  ret += toolTipInfos[i];
          	  ret += "</tr><tr>";
            }
            ret += (wertezeile + "</tr></table></html>");
    	}
        else
        {
        	ret = "<html><table><tr>" + wertezeile + "</tr></table></html>";
        }
    
        return (ret);
    }

    public String formatLegend(TSeries series, double xValue, double yValue, Object meta)
    {
      return (format.format(yValue));
    }
  }
  
  class StreckenProfilBilderTexteHinweistexteFormatierer implements TToolTipFormat
  {
    public StreckenProfilBilderTexteHinweistexteFormatierer()
    {
    }
    
    public String format(TSeries datenreihe, double xWert, double yWert, Object meta)
    {
      String ret = null;
        	
      if(meta != null)
      {
        if(((CPairHolder)meta).getFirst() instanceof StreckenProfilInhaltTyp)
        {
          StreckenProfilInhaltTyp inhaltTyp = (StreckenProfilInhaltTyp)((CPairHolder)meta).getFirst();
          String[] toolTipInfos = null;
          if(((CPairHolder)meta).getSecond() != null)
          {
            IStreckenProfilToolTipDecoration toolTipDecoration = (IStreckenProfilToolTipDecoration)((CPairHolder)meta).getSecond();
            toolTipInfos = toolTipDecoration.getToolTipText();
          }
          if(toolTipInfos != null)
          {
            ret = "<html><table>";
            for(int i = 0; i < toolTipInfos.length; i++)
            {
              ret += "<tr>"; 
              ret += toolTipInfos[i];
              ret += "</tr>";
            }
            if (toolTipInfos.length == 1)
              ret += "<tr>" + inhaltTyp.getType() + "</tr></table></html>";
            else
              ret += "</table></html>";
            
          }
        }
        else if(((CPairHolder)meta).getFirst() instanceof StreckenProfilKonfigurationData.TextKonfiguration)
        {
          StreckenProfilKonfigurationData.TextKonfiguration textKonfiguration = (StreckenProfilKonfigurationData.TextKonfiguration)((CPairHolder)meta).getFirst();
          String[] toolTipInfos = textKonfiguration.getTooltip();
          if(toolTipInfos != null)
          {
            ret = "<html><table>";
            for(int i = 0; i < toolTipInfos.length; i++)
            {
              ret += "<tr>"; 
              ret += toolTipInfos[i];
              ret += "</tr>";
            }
            ret += "</table></html>";
          }
        }
      }
      
      return (ret);
    }

    public String formatLegend(TSeries series, double xValue, double yValue, Object meta)
    {
      return (null);
    }
  }

  public void setZeigeAbszissenAusschliesslich(boolean zeigeAbszissenAusschliesslich)
  {
    try
    {
      Class klasse = TChart.class;
      Field attribut = klasse.getDeclaredField("showAbscissasOnly");
      attribut.setAccessible(true);
      attribut.set(diagramm, new Boolean(zeigeAbszissenAusschliesslich));
    }
    catch(Throwable t)
    {
      t.printStackTrace();
    }
  }

  class TKmFormatierung implements TFormat
  {
    protected TRenderableLabel beschriftung = new TRenderableLabel();

    public TKmFormatierung()
    {
    }

    public TRenderableComponent format(TAxis axis, TFormat[] otherFormatList, double xValue, double yValue, int labelCount, int labelPosition)
    {
      long km = (long)xValue;
      long kmWert = km / 1000;
      long mWert = km % 1000;
      String mWertText = "" + mWert;
      while(mWertText.length() < 3)
      {
        mWertText = "0" + mWertText;
      }
      
      beschriftung.setFont(axis.getLabelFont());
      beschriftung.setText(kmWert + "." + mWertText);
      beschriftung.setRotation(axis.getLabelRotation());

      return (beschriftung);
    }

    public TAxisLabelSize formatMax(TAxis axis)
    {
      int breite = 0;
      int hoehe = 0;
      int breiteRotiert = 0;
      int hoeheRotiert = 0;

      beschriftung.setFont(axis.getLabelFont());
      beschriftung.setText("888.888");
      beschriftung.setRotation(0);
      Dimension bevorzugteGroesse = beschriftung.getPreferredSize();
      breite = bevorzugteGroesse.width;
      hoehe = bevorzugteGroesse.height;
      
      beschriftung.setRotation(axis.getLabelRotation());
      bevorzugteGroesse = beschriftung.getPreferredSize();
      breiteRotiert = bevorzugteGroesse.width;
      hoeheRotiert = bevorzugteGroesse.height;
      
      return (new TAxisLabelSize(breite, hoehe, axis.getLabelRotation(), breiteRotiert, hoeheRotiert, axis.isAxis(TAxis.AC_X)));
    }
  }

//  public StreckenProfilKonfigurationData.BezeichnungFahrtRichtung getFahrtrichtung()
//  {
//    return fahrtrichtung;
//  }
//
//  public void setFahrtrichtung(StreckenProfilKonfigurationData.BezeichnungFahrtRichtung fahrtrichtung)
//  {
//    this.fahrtrichtung = fahrtrichtung;
//  }
}
