/**
 * <copyright>
 * </copyright>
 *
 * $Id: ActivationState.java,v 1.2 2014/04/17 15:51:11 Pittner Exp $
 */
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>Activation State</b></em>', and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage#getActivationState()
 * @model
 * @generated
 */
public enum ActivationState implements Enumerator {
	/**
   * The '<em><b>Inactive</b></em>' literal object.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @see #INACTIVE_VALUE
   * @generated
   * @ordered
   */
	INACTIVE(0, "Inactive", "Inactive"),

	/**
   * The '<em><b>Semi Active</b></em>' literal object.
   * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
   * @see #SEMI_ACTIVE_VALUE
   * @generated
   * @ordered
   */
	SEMI_ACTIVE(1, "SemiActive", "SemiActive"),

	/**
   * The '<em><b>Active</b></em>' literal object.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @see #ACTIVE_VALUE
   * @generated
   * @ordered
   */
	ACTIVE(2, "Active", "Active");

	/**
	 * The '<em><b>Inactive</b></em>' literal value. <!-- begin-user-doc -->
	 * <!-- end-user-doc --> <!-- begin-model-doc --> Kein Kind ist aktiv <!--
	 * end-model-doc -->
	 * 
	 * @see #INACTIVE
	 * @model name="Inactive"
	 * @generated
	 * @ordered
	 */
	public static final int INACTIVE_VALUE = 0;

	/**
	 * The '<em><b>Semi Active</b></em>' literal value. <!-- begin-user-doc -->
	 * <!-- end-user-doc --> <!-- begin-model-doc --> Nicht alle Kinder sind
	 * aktiv <!-- end-model-doc -->
	 * 
	 * @see #SEMI_ACTIVE
	 * @model name="SemiActive"
	 * @generated
	 * @ordered
	 */
	public static final int SEMI_ACTIVE_VALUE = 1;

	/**
	 * The '<em><b>Active</b></em>' literal value. <!-- begin-user-doc --> <!--
	 * end-user-doc --> <!-- begin-model-doc --> Alle Kinder sind aktiv <!--
	 * end-model-doc -->
	 * 
	 * @see #ACTIVE
	 * @model name="Active"
	 * @generated
	 * @ordered
	 */
	public static final int ACTIVE_VALUE = 2;

	/**
	 * An array of all the '<em><b>Activation State</b></em>' enumerators. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private static final ActivationState[] VALUES_ARRAY = new ActivationState[]
    {
      INACTIVE,
      SEMI_ACTIVE,
      ACTIVE,
    };

	/**
   * A public read-only list of all the '<em><b>Activation State</b></em>' enumerators.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static final List<ActivationState> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
   * Returns the '<em><b>Activation State</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static ActivationState get(String literal) {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      ActivationState result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

	/**
   * Returns the '<em><b>Activation State</b></em>' literal with the specified name.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static ActivationState getByName(String name) {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      ActivationState result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

	/**
   * Returns the '<em><b>Activation State</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public static ActivationState get(int value) {
    switch (value)
    {
      case INACTIVE_VALUE: return INACTIVE;
      case SEMI_ACTIVE_VALUE: return SEMI_ACTIVE;
      case ACTIVE_VALUE: return ACTIVE;
    }
    return null;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	private final int value;

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	private final String name;

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	private final String literal;

	/**
   * Only this class can construct instances.
   * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
   * @generated
   */
	private ActivationState(int value, String name, String literal) {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public int getValue() {
    return value;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public String getName() {
    return name;
  }

	/**
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	public String getLiteral() {
    return literal;
  }

	/**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc --> <!-- end-user-doc -->
   * @generated
   */
	@Override
	public String toString() {
    return literal;
  }

} // ActivationState
