/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.streckenprofil.sts.a8.preferences;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;

/**
 * Preference-Page fr Parameter des Workflows. Versorgte Properties siehe
 * unten.
 * 
 * @author HofmannJ
 * 
 */
public class StreckenprofilPreferencePage extends FieldEditorPreferencePage implements
		IWorkbenchPreferencePage
{
	public static final String ID = "de.bsvrz.buv.plugin.streckenprofil.sts.a8.StreckenprofilPreferencePage";

	/**
	 * Initialisiert den zu verwendenden PreferenceStore.
	 */
	private void initStore()
	{
		IPreferenceStore store = de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator.getDefault().getPreferenceStore();
		setPreferenceStore(store);
	}

	@Override
	public void init(IWorkbench workbench)
	{
		initStore();
	}

	@Override
	protected void createFieldEditors()
	{   
    SystemObjectEditor bAuswahlAnzeigeTypA = new SystemObjectEditor(PreferenceInit.PROP_ANZEIGE_TYP_A,
        "Auswahl Anzeige Typ-A ", getFieldEditorParent());
    
    addField(bAuswahlAnzeigeTypA);
    
    SystemObjectEditor bAuswahlAnzeigeTypB = new SystemObjectEditor(PreferenceInit.PROP_ANZEIGE_TYP_B,
        "Auswahl Anzeige Typ-B ", getFieldEditorParent());
    
    addField(bAuswahlAnzeigeTypB);
    
    SystemObjectEditor bAuswahlAnzeigeTypC = new SystemObjectEditor(PreferenceInit.PROP_ANZEIGE_TYP_C,
        "Auswahl Anzeige Typ-C ", getFieldEditorParent());
    
    addField(bAuswahlAnzeigeTypC);
    
	}
	
	@Override
	protected Control createContents(Composite parent) {
		
    	//Fr die F1 Taste
//		PlatformUI.getWorkbench().getHelpSystem().setHelp( parent, Activator.PLUGIN_ID + ".streckenprofilPreference" );
		
		return super.createContents(parent);
	}
	
	@Override
	public void performHelp()
	{
		String helpContextId = Activator.PLUGIN_ID + ".streckenprofilPreference";
		PlatformUI.getWorkbench().getHelpSystem().displayHelp(helpContextId);
//		PlatformUI.getWorkbench().getHelpSystem().displayHelp(helpContextId);
	}
	
}
