/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/* Segment 13 Bedienung und Visualisierung, Plug-In Streckenprofil 
 * Copyright (C) 2009-2010 BitCtrl Systems GmbH
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information: 
 * BitCtrl Systems GmbH 
 * Weienfelser Strae 67 
 * 04229 Leipzig 
 * Phone: +49 341-490670 
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.streckenprofil.sts.a8.util;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Activateable;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivateableContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.ActivationState;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AeussererStreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AlternativeStreckenAbschnitte;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.InnererStreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.MessQuerschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Named;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.RealerStreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Strecke;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenEintraegeContainer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenKnoten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenTeilAbschnitt;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZug;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilFactory;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.SystemObjektContainer;
import de.bsvrz.buv.rw.bitctrl.startup.StartupPlugin;
import de.bsvrz.sys.funclib.bitctrl.modell.SystemObjekt;
import de.bsvrz.sys.funclib.bitctrl.modell.tmanzeigenglobal.objekte.AnzeigeQuerschnitt;
import de.bsvrz.sys.funclib.bitctrl.modell.tmgeoreferenzierungglobal.konfigurationsdaten.KdLinie.Daten;
import de.bsvrz.sys.funclib.bitctrl.modell.tmgeoreferenzierungglobal.objekte.Linie;
import de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.attribute.AttTmcRichtung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.AeusseresStrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.InneresStrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.MessQuerschnittAllgemein;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Strasse;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenKnoten;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenTeilSegment;

/**
 * 
 * Helper - Klasse zum fllen des EMF Modells.
 * 
 * @author BitCtrl Systems GmbH, Schnepel / Hoesel
 * @version $Id: LoadModel.java,v 1.4 2014/04/17 15:51:09 Pittner Exp $
 */
public final class LoadModel {

	/**
	 * Konstruktor verstecken.
	 */
	private LoadModel() {

	}

	/**
	 * Methode zum Erstellen einer neuen {@link StreckenprofilFactory}.
	 * 
	 * @return die neue {@link StreckenprofilFactory}.
	 */
	private static StreckenprofilFactory factory() {
		return StreckenprofilFactory.eINSTANCE;
	}

	/**
	 * Fgt ein {@link StrassenSegment} einem {@link StreckenZug} hinzu.
	 * 
	 * @param sp
	 *            der {@link StreckenZug}.
	 * @param segment
	 *            das neue {@link StrassenSegment}.
	 * @return ein neuer {@link StreckenAbschnitt}.
	 */
	public static StreckenAbschnitt addSegment(final StreckenZug sp,
			final StrassenSegment segment) {
		if (segment instanceof AeusseresStrassenSegment) {
			return addSegmentInternal(sp, (AeusseresStrassenSegment) segment);
		}
		if (segment instanceof InneresStrassenSegment) {
			return addSegmentInternal(sp, (InneresStrassenSegment) segment);
		}
		final String msg = qualifiedName(sp)
				+ ": Fehler beim Hinzufgen des Segmentes " + segment + "!";
		throw new IllegalStateException(msg);
	}

	/**
	 * Ermittelt den kompletten Namen des {@link Named} Objektes.
	 * 
	 * @param named
	 *            Objekt, dessen Name ermittelt werden soll.
	 * @return der Name
	 */
	private static String qualifiedName(final Named named) {
		String parent = "";
		if (named instanceof Activateable) {
			final ActivateableContainer<?> activateableContainer = ((Activateable) named)
					.getActivateableContainer();
			if (null != activateableContainer) {
				parent = qualifiedName(activateableContainer) + ".";
			}
		}
		return parent + named.getName();
	}

	/**
	 * Fgt ein {@link AeusseresStrassenSegment} dem Streckenprofil hinzu.
	 * 
	 * @param sp
	 *            der {@link StreckenZug}, zu dem das
	 *            {@link AeusseresStrassenSegment} gehrt.
	 * @param segment
	 *            das {@link AeusseresStrassenSegment}.
	 * @return der {@link StreckenAbschnitt}
	 */
	private static StreckenAbschnitt addSegmentInternal(final StreckenZug sp,
			final AeusseresStrassenSegment segment) {
		final boolean firstStreckenAbschnitt = sp.getStrecken().isEmpty();
		final Strecke oldStrecke;
		final StreckenEintrag letzterStreckenEintrag;
		if (firstStreckenAbschnitt) {
			oldStrecke = null;
			letzterStreckenEintrag = null;
		} else {
			oldStrecke = sp.getStrecken().get(sp.getStrecken().size() - 1);
			letzterStreckenEintrag = oldStrecke.getStreckenZugEintraege().get(
					oldStrecke.getStreckenEintraege().size() - 1);
		}

		final boolean useOldStrecke = !firstStreckenAbschnitt
				&& letzterStreckenEintrag instanceof StreckenKnoten
				&& (null == ((StreckenKnoten) letzterStreckenEintrag)
						.getVonStrecke() || (oldStrecke.getStrasse() == SystemObjekte
						.gehoertZuStrasse(segment) && oldStrecke.getRichtung() == SystemObjekte
						.richtung(segment)));
		final Strecke strecke;
		if (useOldStrecke) {
			strecke = oldStrecke;
			if (null == ((StreckenKnoten) letzterStreckenEintrag)
					.getVonStrecke()) {
				strecke.setStrasse(SystemObjekte.gehoertZuStrasse(segment));
				strecke.setRichtung(SystemObjekte.richtung(segment));
			}
		} else {
			strecke = createStrecke(sp, segment);
		}
		StreckenKnoten knoten = null;
		if (firstStreckenAbschnitt) {
			knoten = createKnoten(strecke, SystemObjekte.vonKnoten(segment));
		} else {
			if (!useOldStrecke) {

				final List<StreckenKnoten> oldKnotenListe = new ArrayList<StreckenKnoten>();
				for (final StreckenEintrag e : oldStrecke
						.getStreckenEintraege()) {
					if (e instanceof StreckenKnoten) {
						oldKnotenListe.add((StreckenKnoten) e);
					}
				}

				oldKnotenListe.get(oldKnotenListe.size() - 1)
						.setStreckenEintraegeContainer(strecke);
			}
			for (final StreckenEintrag eintrag : strecke.getStreckenEintraege()) {
				if (eintrag instanceof StreckenKnoten
						&& SystemObjekte.vonKnoten(segment) == ((StreckenKnoten) eintrag)
								.getStrassenKnoten()) {
					knoten = (StreckenKnoten) eintrag;
					break;
				}
			}
		}

		if (knoten == null) {
			return null;
		}
		StreckenAbschnitt abschnitt = null;
		if (!strecke.getStreckenEintraege().isEmpty()
				&& knoten != strecke.getStreckenEintraege().get(
						strecke.getStreckenEintraege().size() - 1)) {
			final AlternativeStreckenAbschnitte alt = factory()
					.createAlternativeStreckenAbschnitte();

			final StreckenKnoten zielKnoten = knoten.getNachStrecke()
					.getNachKnoten();
			strecke.getStreckenEintraege().remove(zielKnoten);
			strecke.getStreckenEintraege().remove(knoten.getNachStrecke());
			strecke.getStreckenEintraege().add(alt);
			strecke.getStreckenEintraege().add(zielKnoten);

			alt.setNachKnoten(zielKnoten);
			knoten.getNachStrecke().setActivateableContainer(alt);
			knoten.setNachStrecke(alt);
			addAeussererStreckenAbschnitt(alt, segment);
			abschnitt = alt;
		} else {
			abschnitt = addAeussererStreckenAbschnitt(strecke, segment);
			abschnitt.setNachKnoten(createKnoten(strecke,
					SystemObjekte.nachKnoten(segment)));
		}
		validateInnereStrecken(abschnitt.getVonKnoten());
		validateInnereStrecken(abschnitt.getNachKnoten());

		findHauptfahrbeziehungAndSetAktiv(knoten, strecke);
		abschnitt.setState(ActivationState.ACTIVE);
		return abschnitt;
	}

	/**
	 * berprft die {@link InnererStreckenAbschnitt}e eines
	 * {@link StreckenKnoten}s.
	 * 
	 * @param knoten
	 *            der {@link StreckenKnoten}.
	 */
	public static void validateInnereStrecken(final StreckenKnoten knoten) {
		final List<InnererStreckenAbschnitt> toBeRemoved = new ArrayList<InnererStreckenAbschnitt>();

		for (final InnererStreckenAbschnitt a : knoten
				.getInnereStreckenAbschnitte()) {
			if (!isValidIncludeInKnoten(knoten, a)) {
				toBeRemoved.add(a);
			}
		}
		knoten.getInnereStreckenAbschnitte().removeAll(toBeRemoved);
	}

	/**
	 * Prft, ob ein {@link InnererStreckenAbschnitt} zu einem
	 * {@link StreckenKnoten} gehrt.
	 * 
	 * @param knoten
	 *            der {@link StreckenKnoten}.
	 * @param abschnitt
	 *            der {@link InnererStreckenAbschnitt}.
	 * @return <code>true</code>, wenn der {@link InnererStreckenAbschnitt} zu
	 *         dem {@link StreckenKnoten} gehrt, sonst <code>false</code>.
	 */
	public static boolean isValidIncludeInKnoten(final StreckenKnoten knoten,
			final InnererStreckenAbschnitt abschnitt) {
		final boolean val1 = isValidIncludeCompare(knoten.getVonStrecke(),
				SystemObjekte.vonStrassenSegment(abschnitt.getModellObjekt()));
		final boolean val2 = isValidIncludeCompare(knoten.getNachStrecke(),
				SystemObjekte.nachStrassenSegment(abschnitt.getModellObjekt()));
		return val1 && val2;
	}

	/**
	 * berprft, ob ein {@link AeusseresStrassenSegment} zu einem
	 * {@link StreckenAbschnitt} gehrt.
	 * 
	 * @param abschnitt
	 *            der {@link StreckenAbschnitt}.
	 * @param segment
	 *            das {@link AeusseresStrassenSegment}.
	 * @return <code>true</code>, wenn das {@link AeusseresStrassenSegment} zu
	 *         dem {@link StreckenKnoten} gehrt, sonst <code>false</code>.
	 */
	public static boolean isValidIncludeCompare(
			final StreckenAbschnitt abschnitt,
			final AeusseresStrassenSegment segment) {
		if (abschnitt == null) {
			return true;
		} else if (abschnitt instanceof AlternativeStreckenAbschnitte) {

			final List<SystemObjekt> sysObjListe = new ArrayList<SystemObjekt>();
			for (final StreckenEintrag e : ((AlternativeStreckenAbschnitte) abschnitt)
					.getStreckenEintraege()) {
				if (e instanceof SystemObjektContainer<?>) {
					sysObjListe.add(((SystemObjektContainer<?>) e)
							.getModellObjekt());
				}
			}

			return sysObjListe.contains(segment);
		} else {
			return segment == abschnitt.getAktiverStreckenAbschnitt()
					.getModellObjekt();
		}
	}

	/**
	 * Versucht die Hauptfahrbeziehung eines Streckenknotens zu ermitteln und
	 * diese auf "aktiv" zu setzen.
	 * 
	 * @param knoten
	 *            der {@link StreckenKnoten}, dessen Hauptfahrbeziehung
	 *            ermittelt werden soll.
	 * @param strecke
	 *            die {@link Strecke} die untersucht wird.
	 */
	public static void findHauptfahrbeziehungAndSetAktiv(
			final StreckenKnoten knoten, final Strecke strecke) {
		final List<InnererStreckenAbschnitt> streckenEintraege = knoten
				.getStreckenEintraege();
		if (!streckenEintraege.isEmpty()) {

			final TreeSet<InnererStreckenAbschnitt> sortierteStreckenAbschnitte = new TreeSet<InnererStreckenAbschnitt>(
					new StreckenZugEintragLaengeComparator());

			final Strasse strasse = strecke.getStrasse();

			for (final InnererStreckenAbschnitt i : streckenEintraege) {

				final Boolean isHauptfahrbeziehung = SystemObjekte
						.isHauptFahrbeziehung(i.getStrassenSegment());
				if (Boolean.TRUE == isHauptfahrbeziehung) {
					sortierteStreckenAbschnitte.add(i);
				} else if (Boolean.FALSE == isHauptfahrbeziehung) {
					continue;
				} else {
					// isHauptfahrbeziehung == null
					final AeusseresStrassenSegment vonSegment = SystemObjekte
							.nachStrassenSegment(i.getStrassenSegment());
					final AeusseresStrassenSegment nachSegment = SystemObjekte
							.vonStrassenSegment(i.getStrassenSegment());
					if (vonSegment != null && nachSegment != null) {
						final Strasse vonStrasse = SystemObjekte
								.gehoertZuStrasse(vonSegment);
						final Strasse nachStrasse = SystemObjekte
								.gehoertZuStrasse(nachSegment);
						if (strasse != null && strasse.equals(vonStrasse)
								&& strasse.equals(nachStrasse)) {
							sortierteStreckenAbschnitte.add(i);
						}
					}
				}

			}

			if (sortierteStreckenAbschnitte.isEmpty()) {
				// default
				sortierteStreckenAbschnitte.addAll(streckenEintraege);
			}

			knoten.setAktiverStreckenAbschnitt(sortierteStreckenAbschnitte
					.first());
		}
	}

	/**
	 * Fgt ein {@link InneresStrassenSegment} zu einem {@link StreckenZug} des
	 * Streckneprofils hinzu.
	 * 
	 * @param sp
	 *            der {@link StreckenZug}.
	 * @param segment
	 *            das {@link InneresStrassenSegment}.
	 * @return der neue, daraus resultierende {@link InnererStreckenAbschnitt}.
	 */
	private static InnererStreckenAbschnitt addSegmentInternal(
			final StreckenZug sp, final InneresStrassenSegment segment) {
		StreckenKnoten knoten;
		if (sp.getStrecken().isEmpty()) {
			knoten = createKnoten(
					createStrecke(sp,
							SystemObjekte.nachStrassenSegment(segment)),
					SystemObjekte.knoten(segment));
		} else {
			final Strecke letzteStrecken = sp.getStrecken().get(
					sp.getStrecken().size() - 1);
			final List<StreckenKnoten> knotenDerLetztenStrecke = new ArrayList<StreckenKnoten>();
			for (final StreckenEintrag eintrag : letzteStrecken
					.getStreckenEintraege()) {
				if (eintrag instanceof StreckenKnoten) {
					knotenDerLetztenStrecke.add((StreckenKnoten) eintrag);
				}
			}

			knoten = knotenDerLetztenStrecke
					.get(knotenDerLetztenStrecke.size() - 1);
			// knoten =
			// Collections.last(Collections.typeSelect(Collections.last(
			// sp.getStrecken()).getStreckenEintraege(),
			// StreckenKnoten.class));
		}
		return addInnererStreckenAbschnitt(knoten, segment);
	}

	/**
	 * Erzeugt eine neue {@link Strecke} aus einem {@link StreckenZug} und einem
	 * {@link AeusseresStrassenSegment}.
	 * 
	 * @param sp
	 *            der {@link StreckenZug}.
	 * @param segment
	 *            das {@link AeusseresStrassenSegment}.
	 * @return die daraus resultierende {@link Strecke}.
	 */
	public static Strecke createStrecke(final StreckenZug sp,
			final AeusseresStrassenSegment segment) {
		final Strecke strecke = factory().createStrecke();
		strecke.setStrasse(SystemObjekte.gehoertZuStrasse(segment));
		strecke.setRichtung(SystemObjekte.richtung(segment));
		sp.getStrecken().add(strecke);
		return strecke;
	}

	/**
	 * Erzeugt eine neue {@link Strecke} fr den bergebenen {@link StreckenZug}
	 * und fgt diese damit automatisch ins EMF Modell des Streckenprofils mit
	 * ein.
	 * 
	 * @param sp
	 *            der {@link StreckenZug}.
	 * @param strasse
	 *            die {@link Strasse} zu der der {@link StreckenZug} gehrt.
	 * @param richtung
	 *            die {@link AttTmcRichtung} des {@link StreckenZug}s.
	 * @return die daraus resultierende {@link Strecke}.
	 */
	public static Strecke createStrecke(final StreckenZug sp,
			final Strasse strasse, final AttTmcRichtung richtung) {
		final Strecke strecke = factory().createStrecke();
		strecke.setStrasse(strasse);
		strecke.setRichtung(richtung);
		sp.getStrecken().add(strecke);
		return strecke;
	}

	/**
	 * Erzeugt einen {@link StreckenKnoten} (aus unserem EMF Modell) aus einem
	 * {@link StrassenKnoten} (DAV Modell) fr eine bestimmte {@link Strecke}.
	 * 
	 * @param strecke
	 *            die {@link Strecke}.
	 * @param strassenKnoten
	 *            der {@link StrassenKnoten}.
	 * @return der neue {@link StreckenKnoten}.
	 */
	public static StreckenKnoten createKnoten(final Strecke strecke,
			final StrassenKnoten strassenKnoten) {
		final StreckenKnoten knoten = factory().createStreckenKnoten();
		knoten.setStrassenKnoten(strassenKnoten);
		knoten.setActivateableContainer(strecke);
		for (final InneresStrassenSegment iss : strassenKnoten
				.getInnereStrassenSegmente()) {
			addInnererStreckenAbschnitt(knoten, iss);
		}

		// Collections.iterate(strassenKnoten.getInnereStrassenSegmente(),
		// new VoidClosure<InneresStrassenSegment>() {
		// public void closure(final InneresStrassenSegment param) {
		// addInnererStreckenAbschnitt(knoten, param);
		// }
		// });
		return knoten;
	}

	/**
	 * Erzeugt einen {@link AeussererStreckenAbschnitt} aus einem
	 * {@link AeusseresStrassenSegment}.
	 * 
	 * @param segment
	 *            das {@link AeusseresStrassenSegment}.
	 * @return der neue {@link AeussererStreckenAbschnitt}.
	 */
	public static AeussererStreckenAbschnitt createAeussererStreckenAbschnitt(
			final AeusseresStrassenSegment segment) {
		final AeussererStreckenAbschnitt abschnitt = factory()
				.createAeussererStreckenAbschnitt();
		abschnitt.setStrassenSegment(segment);
		return abschnitt;
	}

	/**
	 * Fgt der {@link Strecke} einen neuen {@link AeussererStreckenAbschnitt}
	 * hinzu.
	 * 
	 * @param strecke
	 *            die {@link Strecke}.
	 * @param segment
	 *            der neue {@link AeussererStreckenAbschnitt}.
	 * @return der neu erzeugt {@link AeussererStreckenAbschnitt}.
	 */
	public static AeussererStreckenAbschnitt addAeussererStreckenAbschnitt(
			final StreckenEintraegeContainer<? extends StreckenEintrag> strecke,
			final AeusseresStrassenSegment segment) {
		final AeussererStreckenAbschnitt abschnitt = createAeussererStreckenAbschnitt(segment);

		final LinkedList<StreckenKnoten> knotenListe = new LinkedList<StreckenKnoten>();
		for (final StreckenEintrag e : strecke.getStreckenEintraege()) {
			if (e instanceof StreckenKnoten) {
				knotenListe.addLast((StreckenKnoten) e);
			}
		}
		if (!knotenListe.isEmpty()) {
			knotenListe.getLast();
			knotenListe.getLast().setNachStrecke(abschnitt);
			abschnitt.setVonKnoten(knotenListe.getLast());
		}
		abschnitt.setActivateableContainer(strecke);
		addMessQuerschnitte(abschnitt);
		addStreckenTeilAbschnitte(abschnitt);
		addAnzeigequerschnitt(abschnitt);
		return abschnitt;
	}

	/**
	 * Entfernt ein {@link Activateable} ( z.B. {@link StreckenKnoten})aus dem
	 * Modell.
	 * 
	 * @param object
	 *            das {@link Activateable}, das aus dem Streckenprofil entfernt
	 *            werden soll.
	 */
	public static void removeActivateable(final Activateable object) {
		if (object instanceof StreckenKnoten) {
			StreckenKnoten kn = (StreckenKnoten) object;
			StreckenAbschnitt sa = kn.getNachStrecke();
			if (sa == null) {
				// Letzter Knoten
				sa = kn.getVonStrecke();
				if (sa != null) {
					// nicht der erste Knoten
					kn.setActivateableContainer(null);
					sa.setActivateableContainer(null);
					kn = sa.getVonKnoten();
					kn.setNachStrecke(null);
				}
			} else {
				// nicht der letzte Knoten
				while (sa != null && sa.getNachKnoten() != null) {
					// immer noch nicht nicht der letzte Knoten
					final StreckenEintraegeContainer<?> sec = sa
							.getStreckenEintraegeContainer();
					sa.setActivateableContainer(null);
					sa.getNachKnoten().setActivateableContainer(null);
					sa.setVonKnoten(null);
					sa = sa.getNachKnoten().getNachStrecke();
					if (sec.getStreckenEintraege().isEmpty()) {
						sec.setActivateableContainer(null);
					}
				}
			}
			final StreckenEintraegeContainer<?> strecke = kn
					.getStreckenEintraegeContainer();
			if (strecke.getStreckenEintraege().size() == 1) {
				if (sa != null) {
					kn.setActivateableContainer(sa.getActivateableContainer());
				}
				strecke.setActivateableContainer(null);
			}
		} else {
			object.setActivateableContainer(null);
		}
	}

	/**
	 * Fht ein neues {@link InneresStrassenSegment} dem Streckenprofil hinzu.
	 * 
	 * @param knoten
	 *            der {@link StreckenKnoten}, zu dem das
	 *            {@link InneresStrassenSegment} gehrt.
	 * @param segment
	 *            das {@link InneresStrassenSegment}.
	 * @return der daraus resultierende {@link InnererStreckenAbschnitt}.
	 */
	public static InnererStreckenAbschnitt addInnererStreckenAbschnitt(
			final StreckenKnoten knoten, final InneresStrassenSegment segment) {

		for (final InnererStreckenAbschnitt abschnitt : knoten
				.getInnereStreckenAbschnitte()) {
			if (abschnitt.getModellObjekt() != null
					&& segment.getPid().equals(
							abschnitt.getModellObjekt().getPid())) {
				Activator
						.getDefault()
						.getLog()
						.log(new Status(
								IStatus.INFO,
								Activator.PLUGIN_ID,
								"Inneres Strassensegment "
										+ segment.getName()
										+ " ist schon im Netzknoten "
										+ knoten.getName()
										+ " enthalten und wird kein zweites Mal hinzugefgt."));
				return abschnitt;
			}
		}

		final InnererStreckenAbschnitt abschnitt = factory()
				.createInnererStreckenAbschnitt();
		abschnitt.setStrassenSegment(segment);
		abschnitt.setActivateableContainer(knoten);
		addStreckenTeilAbschnitte(abschnitt);
		addMessQuerschnitte(abschnitt);
    addAnzeigequerschnitt(abschnitt); // 2014.04.03 STS
		return abschnitt;
	}

	/**
	 * Ermittelt alle {@link StreckenTeilAbschnitt}e fr den
	 * {@link RealerStreckenAbschnitt} fr diese ihm hinzu.
	 * 
	 * @param abschnitt
	 *            der {@link RealerStreckenAbschnitt}, dessen
	 *            {@link StreckenTeilAbschnitt} ermittelt werden.
	 */
	private static void addStreckenTeilAbschnitte(
			final RealerStreckenAbschnitt<?> abschnitt) {
		for (final Linie l : abschnitt.getModellObjekt()
				.getKdBestehtAusLinienObjekten().getDatum().getLinienReferenz()) {
			if (l instanceof StrassenTeilSegment) {
				final StreckenTeilAbschnitt teilAbschnitt = factory()
						.createStreckenTeilAbschnitt();
				final StrassenTeilSegment sts = (StrassenTeilSegment) l;
				teilAbschnitt.setModellObjekt(sts);
				final Daten d = sts.getKdLinie().getDatum();
				if (d == null) {
					// offensichtlich wurden fr das Stassenteilsegment keine
					// Konfigurationsdaten der ATG atg.linie versorgt.
					teilAbschnitt.setLaenge(0d);
				} else {
					teilAbschnitt.setLaenge(d.getLaenge().getValue());
				}
				abschnitt.getStreckenTeilAbschnitt().add(teilAbschnitt);
			}
		}
	}

	/**
	 * Ermittelt alle
	 * {@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AnzeigeQuerschnitt}e des
	 * {@link RealerStreckenAbschnitt}s.
	 * 
	 * @param abschnitt
	 *            der {@link RealerStreckenAbschnitt}, dessen
	 *            {@link de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AnzeigeQuerschnitt}
	 *            e ermittelt werden.
	 */
	private static void addAnzeigequerschnitt(
			final RealerStreckenAbschnitt<? extends StrassenSegment> abschnitt) {

	  
	  
		final Set<AnzeigeQuerschnitt> aqs = StartupPlugin.getDefault()
				.getDefaultAqCache()
				.getAnzeigeQuerschnitt(abschnitt.getStrassenSegment());
		
//		System.out.println("LoadModel.addAnzeigequerschnitt(): " + abschnitt.getStrassenSegment() + " -> " +  aqs.size());
		
		for (final AnzeigeQuerschnitt a : aqs) {
			final de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.AnzeigeQuerschnitt aq = StreckenprofilFactory.eINSTANCE
					.createAnzeigeQuerschnitt();
			aq.setLaenge(0d);
			aq.setModellObjekt(a);
			aq.setState(ActivationState.ACTIVE);
			abschnitt.getAnzeigeQuerschnitt().add(aq);
		}
	}

	/**
	 * Ermittelt alle {@link MessQuerschnitt}e, des
	 * {@link RealerStreckenAbschnitt}s und fgt diese dem Abschnitt hinzu.
	 * 
	 * @param abschnitt
	 *            der {@link RealerStreckenAbschnitt}, dessen
	 *            {@link MessQuerschnitt}e gesucht werden.
	 */
	public static void addMessQuerschnitte(
			final RealerStreckenAbschnitt<? extends StrassenSegment> abschnitt) {
	  
	  
//	  Set<MessQuerschnittAllgemein> mqs = SystemObjekte.messQuerschnitte(abschnitt.getStrassenSegment());	  
//	  System.out.println("LoadModel.addMessquerschnitt(): " + abschnitt.getStrassenSegment() + " -> " +  mqs.size());
	  
		for (final MessQuerschnittAllgemein mq : SystemObjekte
				.messQuerschnitte(abschnitt.getStrassenSegment())) {
			addMessQuerschnitt(abschnitt, mq);
		}

	}

	/**
	 * Fgt einen {@link MessQuerschnitt} einem {@link RealerStreckenAbschnitt}
	 * hinzu.
	 * 
	 * @param abschnitt
	 *            der {@link RealerStreckenAbschnitt}, zu dem ein
	 *            {@link MessQuerschnittAllgemein} hinzugefgt werden soll-
	 * @param mqa
	 *            das {@link MessQuerschnittAllgemein} Objekt, das dem
	 *            Streckenabschnitt hinzugefgt werden soll.
	 */
	public static void addMessQuerschnitt(
			final RealerStreckenAbschnitt<? extends StrassenSegment> abschnitt,
			final MessQuerschnittAllgemein mqa) {
		final MessQuerschnitt mq = factory().createMessQuerschnitt();
		mq.setMessQuerschnitt(mqa);
		mq.setStreckenAbschnitt(abschnitt);
	}

}
