/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.sba.plugin.navigator.kontextmenu;

import java.util.Iterator;
import java.util.LinkedList;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.actions.parameter.IParameter;

class DefaultParameter implements IParameter
	{
		private String _id = null;
		private Object _value = null;
		
		public DefaultParameter(String id, Object value)
		{
			this._id = id;		
	    if (value instanceof LinkedList)
	    {
        String strPids = "";
        LinkedList<SystemObject> liste = (LinkedList<SystemObject>) value;
        for (Iterator iterator = liste.iterator(); iterator.hasNext();)
        {
          SystemObject systemObject = (SystemObject) iterator.next();
          if ( strPids.length() > 0 )
              strPids += ",";
          strPids += systemObject.getPid();          
        }
        this._value = strPids;
	    }
	    else
	    {
	      this._value = value;
	    }	    
		}
		
		@Override
		public String getId()
		{
			return _id;
		}

		@Override
		public String getParameterInfo()
		{
			return "Keine besonder Info zu Parameter " + _id + "!";
		}

		@Override
		public Object getValue()
		{
			return _value;
		}

		@Override
		public void setValue(Object value)
		{
			this._value = value;			
		}		
	}
