package de.bsvrz.sba.plugin.parameter.steuerungskern.konfig;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.EAnzeigeQuerschnittTyp;

/**
 * Klasse kapselt einen Anzeigequerschnitt mit dem dazugehrenden Anzeigetyp
 * @author ObertM
 *
 */
public class AnzeigeQuerschnittMitTyp
{
	/**
	 * Systemobjekt des Anzeigequerschnitts
	 */
	private SystemObject _anzeigeQuerschnitt;
	
	/**
	 * Anzeigetyp des Anzeigequerschnitts
	 */
	private EAnzeigeQuerschnittTyp _typ;

	/**
	 * Konstruktor der Klasse
	 * @param anzeigeQuerschnitt Systemobjekt des Anzeigequerschnitt
	 * @param typ Anzeigetyp des Anzeigequerschnitts
	 */
	public AnzeigeQuerschnittMitTyp (SystemObject anzeigeQuerschnitt, EAnzeigeQuerschnittTyp typ)
	{
		_anzeigeQuerschnitt = anzeigeQuerschnitt;
		
		_typ = typ;
	}
	
	/**
   * Methode liefert anzeigeQuerschnitt zurck
   * @return anzeigeQuerschnitt
   */
  public SystemObject getAnzeigeQuerschnitt()
  {
  	return _anzeigeQuerschnitt;
  }

	/**
   * Methode setzt die Variable anzeigeQuerschnitt
   * @param anzeigeQuerschnitt zu bernehmender Wert fr anzeigeQuerschnitt
   */
  public void setAnzeigeQuerschnitt(SystemObject anzeigeQuerschnitt)
  {
  	_anzeigeQuerschnitt = anzeigeQuerschnitt;
  }

	/**
   * Methode liefert typ zurck
   * @return typ
   */
  public EAnzeigeQuerschnittTyp getTyp()
  {
  	return _typ;
  }

	/**
   * Methode setzt die Variable typ
   * @param typ zu bernehmender Wert fr typ
   */
  public void setTyp(EAnzeigeQuerschnittTyp typ)
  {
  	_typ = typ;
  }

	/* (non-Javadoc)
   * @see java.lang.Object#toString()
   */
  @Override
  public String toString()
  {
	  return _anzeigeQuerschnitt.getName() + " (" + getTyp().getName() + ")";
  }

  /**
   * Methode liefert eine Kopie der Instanz
   * @return Kopie der Instanz
   */
  public AnzeigeQuerschnittMitTyp getCopy ()
  {
  	return new AnzeigeQuerschnittMitTyp (getAnzeigeQuerschnitt(), getTyp());
  }
}
