package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.bedienung;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.AnzeigeQuerschnittMitTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.EAnzeigeQuerschnittTyp;

public class CompositeZuordnungMitTypAuswahl extends CompositeZuordnung
{
	private Combo _combo;
	private Button _buttonTypUebernehmen;

	public CompositeZuordnungMitTypAuswahl(Composite parent, int style)
  {
	  super(parent, style);
  }

	public CompositeZuordnungMitTypAuswahl(Composite parent, int style, String textLinks, String textRechts)
	{
		super(parent, style, textLinks, textRechts);
	}

	
	@Override
  protected void createCompositeZugewieseneObjekte (Composite parent)
  {
  	super.createCompositeZugewieseneObjekte(parent);
  	
  	createCompositeTyp(parent);
  }

	private void createCompositeTyp (Composite parent)
	{
    /*
     * Combobox mit der Auswahlmglichkeit der Anzeigetypen
     */
    
		GridData gdTextItem = new GridData();
		gdTextItem.horizontalAlignment = GridData.FILL;
		gdTextItem.grabExcessHorizontalSpace = true;
		gdTextItem.verticalAlignment = GridData.BEGINNING;

		GridData gdComboItem = new GridData();
		gdComboItem.horizontalAlignment = GridData.FILL;

		Label dummy = new Label(parent, SWT.LEFT);
		dummy.setText("Anzeigetyp");
		dummy.setLayoutData(gdTextItem);

		_combo = new Combo(parent, SWT.BORDER);
		_combo.setLayoutData(gdComboItem);

		int anzahl = EAnzeigeQuerschnittTyp.values().length;
		
		String[] sa = new String[anzahl];
		for (int j = 0; j < anzahl; ++j)
			sa[j] = EAnzeigeQuerschnittTyp.values()[j].getName();

		_combo.setItems(sa);
		_combo.select(0);
		
		_buttonTypUebernehmen = new Button(parent, SWT.NONE);
		
		_buttonTypUebernehmen.setText("Anzeigetyp bernehmen");
		
		_buttonTypUebernehmen.setEnabled(false);
		_combo.setEnabled(false);
	}

	/**
   * Methode liefert combo zurck
   * @return combo
   */
  public Combo getCombo()
  {
  	return _combo;
  }

	/**
   * Methode liefert buttonTypUebernehmen zurck
   * @return buttonTypUebernehmen
   */
  public Button getButtonTypUebernehmen()
  {
  	return _buttonTypUebernehmen;
  }
  
	@Override
	protected void selektionRechts ()
	{
    super.selektionRechts();
    
    int anzahl = getSelectedObjekteRechts().size();
    
    _buttonTypUebernehmen.setEnabled(anzahl > 0);
    _combo.setEnabled(anzahl > 0);

    if (anzahl > 0)
    {
    	AnzeigeQuerschnittMitTyp aqmt = (AnzeigeQuerschnittMitTyp) getSelectedObjekteRechts().get(0);
    	
    	EAnzeigeQuerschnittTyp typ = aqmt.getTyp();
    	
    	selektiereTyp (typ);
    }
	}
	
  protected void selektiereTyp(EAnzeigeQuerschnittTyp typ)
  {
  	int index = -1;
  	
  	for (int i=0; i<EAnzeigeQuerschnittTyp.values().length; ++i)
  		if (EAnzeigeQuerschnittTyp.values()[i] == typ)
  			index = i;
  	
  	_combo.select(index);
  }
}
