package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.zusammenfassungEnde;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Vector;

import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeElementFigure;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeInhaltTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

/**
 * Klasse zum Erzeugen der Defaultwerte fr die Regel "Zusqammenfassung Aufhebung"
 * @author ObertM
 *
 */
public class DefaultWerte
{
	/**
   * Methode generiert automatisch die Defaultwerte
   */
  public Vector<RegelZusammenfassungEnde> getDefaultWerte (int anzBilderProZeile)
  {
  	List<AnzeigeInhaltTyp> ende = Arrays.asList(
  				AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_40,
  				AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_50,
  				AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_60,
  				AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_80,
  				AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_100,
  				AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_120,
  				AnzeigeInhaltTyp.TLS_ENDE_ZULAESSIGE_HOECHST_130,
  				AnzeigeInhaltTyp.TLS_ENDE_ALLER_STRECKENVERBOTE,
  				AnzeigeInhaltTyp.TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN,
  				AnzeigeInhaltTyp.TLS_ENDE_UEBERHOLVERBOT_LKW);

	  VerwaltungWvzInhalte verw = VerwaltungWvzInhalte.getInstance();

	  // Vorhandene Inhalte fr Typ A bestimmen
	  
  	List<WVZInhalt> inhaltA = new ArrayList<WVZInhalt>();
  	List<AnzeigeInhaltTyp> vorhandenA = AnzeigeElementFigure.createAnzeigeInhalte(AnzeigeElementTyp.WZG_A);
  	for (AnzeigeInhaltTyp ait : ende)
  		if (vorhandenA.contains(ait))
  			inhaltA.add(verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, ait ));

	  // Vorhandene Inhalte fr Typ B bestimmen
	  
  	List<WVZInhalt> inhaltB = new ArrayList<WVZInhalt>();
  	List<AnzeigeInhaltTyp> vorhandenB = AnzeigeElementFigure.createAnzeigeInhalte(AnzeigeElementTyp.WZG_B);
  	for (AnzeigeInhaltTyp ait : ende)
  		if (vorhandenB.contains(ait))
  			inhaltB.add(verw.getWvzInhalt(AnzeigeElementTyp.WZG_B, ait ));

		Vector<RegelZusammenfassungEnde> regeln = new Vector<RegelZusammenfassungEnde>();
		
		RegelZusammenfassungEnde r = new RegelZusammenfassungEnde();
		
  	Aspect schaltgrund = VerwaltungParaZusammenfassungEnde.getInstance().getSchaltgrundAllgemein();

		// zu schaltenden Inhalt bestimmen
		
		WVZInhalt angeforderterInhaltA = null;
		WVZInhalt angeforderterInhaltB = null;
		
		AnzeigeInhaltTyp vz282       = AnzeigeInhaltTyp.TLS_ENDE_ALLER_STRECKENVERBOTE;
		AnzeigeInhaltTyp dunkelHP    = AnzeigeInhaltTyp.DUNKEL_HP;
		AnzeigeInhaltTyp dunkel      = AnzeigeInhaltTyp.DUNKEL;
		
		int prioA = -1;
		int prioB = -1;
		
		// Prfen ob Typ A oder Typ B das VZ 282 enthlt
		
		if (vorhandenA.contains(vz282))
		{
			angeforderterInhaltA = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, vz282 );
			
			angeforderterInhaltB = verw.getWvzInhalt(AnzeigeElementTyp.WZG_B, dunkelHP );
			if (angeforderterInhaltB == null)
			{
				angeforderterInhaltB = verw.getWvzInhalt(AnzeigeElementTyp.WZG_B, dunkel );
				prioB = 500;
			}
		}
		else if (vorhandenB.contains(vz282))
		{
			angeforderterInhaltA = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, dunkelHP );
			if (angeforderterInhaltA == null)
			{
				angeforderterInhaltA = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, dunkel );
				prioB = 500;
			}
			
			angeforderterInhaltB = verw.getWvzInhalt(AnzeigeElementTyp.WZG_B, vz282 );
		}
		
		/*
		 * Zur Sichwerheit fr den unwahrscheinlichen Fall, dass kein VZ 282 definiert ist
		 */
		if (angeforderterInhaltA != null)
		{
			r.setSchaltgrundRegel(schaltgrund);
	  	r.setAnzeigenInhaltA(inhaltA);
	  	r.setAnzeigenInhaltB(inhaltB);
	  	r.setAngeforderterInhaltA(angeforderterInhaltA);
	  	r.setAngeforderterInhaltB(angeforderterInhaltB);
	  	r.setPrioritaetA(prioA);
	  	r.setPrioritaetB(prioB);
	
			regeln.add(r);
		}
		
		return regeln;
  }
}
