package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.steuerungskern;

import java.util.Vector;

/**
 * Klasse speichert einen Parametersatz "Iterationen"
 * @author ObertM
 */
public class ParaIterationen
{
	/**
	 * Instanzen fr die der Wert gilt
	 */
  private Vector<String> _instanzen = new Vector<String>();
  
  /**
   * Anzahl Iterationen
   */
  private long _anzIterationen;
  
  /**
   * Konstruktor der Klasse
   * @param instanzen Instanzen fr die der Parameter gilt
   * @param anzIterationen Anzahl Iterationen
   */
  public ParaIterationen (Vector<String> instanzen, long anzIterationen)
  {
    _instanzen = instanzen;
    
    _anzIterationen = anzIterationen;
  }

  /**
   * Konstruktor der Klasse
   * @param instanz Instanz fr die der Parameter gilt
   * @param anzIterationen Anzahl Iterationen
   */
	public ParaIterationen(String instanz, long anzIterationen)
  {
		_instanzen.add(instanz);
		
		_anzIterationen = anzIterationen;
  }

	/**
   * Methode liefert instanzen zurck
   * @return instanzen
   */
  public Vector<String> getInstanzen()
  {
  	return _instanzen;
  }

	/**
   * Methode setzt die Variable instanzen
   * @param instanzen zu bernehmender Wert fr instanzen
   */
  public void setInstanzen(Vector<String> instanzen)
  {
  	_instanzen = instanzen;
  }

	/**
   * Methode liefert anzIterationen zurck
   * @return anzIterationen
   */
  public long getAnzIterationen()
  {
  	return _anzIterationen;
  }

	/**
   * Methode setzt die Variable anzIterationen
   * @param anzIterationen zu bernehmender Wert fr anzIterationen
   */
  public void setAnzIterationen(long anzIterationen)
  {
  	_anzIterationen = anzIterationen;
  }

}
