package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.vorgaengerNachfolger;

import de.bsvrz.dav.daf.main.Data;

/**
 * Klasse speichert die Vorgnger und Nachfolger einer Anzeige
 * @author       Dambach Werke GmbH
 */
public class VorgaengerNachfolger
{
  /**
   * Vorgnger/Nachfolger in Querrichtung
   */
  private NachbarAnzeigen m_querRichtung = new NachbarAnzeigen();

  /**
   * Vorgnger/Nachfolger in Lngsrichtung
   */
  private NachbarAnzeigen m_laengsRichtung = new NachbarAnzeigen();

  /**
   * Methode liefert die Variable querRichtung zurck
   * @return Variable querRichtung
   */
  public NachbarAnzeigen getQuerRichtung()
  {
    return m_querRichtung;
  }

  /**
   * Methode liefert eine Kopie der Instanz
   * @return Kopie der Instanz
   */
  public VorgaengerNachfolger getKopie()
  {
    VorgaengerNachfolger kopie = new VorgaengerNachfolger();
    
    kopie.setLaengsRichtung( getLaengsRichtung().getKopie() );
    kopie.setQuerRichtung  ( getQuerRichtung().getKopie() );
    
    return kopie;
  }

  /**
   * Methode setzt die Variable querRichtung
   * @param querRichtung Wert fr querRichtung
   */
  public void setQuerRichtung(NachbarAnzeigen querRichtung)
  {
    m_querRichtung = querRichtung;
  }

  /**
   * Methode liefert die Variable laengsRichtung zurck
   * @return Variable laengsRichtung
   */
  public NachbarAnzeigen getLaengsRichtung()
  {
    return m_laengsRichtung;
  }

  /**
   * Methode setzt die Variable laengsRichtung
   * @param laengsRichtung Wert fr laengsRichtung
   */
  public void setLaengsRichtung(NachbarAnzeigen laengsRichtung)
  {
    m_laengsRichtung = laengsRichtung;
  }
  
  /**
   * Methode zum Auswerten der Attributgruppe 'atg.sswSbaVorgngerNachfolgerBeziehung'
   * @param data empfangender Datensatz
   */
  public void auswerteAttributgruppe( Data data )
  {
    Data laengsRichtung = data.getItem( "Lngsrichtung" );
    m_laengsRichtung = new NachbarAnzeigen();
    m_laengsRichtung.auswerteAttributgruppe( laengsRichtung );
    
    Data querRichtung = data.getItem( "Querrichtung" );
    m_querRichtung = new NachbarAnzeigen();
    m_querRichtung.auswerteAttributgruppe( querRichtung );
  }
  
  /**
   * Methode liefert den Inhalt der Klasse als String
   */
  public String toString ()
  {
    String s = "";

    s += "Querrichtung:\n";
    s += "=============\n";
    s += m_querRichtung.toString();
    
    s += "Lngsrichtung\n";
    s += "=============\n";
    s += m_laengsRichtung.toString();
    
    return s;
  }
}

