package de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen;

/**
 * Definition der mglichen Anzeigetypen
 * @author ObertM
 */
public enum EAnzeigeTypen
{
  TYP_WZG_A (1),
  TYP_WZG_B (2),
  TYP_WZG_C (3),
  TYP_WZG_D (4),
  TYP_WZG_E (5),
  
  TYP_WZG_A1 (6),
  TYP_WZG_B1 (7),
  TYP_WZG_C1 (8),
  TYP_WZG_D1 (9),
  TYP_WZG_E1 (10),

  TYP_WZG_A2 (11),
  TYP_WZG_B2 (12),
  TYP_WZG_C2 (13),
  TYP_WZG_D2 (14),
  TYP_WZG_E2 (15),

  TYP_BAQ (16),
  TYP_TAQ (17),
  TYP_WAQ (18),
    
  TYP_BLINKER (19),
  
  TYP_FAIL_SAFE_A (20),
  TYP_FAIL_SAFE_B (21),
  
  TYP_INFO_A (22),
  TYP_INFO_B (23),
  
  TYP_BAG (24),
  ;
  
  /**
   * Kodierung des Typs im DaV
   */
  private int _kodieerungImDaV;
  
  /**
   * Konstruktor
   * @param kodierung Kodierung im DaV
   */
  private EAnzeigeTypen(int kodierung)
  {
  	_kodieerungImDaV = kodierung;
  }
  
  /**
   * Methode liefert den Typ zu einer Kodierung
   * @param kodierung Kodierung
   * @return Typ
   */
  public static EAnzeigeTypen getTyp (int kodierung)
  {
  	for (EAnzeigeTypen typ : values())
  		if (typ.getKodieerungImDaV() == kodierung)
  			return typ;
  	
  	return null;
  }

	/**
   * Methode liefert kodieerungImDaV zurck
   * @return kodieerungImDaV
   */
  public int getKodieerungImDaV()
  {
  	return _kodieerungImDaV;
  }
}
