package de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.sba.plugin.parameter.steuerungskern.Activator;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.Konfig;
import de.bsvrz.sba.plugin.parameter.steuerungskern.tools.Tools;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * View ermglicht die Auswahl von Anzeigequerschnitten
 * @author ObertM
 *
 */
public class ViewAuswahlAnzeigen extends ViewPart
{
  public static String ID = "de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein.ViewAuswahlAnzeigen";

  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();
  
  /**
   * Parent Compisite
   */
  private Composite _parent;
  
  /**
   * Oberes Composite
   */
  private Composite compositeTop;

  private Group _gruppeUebersicht;

  private Table _tabelleKmdPar;

  private TableViewer _tableViewerKmdPar;

  private ISelectionChangedListener _selectionChangedListener;

  private Composite compositeBottom;

  private Button buttonOk;

  private Button buttonAbbrechen;

//  private int _numViewInstances = 0;

  private ClientDavInterface _connection;

  private Button buttonHilfe;

  protected List<SystemObject> m_angewaehlteObjekte;

	private String _secondViewId;

  public List<SystemObject> getAngewaehlteObjekte()
  {
    return m_angewaehlteObjekte;
  }

  @Override
  public void createPartControl(Composite parent)
  {
    _parent = parent;

    this.setPartName("Auswahl Anzeigen " + _secondViewId);

    //Fr die F1 Taste
    
    PlatformUI.getWorkbench().getHelpSystem().setHelp( _parent, Activator.PLUGIN_ID + ".auswahl" );

    _parent.setLayout(new GridLayout());
    createCompositeTop(_parent);
    createCompositeBottom(_parent);
    
    _connection = DaVVerbindung.getInstanz().getDaVVerbindung();

    bestimmeAnzeigen();
  }

  private void bestimmeAnzeigen ()
  {
		List<SystemObject> objekte = Konfig.getInstance().getAnzeigen();

    Map<String, SystemObject> treeMap = new TreeMap<String, SystemObject>();
    for (SystemObject so : objekte)
      treeMap.put(so.getName(), so);

    List<Modell> sortList = new ArrayList<Modell>();
    
    for (SystemObject so : treeMap.values())
    {
    	boolean versorgt = OpenVersorgungsViews.isParameterFuerAnzeigeVersorgt(_secondViewId, so);
    	sortList.add(new Modell (so, versorgt));
    }
    
    _tableViewerKmdPar.setInput(sortList);
  }

  @Override
  public void setFocus()
  {
    if (_parent != null)
      _parent.setFocus();
    
    bestimmeAnzeigen();
  }

  /**
   * Erzeugt gruppeUebersicht
   * 
   */
  private void createCompositeTop(Composite parent)
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessVerticalSpace = true;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.FILL;
    compositeTop = new Composite(parent, SWT.NONE);
    compositeTop.setLayout(new GridLayout());
    compositeTop.setLayoutData(gridData);
    GridData gridDataTabelle = new GridData();
    gridDataTabelle.horizontalAlignment = GridData.FILL;
    gridDataTabelle.grabExcessHorizontalSpace = true;
    gridDataTabelle.grabExcessVerticalSpace = true;
    gridDataTabelle.verticalAlignment = GridData.FILL;
    GridData gridDataGruppeUebersicht = new GridData();
    gridDataGruppeUebersicht.horizontalAlignment = GridData.FILL;
    gridDataGruppeUebersicht.grabExcessHorizontalSpace = true;
    gridDataGruppeUebersicht.grabExcessVerticalSpace = true;
    gridDataGruppeUebersicht.verticalAlignment = GridData.FILL;
    _gruppeUebersicht = new Group(compositeTop, SWT.NONE);
    _gruppeUebersicht.setLayout(new GridLayout());
    _gruppeUebersicht.setLayoutData(gridDataGruppeUebersicht);
    _gruppeUebersicht.setText("Auswahl Anzeigen:");
    _tabelleKmdPar = new Table(_gruppeUebersicht, SWT.BORDER | SWT.MULTI | SWT.FULL_SELECTION);
    _tabelleKmdPar.setHeaderVisible(true);
    _tabelleKmdPar.setLayoutData(gridDataTabelle);
    _tabelleKmdPar.setLinesVisible(true);
    _tableViewerKmdPar = new TableViewer(_tabelleKmdPar);
    // _tableViewerKmdPar = new CheckboxTableViewer(_tabelleKmdPar);

    TableColumn tcVersorgt = new TableColumn(_tabelleKmdPar, SWT.LEFT);
    tcVersorgt.setText("Versorgt:");
    tcVersorgt.setWidth(60);
   
    TableColumn tcKey = new TableColumn(_tabelleKmdPar, SWT.LEFT);
    tcKey.setText("Name:");
    tcKey.setWidth(300);

//    TableColumn tcValue = new TableColumn(_tabelleKmdPar, SWT.LEFT);
//    tcValue.setText("Pid:");
//    tcValue.setWidth(320);

    _tableViewerKmdPar.setContentProvider(new ContentProvider());
    _tableViewerKmdPar.setLabelProvider(new LabelProvider());

    _selectionChangedListener = new ISelectionChangedListener() {
          public void selectionChanged(SelectionChangedEvent event)
      {
        IStructuredSelection selection = (IStructuredSelection)event.getSelection();
        Object firstElement = selection.getFirstElement();

        if (firstElement instanceof SystemObject)
        {

        }
      }

    };
    _tableViewerKmdPar.addSelectionChangedListener(_selectionChangedListener);
    _tableViewerKmdPar.addDoubleClickListener(new IDoubleClickListener() {

      @Override
      public void doubleClick(DoubleClickEvent event)
      {
        openViewParameterVerdopplung();       
      }
    });
  }
  
  /**
   * Methode liefert die angewhlten Objekte zurck
   * @return angewhlte Objekte
   */
  private List<SystemObject> bestimmeAngewaehlteObjekte ()
  {
    List<SystemObject> listKBA = new ArrayList<SystemObject>();
    
    IStructuredSelection selection = (IStructuredSelection)_tableViewerKmdPar.getSelection();
    
    Object firstElement = selection.getFirstElement();
    if (firstElement instanceof SystemObject)
    {      
      Object[] array = selection.toArray();
      for (Object object : array)
      {
        SystemObject so = (SystemObject)object;
        listKBA.add(so);          
      }
    }
    
    return listKBA;
  }
  
  private void openViewParameterVerdopplung ()
  {
    IStructuredSelection selection = (IStructuredSelection)_tableViewerKmdPar.getSelection();
    
    Object firstElement = selection.getFirstElement();
    if (firstElement instanceof Modell)
    {      
      Object[] array = selection.toArray();
      List<SystemObject> listKBA = new ArrayList<SystemObject>();
       
      for (Object object : array)
      {
        SystemObject so = ((Modell)object).getObjekt();
        listKBA.add(so);          
      }
      
      IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
      IWorkbenchPage page = dw.getActivePage();
      
      if (listKBA.size() > 0)
      {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < listKBA.size(); i++)
        {
          SystemObject so = listKBA.get(i);
          if (i<listKBA.size()-1)
            sb.append(so.getPid() + ";");
          else
            sb.append(so.getPid());
        }

        OpenVersorgungsViews.openView(_secondViewId, sb.toString());
      }        
    }
  }

  private void createCompositeBottom(Composite parent)
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    compositeBottom = new Composite(parent, SWT.NONE);
    compositeBottom.setLayoutData(gridData3);
    compositeBottom.setLayout(rowLayout);
    buttonOk = new Button(compositeBottom, SWT.NONE);
    buttonOk.setText("Ok");
    buttonOk.addMouseListener(new MouseAdapter() {


      @Override
      public void mouseDown(MouseEvent e)
      {
         openViewParameterVerdopplung();      
      }
    });

    buttonAbbrechen = new Button(compositeBottom, SWT.NONE);
    buttonAbbrechen.setText("Abbrechen");
    buttonAbbrechen.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {
        super.mouseDown(e);
        aktionAbbrechen();
      }

    });
    
    buttonHilfe = new Button(compositeBottom, SWT.NONE);
    buttonHilfe.setText("Hilfe");
    buttonHilfe.addMouseListener(new MouseAdapter() {

      @Override
      public void mouseDown(MouseEvent e)
      {
        super.mouseDown(e);
        aktionHilfe();
      }

    });
  }

  protected void aktionAbbrechen()
  {
    PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().hideView(this);
  }

  /**
   * Zeigt die Hilfe zum Dialog an.
   * 
   */
  protected void aktionHilfe()
  {
    String contextId = Activator.PLUGIN_ID + ".auswahl";
    _debug.fine("ContextID: " + contextId);
    
    PlatformUI.getWorkbench().getHelpSystem().displayHelp(contextId);
  }

  private class ContentProvider implements IStructuredContentProvider
  {
    @Override
    public Object[] getElements(Object inputElement)
    {
      List list = (List)inputElement;

      Object[] re = new Object[list.size()];

      for (int i = 0; i < list.size(); i++)
      {
        re[i] = list.get(i);
      }
      return re;
    }

    @Override
    public void dispose()
    {
    }

    @Override
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {
    }

  }

  private class LabelProvider implements ITableLabelProvider
  {

    @Override
    public Image getColumnImage(Object element, int columnIndex)
    {
      return null;
    }

    @Override
    public String getColumnText(Object element, int columnIndex)
    {

      // String[] ss = (String[])element;

      String returnString = null;

      switch (columnIndex)
      {
      case 0:
      	
      	if (((Modell)element).isVersorgt())
      		returnString = "*";
      	else
      		returnString = "";
      		
        break;

      case 1:
        returnString = ((Modell)element).getObjekt().getName();
        break;

      case 2:
        returnString = ((Modell)element).getObjekt().getPid();
        break;

        default:
          returnString = "default";
      }

      return returnString;

    }

    @Override
    public void addListener(ILabelProviderListener listener)
    {
    }

    @Override
    public void dispose()
    {
    }

    @Override
    public boolean isLabelProperty(Object element, String property)
    {
      return false;
    }

    @Override
    public void removeListener(ILabelProviderListener listener)
    {
    }

  }

  @Override
  public void init( IViewSite site, IMemento memento ) throws PartInitException
  {
    _secondViewId = site.getSecondaryId();
    super.init( site, memento );
  }

  /**
   * Modell fr Tabelle
   * @author ObertM
   */
  private class Modell 
  {
  	SystemObject _objekt;
  	
  	boolean _versorgt = false;
  	
  	public Modell (SystemObject objekt, boolean versorgt)
  	{
  	  _objekt = objekt;
  	  
  	  _versorgt = versorgt;
  	}

		/**
     * Methode liefert objekt zurck
     * @return objekt
     */
    public SystemObject getObjekt()
    {
    	return _objekt;
    }

		/**
     * Methode setzt die Variable objekt
     * @param objekt zu bernehmender Wert fr objekt
     */
    public void setObjekt(SystemObject objekt)
    {
    	_objekt = objekt;
    }

		/**
     * Methode liefert versorgt zurck
     * @return versorgt
     */
    public boolean isVersorgt()
    {
    	return _versorgt;
    }

		/**
     * Methode setzt die Variable versorgt
     * @param versorgt zu bernehmender Wert fr versorgt
     */
    public void setVersorgt(boolean versorgt)
    {
    	_versorgt = versorgt;
    }
  }
}
