package de.bsvrz.sba.plugin.zlt.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.sba.plugin.zlt.views.ViewZltProgrammaktivierung;

/**
 * ffnet die bersicht der Programmaktivierung.
 * 
 * @author Swarco Traffic Systems GmbH
 * 
 */
public class ActionOpenProgrammaktivierung
		implements
			IWorkbenchWindowActionDelegate
{

	@Override
	public void dispose()
	{
	}

	@Override
	public void init(IWorkbenchWindow window)
	{
	}

	@Override
	public void run(IAction action)
	{
		IWorkbenchWindow window = PlatformUI.getWorkbench()
				.getActiveWorkbenchWindow();

		IViewPart showView;
		try
		{
			showView = window.getActivePage().showView(
					ViewZltProgrammaktivierung.VIEW_ID,
					ViewZltProgrammaktivierung.VIEW_KIND_NORMAL,
					IWorkbenchPage.VIEW_VISIBLE);
			if (showView instanceof ViewZltProgrammaktivierung)
			{

				IViewPart viewZltProgrammaktivierung = (ViewZltProgrammaktivierung) showView;
				window.getActivePage().activate(viewZltProgrammaktivierung);
			}
		} catch (PartInitException e)
		{
			e.printStackTrace();
		}

	}

	@Override
	public void selectionChanged(IAction action, ISelection selection)
	{
	}

}
