package de.koelnloevenich.dif.basislib.urlasserdialog;

import de.bsvrz.buv.rw.rw.dav.BenutzerAngemeldet;

/**
 * Klasse die die Daten zur Vorbelegung des Urlasser-Dialoges erzeugt.
 * 
 * @author Pittner
 * 
 */
public class UrlasserFactory
{
  
  /**
   * Singleton-Instanz
   */
  private static UrlasserFactory _instanz = null;
  
  /**
   * Singleton-Instanz
   */
  private UrlasserInfo _info = null;


  /**
   * Liefert die Singletoninstanz.
   * 
   * @return Instanz dieser Klasse.
   */
  public static UrlasserFactory getInstanz()
  {
    if (_instanz == null)
    {
      _instanz = new UrlasserFactory();
    }
    return _instanz;
  }

  /**
   * Konstruktor der Klasse
   */
  private UrlasserFactory()
  {
//    System.out.println("UrlasserFactory.UrlasserFactory()");
    try {
      _info = new UrlasserInfo(BenutzerAngemeldet.getInstanz().getName(), "", "", "");
    }
    catch (Exception e) {
      _info = new UrlasserInfo("", "", "", "");  
    }
  }
  
  public UrlasserInfo getInfo()
  {
    return _info;
  }

  public void setInfo(UrlasserInfo info)
  {
    _info = info;
  }
  
}