/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dav;

import de.koelnloevenich.dif.basislib.urlasserdialog.UrlasserDialog.UrlasserDialogInfo;

//import de.bsvrz.buv.rw.basislib.login.UrlasserDialog;
//import de.bsvrz.buv.rw.basislib.login.UrlasserDialog.UrlasserDialogInfo;

/**
 * Verpackt die {@link UrlasserDialogInfo} eines Datenversandes via
 * {@link UrlasserDialog} zusammen mit weiteren frei zu setzenden Informationen.
 * 
 * @author HofmannJ
 * 
 */
public class WrapperULDInfo
{
	/**
	 * Liefert die Information, unter welchen Bedingungen die Daten Verschickt
	 * wurden und ob OK oder Abbrechen geklickt wurde.
	 */
	private UrlasserDialogInfo _uldInfo = null;

	/**
	 * Nimmt sonstige Informationen auf.
	 */
	private String _fehlerInfo = null;

	/**
	 * Konstruktor fr den Wrapper.
	 * 
	 * @param urlasserDialogInfo
	 *          Die vom {@link UrlasserDialog} gelieferte
	 *          {@link UrlasserDialogInfo}.
	 * @param fehlerInfo
	 *          Sonstige FehlerInfos.
	 */
	public WrapperULDInfo(UrlasserDialogInfo urlasserDialogInfo, String fehlerInfo)
	{
		this._uldInfo = urlasserDialogInfo;
		this._fehlerInfo = fehlerInfo;
	}

	/**
	 * Die vom {@link UrlasserDialog} gelieferte {@link UrlasserDialogInfo}.
	 * 
	 * @return
	 */
	public UrlasserDialogInfo getUldInfo()
	{
		return _uldInfo;
	}

	/**
	 * Sonstige freie Infos.
	 * 
	 * @return
	 */
	public String getFehlerInfo()
	{
		return _fehlerInfo;
	}

}
