/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dlg;

import org.eclipse.ui.IPerspectiveDescriptor;
import org.eclipse.ui.IPerspectiveListener4;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPartReference;
import org.eclipse.ui.PlatformUI;

public class TestPerspectiveListener implements IPerspectiveListener4
{
	public TestPerspectiveListener()
	{
		PlatformUI.getWorkbench().getActiveWorkbenchWindow()
				.addPerspectiveListener(this);
		System.out
				.println("=> TestPerspectiveListener wurde am Workbenchwindow registriert.");
	}
	
	public static String getInfos(IPerspectiveDescriptor perspective)
	{
		StringBuffer sb = new StringBuffer();
		
		if(perspective!=null){
		sb.append("-> Perspective Label=");
		sb.append(perspective.getLabel());
		sb.append(", ID=");
		sb.append(perspective.getLabel());
		}
		
		return sb.toString();
	}

	@Override
	public void perspectivePreDeactivate(IWorkbenchPage page,
			IPerspectiveDescriptor perspective)
	{
		System.out.println("=> perspectivePreDeactivate");
		System.out.println("\t" + getInfos(perspective));
	}

	@Override
	public void perspectiveClosed(IWorkbenchPage page,
			IPerspectiveDescriptor perspective)
	{
		// TODO Auto-generated method stub

	}

	@Override
	public void perspectiveDeactivated(IWorkbenchPage page,
			IPerspectiveDescriptor perspective)
	{
		System.out.println("=> perspectiveDeactivated");
		System.out.println("\t" + getInfos(perspective));

	}

	@Override
	public void perspectiveOpened(IWorkbenchPage page,
			IPerspectiveDescriptor perspective)
	{
		// TODO Auto-generated method stub

	}

	@Override
	public void perspectiveSavedAs(IWorkbenchPage page,
			IPerspectiveDescriptor oldPerspective,
			IPerspectiveDescriptor newPerspective)
	{
		// TODO Auto-generated method stub

	}

	@Override
	public void perspectiveChanged(IWorkbenchPage page,
			IPerspectiveDescriptor perspective, IWorkbenchPartReference partRef,
			String changeId)
	{
		// TODO Auto-generated method stub

	}

	@Override
	public void perspectiveActivated(IWorkbenchPage page,
			IPerspectiveDescriptor perspective)
	{
		System.out.println("=> perspectiveActivated");
		System.out.println("\t" + getInfos(perspective));
	}

	@Override
	public void perspectiveChanged(IWorkbenchPage page,
			IPerspectiveDescriptor perspective, String changeId)
	{
		// TODO Auto-generated method stub

	}

}
